commit 6ddabfd29480a6a526895a578c56bc8051228c15
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Nov 3 11:14:07 2017 -0400

    1.8 release

commit 6a3de54ea0428a33e7039ab7940f38dcfea341ec
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 27 16:39:17 2017 -0400

    TODO: some extra cmdline args

commit 40605158e06cd2e762b421866b0dabb42893fd02
Author: Vince Weaver <vincent.weaver@maine.edu>
Date:   Thu Oct 26 11:18:13 2017 -0400

    perf_event_open: update features to 4.14-rc6
    
    This patch brings perf_event_open() support up to date as of 4.14-rc6.
    
    Signed-off-by: Vince Weaver <vincent.weaver@maine.edu>

commit 31a51156b468798238f9ea4ff180ec3c0edc1ca5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 26 10:21:04 2017 -0400

    update hashes

commit e1b99c67fd3da7a32c40e3bdbc02b03ac6839e1d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 26 10:20:53 2017 -0400

    add new madvise flags

commit 3acf7d3eb577410c24f3f0c418bd8c3cad615aa6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 26 10:19:04 2017 -0400

    add MSG_ZEROCOPY

commit 6485043e0aec90fcd688d5f30192ec0b3f8b6ea3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 26 10:16:38 2017 -0400

    add statx for i386

commit 68362e386dc687b787fd38119d6c58de5960a2c3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 26 10:09:50 2017 -0400

    add SO_ZEROCOPY

commit d4cb8d894ba32d1417ef8eb422515abb64ddf111
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 6 13:58:50 2017 -0400

    ignore possible error codes like ERESTARTSYS
    
    These are usually only seen by libc, and never passed on to apps,
    but Trinity is doing raw syscalls, so we have to worry about these.

commit 14e3dbf95680d9eb9006233d09742be21f5726d8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Sep 23 15:30:53 2017 -0400

    Fix up null ptr deref when no -l arg.

commit 2c49c862df82f311ae4791827542053ce8fe7bad
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 20:16:24 2017 -0400

    add hashcheck use to TODO

commit 72b934fb86f0ee22ed76f7945574575a578aecbf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 20:15:17 2017 -0400

    add a script I use to monitor when the kernel interfaces change

commit e14f62996aeedad94dcccc236ed3937f97e7b04f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 20:13:31 2017 -0400

    update the TODO some.
    
    Still needs some cleanup, but this is a braindump of my private TODO
    that has a mix of old/new stuff.

commit 91cc68ac824f3906c93c50e2d2e225d9ca848083
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 14:28:29 2017 -0400

    update some documentation regarding logging

commit 838860d593cc889471fa5ceedf8d8974f9e926c7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 14:24:49 2017 -0400

    remove logfiles_opened
    
    This seems unnecessary now

commit f243759cc7fd46338a533fec6a2e848a83596850
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 14:23:57 2017 -0400

    make output() aware that LOGGING_UDP is a thing
    
    This section only matters for LOGGING_FILES, so wrap it in an if.

commit e75c83b705d8af29ac970196ae75c9b37e3cd9c7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 14:21:40 2017 -0400

    remove duplicate LOGGING_DISABLED checks
    
    These all happen a layer above

commit 4ff08f2eb56afdd82ff798bfce8e0fb38f4589cb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 18 14:16:41 2017 -0400

    fix the case where -l is passed a directory.
    
    Did this ever work ? It was supposed to, so now it does.

commit 13856316c2597dd04af10688335dd960f86d4809
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Sep 9 17:00:08 2017 -0400

    reinstate the log-to-file code for now.
    
    The log-to-udp code isn't ready for primetime, and logging to file still
    has its occasional uses, so bring it back for the upcoming release.

commit b4a52de7b7f78cebe9e8bc648185a25c43aa4ab3
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Sep 7 14:14:11 2017 +0200

    mips: add n32 and 64 ABIs
    
    MIPS has a different set of syscalls for n32 and 64-bit ABIs.
    They are placed in a different order and start from a different offset,
    so add new syscall tables for these ABIs and define SYSCALL_OFFSET
    appropriately.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 4b8700f780a3b6279ec4ff089e0d316358c8efe1
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Sep 7 14:14:10 2017 +0200

    mips[o32]: add missing syscalls
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit fd315d63fabfe0d54b232de114e2443e6fa054e0
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Sep 7 14:14:09 2017 +0200

    syscalls-mips: split header
    
    In preparation for adding support for other MIPS ABIs move the syscalls
    array from a common mips header to an ABI-specific one.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit ebb1229f9e5ba1f5ae8d1d48a326e594ac4d36d1
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Sep 7 14:14:08 2017 +0200

    proto-rds: fix missing includes
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit fc46726b2dbaac67ee08c655c41130c81bfc87d3
Author: Tommi Rantala <tommi.t.rantala@nokia.com>
Date:   Tue Sep 5 14:57:56 2017 +0300

    net/proto-rds.c: rds_setsockopt() stub not needed
    
    The stub function is not needed, and we can #ifdef the whole file.
    
    Signed-off-by: Tommi Rantala <tommi.t.rantala@nokia.com>

commit 76564c44fef45e197167147ef273d3dcd41ca516
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Sep 6 12:08:18 2017 -0400

    output a packet count for debugging

commit c988a3c1d4c7d065b0e3345d050370d86f3d6831
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Fri Aug 25 08:01:30 2017 +0200

    Add SIGILL as a potential child exit signal
    
    It is possible for the child process to terminate with a SIGILL signal.
    As this is currently not handled, the parent process would not properly
    clean up the child's state and will later assume the child is not making
    a progress and attempt to kill it even though it's no longer there.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit eb2491f29f7201af6dc471374d994a5f1e019a85
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Aug 24 09:21:24 2017 +0200

    syscall: ensure a child is not killed with a lock held
    
    When an EXTRA_FORK syscall is executed, there is a race condition
    between the forked child and the parent - one trying to execute
    the syscall and the other trying to kill it after a short delay.
    
    It is therefore possible for the child to be killed while it's
    holding a syscallrecord lock. Prevent this by taking the lock
    before attempting to kill the child.
    
    Theoretically this may lead to a situation when the parent takes
    the lock before the child completes preventing it from updating
    the record state to AFTER and setting the return value. However,
    since this is for an EXTRA_FORK case only where we expect the
    syscall to never return and get replaced by the new process, it
    is not an issue as the post-syscall record update sequence is
    never reached.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit dd22e30cb1911529cccd3d5742c8cf36d46eba0d
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Wed Aug 23 12:26:35 2017 +0200

    Fix version.h generation
    
    The makefile doesn't specify correct dependencies for the version
    header and as a result we may end up compiling sources which
    require the header before the header is generated.
    
    Rewrite the dependencies so that:
    - version.h has a dependency on all of the files that may change it
    - all .c files have an order-only dependency on version.h
    
    An order-only dependency on version.h should be enough for all files,
    as any sources that have a direct dependency on the version.h will
    later use the normal dependencies defined on .d files. Those, however,
    don't exist on the first make run so this extra rule is required.
    
    Finally, update gen-versionh.sh to touch the file even if it hasn't
    changed, so that if any pre-requisites change in a way that trigger
    version.h regeneration, we still update its timestamp to keep make
    happy.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit c9a3dbca2dcb3ca1c35f37e346ad37194b25b825
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:50 2017 +0200

    pathnames: add missing nftw defines
    
    nftw in glibc has a non-standard FTW_ACTIONRETVAL option that allows the
    callback implementation to be more efficient. Add the missing #defines
    to make the current implementation compatible with musl-libc which
    doesn't have the FTW_ACTIONRETVAL extension.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 1ff88c2ec9a15ef9f276e953d1c381a24598cdf9
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:49 2017 +0200

    fix includes
    
    musl-libc is more strict about which headers provide which definitions,
    so add/remove includes where required

commit 009d2c74247e083c148d87e2167fd8d16371b16e
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:48 2017 +0200

    syscalls/select: ensure __NFDBITS is defined
    
    musl-libc doesn't define __NFDBITS and provides a definition of NFDBITS
    instead.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 80ce899b064123e0cb71615f319f62547407c36c
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:47 2017 +0200

    types.h: change __uint32_t -> uint32_t
    
    uint32_t is a standard type definition, so use it instead of __uint32_t
    which is not defined by musl-libc
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit b5300a20070f831b3d2c011d158e5040fe9a1919
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:46 2017 +0200

    replace __WORDSIZE with WORD_BIT
    
    WORD_BIT is defined by the standard and is declared in limits.h
    __WORDSIZE is a libc-internal symbol and should not be used by the
    applications. Moreover, musl-libc doesn't declare it at all.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit c09169b728ecd3d28bdf7bffac6bc09fd7c02910
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:45 2017 +0200

    ipx: make optional
    
    musl-libc doesn't define structures required for ipx support, so make
    the protocol support optional depending on whether the expected header
    exists
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 1d26a9636da436f74a09cb122922f1421dda28f9
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:44 2017 +0200

    change include <sys/termios.h> -> <termios.h>
    
    musl-libc warns about an incorrect include:
      redirecting incorrect #include <sys/termios.h> to <termios.h>
    and indeed accoring to the standard, only termios.h should be included,
    glibc only provides a wrapper when the wrong include is used.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit d60af368897139f36cfb49f4baa03ae253e3296c
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:43 2017 +0200

    ax25: make optional
    
    musl-libc doesn't define structures required for ax25 support, so make
    the protocol support optional depending on whether the expected header
    exists
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 97357adf9bf7a8609231183ea0664c579a568b10
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Tue Aug 22 13:50:42 2017 +0200

    econet: make optional
    
    musl-libc doesn't define structures required for econet support, so make
    the protocol support optional depending on whether the expected header
    exists
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit a121a00c9f3a2866f12d50363ec01ea4893e5a82
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 14 11:16:45 2017 -0400

    add RENAME_WHITEOUT

commit 2ce77d8b298b883836867414fc5d71bf0ae0f548
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Aug 13 17:55:08 2017 -0400

    only Werror on gcc7+

commit 0c0656dcb12e14aa34c5131a85666a5ec7af50f5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 3 15:33:03 2017 -0400

    add tls header

commit f3103c094cff42d96fc4f96e0c11ba030ae71094
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 3 15:32:26 2017 -0400

    beginnings of TCP_ULP support.

commit 070f01bb07631481105704f517918e5bdb755c82
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Aug 3 17:38:48 2017 +0200

    dump_pid_stack: fix uninitialised variable
    
    On first call to getline() 'line' is uninitialised, so while getline
    allocates memory for the line, it will attempt to free an invalid
    pointer.
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 37ae2cceddb7e4cd055b2cf40ad25d57e00c4f80
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 12 17:06:12 2017 -0400

    update netlink protocols

commit fe36cb88567c2638baecc9d11bd3b66e9f93c24d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 12 16:42:16 2017 -0400

    special case tls for TCP_ULP

commit b4a322996a2329a7f30699f647a94a305e074db9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 12 16:33:58 2017 -0400

    update setsockopt options

commit 5ba65ab00420081e118580b95bf557eab163b822
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 12 16:29:32 2017 -0400

    add new TCP setsockopts

commit 1d9af9d07ae111c253c92112fb50000adac47a0c
Author: Marcin Nowakowski <marcin.nowakowski@imgtec.com>
Date:   Thu Jun 29 12:24:10 2017 +0200

    get_syscall_entry: remove SYSCALL_OFFSET
    
    0-based syscall numbers are used throughout the application and the
    SYSCALL_OFFSET is only added when invoking the syscall. It is therefore
    wrong to substract the offset in get_syscall_entry, as it leads to
    dereferencing array entries at negative offsets and segfaults.
    
    Tested on MIPS32/LE.
    This change effectively reverts cc5108ff ('make get_syscall_entry take
    SYSCALL_OFFSET into account')
    
    Signed-off-by: Marcin Nowakowski <marcin.nowakowski@imgtec.com>

commit 3ed77ef4b51910c1e489863b2240fc435f83a9ef
Author: Tommi Rantala <tommi.t.rantala@nokia.com>
Date:   Wed Jun 21 21:33:58 2017 +0300

    ioctls/vfs.c: FS_IOC_GETFSMAP

commit 059b714aa048b9a693dd0e3840712f025c89b484
Author: Tommi Rantala <tommi.t.rantala@nokia.com>
Date:   Wed Jun 21 21:33:57 2017 +0300

    ioctls/vfs.c: add more ioctls from linux/fs.h
    
    Note that BLKTRACESETUP needs struct blk_user_trace_setup from
    <linux/blktrace_api.h>:
    
      #define BLKTRACESETUP _IOWR(0x12,115,struct blk_user_trace_setup)

commit dd7fc8b44cc8bb8a7e9dc03aa3aa57fbefbf433b
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Tue Jun 20 22:43:01 2017 +0000

    Include sys/io.h for UIO_MAXIOV symbol.
    
    This patch fixes this build error.
    
      CC    net/proto-ipv4.o
    net/proto-ipv4.c: In function ‘ip_setsockopt’:
    net/proto-ipv4.c:231:49: error: ‘UIO_MAXIOV’ undeclared (first use in this function); did you mean ‘_IO_MAGIC’?
       so->optlen = rnd() % sizeof(unsigned long)*(2*UIO_MAXIOV+512);
                                                     ^~~~~~~~~~
                                                     _IO_MAGIC
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit ad849e9720e381f4395fb3efaeb8377ccc869733
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jun 23 15:36:47 2017 -0400

    move the 'are we done' check to the generic child code.

commit 16a42964bfc0fd44610b4365dc79a2e4c057d08d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jun 23 15:35:11 2017 -0400

    make the new seed be sequential (sort of)
    
    Offset it by the number of children, as previous children will have
    already used all the intermediate seeds.

commit 9daca8b001937bb751a718f76f9b5b23836887e7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jun 16 15:46:17 2017 -0400

    remove the syscall-in-subchild code.
    
    I'm not going to pursue this, so might as well drop it entirely.
    
    I had intended to make this a generic thing for execve to opt into,
    but leaving that as its own special case is actually simpler and cleaner

commit d3726b5a45e9d42bf6805d534bfa06923237d797
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 31 02:41:47 2017 -0400

    remove old debug leftover

commit f21c0a62f708688f3df574911525e2b14be01d5e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jun 12 15:21:10 2017 -0400

    reduce the likelyhood that we call expensive syscalls.

commit 033f4a7f5469e47ae3702925215709fba4f9fafc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jun 12 15:15:36 2017 -0400

    mark the sync syscalls as expensive

commit 99208a0df4554b7390528e6ce76abfcb9bef942d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 25 16:39:37 2017 -0400

    replace state machine with simpler drain logic
    
    In its current form, this was too easy to confuse when packets went missing.
    I may resurrect something similar later, but for now, just implement
    a simple plug/drain mutex to dump child queues when a child exits.
    (Other cases still need handling, like segv)

commit 9c6fbfde24c08accbbb6bbae91783b564633c664
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 25 14:14:28 2017 -0400

    fix up cppcheck signedness warnings

commit 8ca29875934ea84b23f56cb6b93fc0c639a8ec6a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 25 14:12:39 2017 -0400

    drop duplicate packets instead of adding them to the list.

commit 005a7ba3e6d034acfb5cb75499c998e962fa0bea
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 25 14:10:47 2017 -0400

    optimize packet rx list walk
    
    instead of walking the list, first check if it goes at the end.

commit 0f67581d8853950aa727111ab2117909d726872a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 25 14:06:46 2017 -0400

    use a single thread to process all child packets
    
    Having n threads can end up swamping the system, and starving
    the packet recieve thread.

commit 992f1f7366f0d9475e02060a215b3a4e312ef1ec
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 23 15:05:33 2017 -0400

    childhdr is already set at this point.

commit 4f309eb7023bacf6ced0fdfc03df61a0084e92f2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 23 13:19:18 2017 -0400

    maintain a count of packets processed each scan of the child list.

commit 4b0e9db4f73a73b32e5b08b44e9daf80f56673d3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 23 13:10:22 2017 -0400

    only process CHILD_EXITED messages if the opnr is current

commit b94f6c8c1468e150774c9785a33b821711fe3dd1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 22 12:56:33 2017 -0400

    add a flag to mark when we're expecting a spawn message.

commit ff6010c4ac1eb66d3844414cc1ee36e3a9ad66d0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 22 12:49:52 2017 -0400

    add the last op_nr to the childexited message

commit 6c5625fc2ed380ae11e8f8f2655538b29ff87fc3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 22 11:11:23 2017 -0400

    add incoming packets to the correct place in the list.
    
    At this point, 'node' points to the node after where we want to insert.

commit a81fba1701ad9250f91f87c7748940525eaaffa4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 12 14:11:06 2017 -0400

    bump the expected sequence nr if we got a SIGALARM

commit 81b0bc671f8390e18a6f54e527106d0ff6d0fa40
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 12 14:04:25 2017 -0400

    send the SIGALARM message from the child that just received it.

commit d09da5d01d57d8d02dd3ddf4247ab5fc24714db3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 12 13:59:56 2017 -0400

    use pthread_yield rather than sleep

commit 299a83b36e5a0eb3309ec7f2ebeebecf6d1fbe04
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 11 14:35:44 2017 -0400

    log the last operation number a child did when we get a signal

commit e72732e62fd8c54bbcb5398188d84eeee27f9809
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 12 13:56:44 2017 -0400

    copy incoming packet timestamp into the packet header

commit e9e5a43bf6f0157ed6e0af0312bfe4966b221279
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 12 13:56:00 2017 -0400

    maintain a packets pending count
    
    for debugging purposes.

commit f4ab397e6d53c1f32aef343e1fcfe449e6853ba0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 11 00:38:22 2017 -0400

    dump errno if write() to logfile fails

commit e661a26ccd43b75afe0a41eaf8118a8115b1554c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 11 00:35:28 2017 -0400

    more cppcheck cleanups

commit 52a6a136dc92a7381dffdbf5b9df15f2cf0983c9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 17:09:26 2017 -0400

    misc cleanup

commit 8da1609293e425931a06be2777b356d18a99d349
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 17:05:12 2017 -0400

    scope reduction

commit f028b87ee1fc96ac36f39c97447196419f3b076a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 17:02:47 2017 -0400

    detect pid changes in child messages
    
    This has the effect of ordering exit/spawn messages among syscall messages.

commit cf932d75ac241e7ecda78aa02f77286f47282540
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 16:50:34 2017 -0400

    no implied ordering between packets on spawn/exit/signal

commit b46e9cbb601cb27073aaf0de999305052c361b44
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 16:49:36 2017 -0400

    after iterating the child list once, sleep.
    
    This gives other threads a chance to execute, and lets the queue
    build up again

commit 2cf559e85c04d3e08717d0e9f35a0b9ecd541784
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 16:48:11 2017 -0400

    reset the expected sequence number when a child is respawned

commit b10083970d187e20367521e81585d5765a2d4ba2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 16:18:42 2017 -0400

    server side packet ordering.
    
    1. Insert packets into list in order based on timestamps.
    2. Iterate over the child list processing only the packets we expect
    (eg, result follows prep)

commit e4eb4e04cc2aa81cb6d4131290669343a02065a2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 16:12:30 2017 -0400

    only print setsockopt success if it actually succeeded

commit a1771fe6e0cea98f0c2f82a4b09312b0d1b6075f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 15:04:39 2017 -0400

    timestamp all child messages
    
    Move the timestamp out of the syscall record out to the childmsg header.
    This way we can order all child messages more easily

commit 903ca1de9f416030fff74479d1359ae2a6bfff56
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 10 14:18:20 2017 -0400

    timestamp syscall operations.

commit fae03d64591863267371b2c744b8c763282e2111
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 16:28:16 2017 -0400

    tweak socket buffer sizes.
    
    This isn't perfect, but it's a start

commit 87f9df549f21a215fbbe94abdbe130b35e284f43
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 15:12:15 2017 -0400

    print where handshakes came from
    
    (will use the ip in the logdir name later)

commit 84af3eab0295fa0d9ca1026783f9ea6064a575be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 14:18:34 2017 -0400

    remove the 'stash' copy of the syscall rec
    
    as these buffers are going away soon, doing sanity checks on them
    is a waste of time.

commit ad5386a632fbf23708e6c0dfa16b5e0f7b9e1f51
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 13:49:37 2017 -0400

    output decoded packets to logfiles.

commit 9858abf0af7ce953a3843d2b574a6f9bfa9fc355
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 11:22:02 2017 -0400

    move some udp related server functions to their own file

commit 249e75e7cb8aa46d9eca194dd9b3bb86dfce0db5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 10:28:28 2017 -0400

    fix potential use-before-init

commit 85e96c85f3ab4899e09546963226e041a3c128be
Author: Michael Orlitzky <michael@orlitzky.com>
Date:   Sat May 6 08:23:11 2017 -0400

    support user CFLAGS in Makefiles
    
    Our three Makefiles {,server,tools}/Makefile set a bunch of CFLAGS by
    default. Some are necessary, but three in particular are "personal
    preference" flags: -g, -O2, and -D_FORTIFY_SOURCE=2. Moreover, the
    particular manner in which those flags were set would override the
    value set by the user.
    
    This commit updates the three Makefiles to instantiate CFLAGS with,
    
      CFLAGS ?= -g -O2 -D_FORTIFY_SOURCE=2
    
    As a result, those flags only get used if the user has CFLAGS
    unset. In other words, if he has e.g. CFLAGS="-O1" set, then his own
    optimization level will be used. The remaining flags added by the
    build system are appended as usual with "+=" and should be unaffected.
    
    This obsoletes a patch carried by the Gentoo distribution to support
    their users' CFLAGS.

commit 0cbaf38fdbbfcd205912a4e80406a95f4bc39976
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 9 10:24:04 2017 -0400

    add a server/ copy of zmalloc

commit b733779f0cb46715dd23ac926aefab729743942f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 8 16:16:38 2017 -0400

    mutex needs to protect list walks, not just removal.

commit 89d58ada84af4c941a7bedaf89a845eb490f6aa2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 8 15:50:35 2017 -0400

    change decoders to return strings

commit 91ae3b58026c255b65c91093d7b64afc799c683b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 8 15:19:12 2017 -0400

    create a thread per child queue
    
    Otherwise, while we wait on one lock every other child is blocked.

commit f3764ffc7f46a7aae442a6d9cfb216a72db2d73f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat May 6 00:52:58 2017 -0400

    shut up cppcheck: scope reduction

commit 176fc46de084cc6d62e62e8f90610d3c0fc52189
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 5 20:20:36 2017 -0400

    use threads to separate 'add to queue' and 'decode queue'.
    
    The decoder needs further threading, as currently we stall all
    processing when we hit a mutex.

commit adc1a72657ac848c80dee0868821dfc242564bec
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 5 15:47:38 2017 -0400

    queue & decode child messages.
    
    Still some work to do here
    - object messages are skipped (see TODO)
    - still no ordering of messages during decoding.

commit 90498fa7fb08588561f7cdde1a6d2fe9f14bc784
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 5 15:45:22 2017 -0400

    initialize logging later.
    
    We need to do this at least after all params are parsed, because things
    like max_children can change based on which args we passed, and the
    value in the handshake will be incorrect.

commit dd47b8c1116362dc18a5b9a6cea2ae6c9e05512f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 5 14:58:19 2017 -0400

    start moving towards separating queueing packets and decoding them
    
    This only implements a queue for main packets, child queues to follow.
    
    Later we'll move towards having separate threads for queueing & decoding.

commit de751d71e490faee3fb6d2bd0cb2550ddfee322e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 5 11:29:17 2017 -0400

    make ->dump silent when running with -q

commit e48be59c026039ec313d2c3a9978c553324c601d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 4 09:33:11 2017 -0400

    num_children moved to the handshake message

commit b21b9c28f2c3ba54896e15daa1ec59aad6c73912
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 3 13:28:32 2017 -0400

    rewrite the handshake code to pass a struct
    
    We'll need to match up session creation (ie, a handshake) with a main
    thread and it's number of children, so pass the relevant info in the
    handshake request.

commit 9244ab7fcf6561d2b62fed2146b4a2417e18dbb8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 3 12:02:46 2017 -0400

    move socket setup to own function, cleaning up main()

commit 717b1274065ff4d23e19bce60e64c3f5b862481e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 3 11:18:27 2017 -0400

    do more dead child reaping when waiting for exit

commit 182e625fe5d5121981fcd88d914b458589732c8b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 2 14:28:04 2017 -0400

    split up the decode file

commit 3e0397baa00f324db937744caa17cb9bd7a29183
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 2 13:45:45 2017 -0400

    don't spin on locks if we've already finished.

commit ab709f6835ec2c96713d6aa03a62621211e48cba
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 2 13:20:32 2017 -0400

    fix infinite loop in main
    
    If we reach max count, and send SIGKILL to a child process which had
    set a lock to LOCKING, but hadn't set the lock owner yet, other children
    which stumble across that lock get stuck.
    
    Help those stuck children along a little with a SIGKILL.

commit 6f17e50da1a4b577c90dfb23f0eb4ba8e98a1026
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 1 17:04:41 2017 -0400

    log seed/reseed events

commit cf19ddb8dade1063cd1d11df479fea59da2c35fa
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 1 16:29:17 2017 -0400

    fix backwards ternary operators
    
    when I switched the meaning of ->global, I forgot to change all these.

commit 998f4171bcbf018f01730973a3ac3a4979be4f4f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 1 15:55:08 2017 -0400

    introduce a trinity_msgchildhdr struct

commit b86f44278240e69f5a98a6074e91c4f43ee6e2ed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 1 14:59:47 2017 -0400

    initial attempt at syscall arg logging over udp.
    
    A number of problems here. The biggest being that there's currently
    no attempt at ordering, and recieving packets out of order is entirely
    possible.
    
    So you see things like...
    
    Child 33 [11226] syscall prep [op:219] 120 (0x7f91a0647000,0x7f91a0647004, 0x7f91a0646000, 0xf0, 0xfffffffffffffffb, 0x800000000000)
    Child 33 [11226] syscall [op:219]  result 0
    Child 33 [11226] syscall [op:220]  result 0
    Child 33 [11226] syscall prep [op:220] 213 (0x1, 0x41, 0xf3f, 0x24, 0x5c, 0xdfdfdfdfdfdf)

commit 4cdcc98cb3f589d674b06971fcf42a00b4c1d65b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 26 16:05:15 2017 -0400

    if handshake fails, force a re-read from udp

commit 397a8178b9d7266cb63de635b2fb39b532cd1cb3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 26 14:20:25 2017 -0400

    remove a bunch of bogus __unused__ attributes

commit 7f94448b55a862e70d3ada24b80fb7484c0a16ad
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 26 12:55:54 2017 -0400

    copy the ->dump method into the child object header

commit 5d0d1a22a0bd58761dffe90d288423acd1d30e2f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 26 12:55:14 2017 -0400

    todo: iterate fd provider list in help text

commit 42680d8ed86fc6edb80bbfeabe3d7627efe1447f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 26 12:54:37 2017 -0400

    reorder local/global definitions
    
    we treat 'global' as a bool in a bunch of places, and having this
    be 'true' when global makes more sense.

commit 0a2d66d85181df40fa5cba407ab8e31dc8bd78f3
Author: Praveen K Pandey <praveen@linux.vnet.ibm.com>
Date:   Fri Apr 21 15:35:42 2017 +0530

    fix memory corruption in tables-uniarch:log_enabled_syscalls_uniarch
    
    size change to (sizeof(int) * shm->nr_active_syscalls
    
    Signed-off-by: Praveen K Pandey <praveen@linux.vnet.ibm.com>

commit d14f212a5ab9677bf01b8fae4d791c98eb2aad8e
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Apr 16 21:29:14 2017 +0300

    fix off-by-one in dump_childnos()
    
    Fixes a segfault:
    
      ## pids: (60 active)
      0-7: 0 0 0 0 0 0 0 0
      8-15: 0 0 0 0 0 0 0 0
      16-23: 0 0 0 0 0 0 0 0
      24-31: 0 0 0 0 0 0 0 0
      32-39: 0 11081 11082 11083 11084 11085 11086 11087
      40-47: 11088 11089 11090 11091 11093 11094 11095 11096
      48-55: 11097 11098 11099 11100 11101 11102 0 0
      Segmentation fault

commit 60d1d13f21c230b1940d61866b80552598237f0c
Author: Baruch Siach <baruch@tkos.co.il>
Date:   Fri Apr 14 08:18:10 2017 +0300

    configure: fix cross compile detection of broken ipv6 headers
    
    Checking the content of the host ipv6.h headers is incompatible with cross
    compilation. Target headers may not be the same as the host. Do direct build
    test instead using the ${CC} (cross) compiler to detect headers issues.
    
    Define _GNU_SOURCE to make sure glibc ipv6 definitions are exposed.
    
    Signed-off-by: Baruch Siach <baruch@tkos.co.il>

commit 656458675e37e065090d22268fbe2c543ca969fe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 15 21:20:14 2017 -0400

    add missing 'transmit and free udp packet' lines to uniarch table code.
    
    missing cut-n-paste.

commit 45ae36627d16c64569c0fa566ccdd70fd371c47d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 14 16:03:36 2017 -0400

    log which syscalls got enabled.

commit ca44988d341986612585c8219536e8c4a0716ea2
Author: Praveen K Pandey <praveen@linux.vnet.ibm.com>
Date:   Mon Apr 10 11:41:31 2017 +0530

    Fix PowerPC compilation issue
    
    compilation failed with
    output.c:33:12: error: comparison is always false due to limited range of data type [-Werror=type-limits]
    if (level == CONT) {
    ^~
    cc1: all warnings being treated as errors
    Makefile:126: recipe for target 'output.o' failed
    
    Signed-off-by: Praveen K Pandey <praveen@linux.vnet.ibm.com>

commit c20a52694c3ce9d142325c483e24a895fd010d7d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 18:45:23 2017 -0400

    pass the buffer down to the decode routines instead of using a global

commit adb29ff32aa3818964b08baa253377fe471420fb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 18:38:02 2017 -0400

    compile fixes

commit ca59ca426679330bf8b76a3788e7d83eae43020c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 18:30:16 2017 -0400

    log & decode object destruction

commit 70bca4e0923becaf69c751124a354311d3f5b2c4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 15:16:18 2017 -0400

    log & decode sysvshm objects

commit a32d50dc20da55e6fe4d9c223d0898ab7014395f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 15:09:33 2017 -0400

    log & decode futex objects

commit af12065d2e0a0f49bb8c9c2f54d0c77010ae0fd6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 15:01:27 2017 -0400

    log & decode socket objects

commit 37bcecec16fb1b30ccfe591b22994e54b6efcd13
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:54:59 2017 -0400

    remove unused bpf fd in object struct

commit e43c1475d7a5163ed2c142ceb3646791a3d769b2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:54:00 2017 -0400

    log & decode bpf map objects

commit 78048589e6040c3e21a517da4011bcb07fc2d11e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:46:11 2017 -0400

    log & decode fanotify objects

commit e3ccdda8b788ac7da2be33b968e75c25141b93fc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:43:03 2017 -0400

    log & decode userfault objects

commit c9ece8f8647c9403bb146afa91bbbbaf630f335d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:32:06 2017 -0400

    log & decode inotify objects

commit 67d51dc1422b3ac0189bd9f2e7305839f5fbe94d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:28:55 2017 -0400

    log & decode drm objects

commit 007326fa0428466787e8ed3ff64de86baf3080df
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:13:27 2017 -0400

    log & decode memfd objects

commit e6f5c8176aeae2f4670070b2b593527e662965be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 14:05:04 2017 -0400

    log & decode testfile objects

commit 8fb7f6cac2553d1253e5b289a62ab857513871bd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 13:53:07 2017 -0400

    log & decode timerfd objects

commit 496a8ce89b3e5b5196039d465b78c2a88e1d7ba7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 12:04:20 2017 -0400

    log & decode eventfd objects

commit ccdc0d11a0197cf99d5b335670e040d517fe0ab2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 5 00:05:42 2017 -0400

    log & decode epoll objects

commit 6af6c657bbb51abfbcb812042d2fed7fc534f0fe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 18:06:38 2017 -0400

    add init_childmsghdr helper

commit 428b934f8fd88490e0f8faff14cad85c6ae9fd8d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 18:03:13 2017 -0400

    use init_msghdr for MAIN_ messages

commit fe875873d80f2942a9043bc87c0d6f2539cfab1b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 17:10:57 2017 -0400

    log & decode perf objects

commit 97739bc23a42d3474b73d51cfe004e9792992d92
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 15:58:19 2017 -0400

    convert map dump to use init_msgobjhdr

commit 8b988bb11c8fc01b265745afa665360634809198
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 15:56:29 2017 -0400

    helper functions for msghdr init

commit d34fab3c17d4c0b474f3aba35066205ed0587bc8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 15:55:38 2017 -0400

    mapping name can contain a path

commit 45f5885093ad27cc0da1f4dc937b43c5e6f4b139
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 14:27:53 2017 -0400

    log & decode pipe objects

commit 125deb677de85c8cd7758ce38078e2f4998994c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 14:22:33 2017 -0400

    remove __unused__

commit 2541d750bfab91e7d76c815e0e7626d9db7906f2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 12:41:56 2017 -0400

    log and decode map objects

commit 142830c67ab4d0bd6daf1d07dc3252e5dd438ae9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 4 09:44:36 2017 -0400

    drmfd dump needs to take the bool arg too.

commit 73a9bd9f58e089e4542e34ed828da912ce4d8ddb
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Mon Apr 3 22:55:16 2017 +0000

    Check for btrfs_ioctl_defrag_range_args.
    
    btrfs_ioctl_defrag_range_args is not available until Linux 4.7.
    
    Fix build error on earlier kernels.
    
      CC    ioctls/btrfs.o
    In file included from /usr/include/x86_64-linux-gnu/asm/ioctl.h:1:0,
                     from /usr/include/linux/ioctl.h:4,
                     from /usr/include/linux/fs.h:10,
                     from ioctls/btrfs.c:3:
    ioctls/btrfs.c:71:49: error: invalid application of ‘sizeof’ to incomplete type ‘struct btrfs_ioctl_defrag_range_args’
      { .name = "BTRFS_IOC_DEFRAG_RANGE", .request = BTRFS_IOC_DEFRAG_RANGE, },
                                                     ^
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit a0cb61187c7a8df37dcb7e803895ef6a1a481877
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Apr 3 13:26:19 2017 -0400

    split out the decoding from the server

commit f0355099660ebfb4dd057c97bc6ebb236b54b111
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 29 16:23:43 2017 -0400

    log files opened over udp

commit 9f8fca89c17be65d14cd06f7856a34815863791a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 29 15:16:48 2017 -0400

    move MAX_PATH_LEN to header

commit 99eb389d993013847eae8d550fa22d5b1ab8570f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 29 15:10:31 2017 -0400

    pass the global bool down to ->dump

commit 2c184523a97d3e19a42e25d4afd1f35eef059495
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 15:28:41 2017 -0400

    cleanup ->dump of socket creation
    
    remove double printing.

commit 3699661f1391295613692c331910d127bb9f7f2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 15:19:14 2017 -0400

    fanotify object extended logging

commit 8dce7f74b019ae84af6397da173ca6ee527bb751
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 15:10:39 2017 -0400

    extended logging for userfaultfd

commit a147750350b10b77d9d175dfbdbbbecebe17d775
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 15:07:17 2017 -0400

    extended logging for inotify objects

commit d9bbde9e684963627e7d4da4caba2d253e98187c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 14:58:52 2017 -0400

    extended logging for memfd objects

commit 7ebdeee62cfc177641b47f71136fe352e6c7752a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 14:54:55 2017 -0400

    extended logging for timerfd objects

commit 697e6fcc3e9ea2c41d4590174fb9647c285377c5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 11:20:26 2017 -0400

    fix leak of epoll object in failure path

commit 2563097b0645a660b377c77e5b047a5b58465b90
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 28 00:10:39 2017 -0400

    fix 'always true' comparison by hoisting declaration
    
    the = NULL assignment each time around the loop
    caused us to leak objects if we failed to open a testfile

commit 98d91d140808398ed2d5de0bf690ca5157a56dde
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 27 17:09:19 2017 -0400

    quieten down the mm dumper

commit 81578bcaa0330aa5ccefee7fd42358e01f6c7d6f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 27 16:43:21 2017 -0400

    extended logging for eventfd

commit 1daa520d99b40656e3d486aaa32ff9040aed6184
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 27 16:41:25 2017 -0400

    fix cut-n-paste error in inotify syscall ->post

commit 7079bc08ea69bda7303440180287a36e93b13518
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 27 16:35:58 2017 -0400

    extended logging for epoll fd creation

commit 7a907e98266430ac3557edc06bb0e1b423506efd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 27 16:17:31 2017 -0400

    enhance testfile ->dump to log more info

commit ceb1d1ccdc50fa2fe724f9ad256900bc6611e57a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 15:31:19 2017 -0400

    copy, and log the perf event structure in the perf object.

commit 87ea5966d4e81d15edfca7d420db110091e95f94
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 15:30:13 2017 -0400

    support continuations in output()
    
    skip the [main] or [childx] prefixes, so output() can be used
    in loops

commit 8f72b7c908efe09a800cc25296e6b670522dd40a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 15:29:45 2017 -0400

    remove unused defines

commit df12e4092f3372fd30f6c1ba8ad6a17fabf9264f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 14:20:24 2017 -0400

    enhance perf fd creation logging

commit 9eea34b2fdae309770e5305f6f8c58b66125effb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 14:13:54 2017 -0400

    remove duplicate output from perf fd init

commit a2d790adebe9fc0838bc8ca9cf69c9e7b358a143
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 14:12:22 2017 -0400

    perf fd destructor/dump were backwards.
    
    wow.

commit 087919c41f79f0cca61c67a17b010338af5ca321
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 14:08:52 2017 -0400

    extend pipe object with additional info about creation

commit 489a4e5c74300000e21d0f7539db44de8c7e5ca6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 14:02:09 2017 -0400

    only set up the pipe objhead once

commit cd9f78d99eb5eb0411aac5b945073fe77fcf479d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:47:27 2017 -0400

    improve dump output for file fds

commit 78abd1499ff402840287acdcd4165c7f71167c7c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:29:45 2017 -0400

    remove duplicate logging from timerfd creation

commit aaec77a07db23022d8666469b825f65bcb37f9e8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:29:23 2017 -0400

    remove duplicate logging from eventfd creation

commit 6c774d18e2f90945fa49ac5ffa3a22119f716a89
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:28:57 2017 -0400

    remove duplicate logging from epollfd creation

commit 2706d5d95ac26ed87c6762fa3deff56767a916c1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:27:17 2017 -0400

    clean up bpf object creation logging

commit 8dbc8a3d3904b10017f816c376940244b4b2b1dd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 13:18:28 2017 -0400

    remove dump_objects, and make add_object do the dumping.
    
    When we start logging objects we want to do them at creation time,
    instead of having to walk a list.

commit cf747cdb3c700f0925ad199082c2787cdc5c7e4f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 12:29:05 2017 -0400

    log where the shm starts/end

commit 219a9c263edea483793af8070729d655288c6f1c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 11:31:11 2017 -0400

    fix some ftrace resource leaks
    
    we're exiting anyway after this, so no big deal, but it shuts coverity up.

commit 20e1c4656233d0ead3c127dca80ec1508aca6f64
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 11:27:21 2017 -0400

    error handling cleanups for ftrace

commit 3e1c368551821d3459aa71f358a59079c2a36013
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 24 11:21:25 2017 -0400

    fix off-by-one in ip proto selection

commit 3589e3b0489a28218173304c0e8b8f9e1b664fbd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 22 17:10:16 2017 -0400

    export logging_enabled and use it appropriately
    
    no point building structures we aren't going to send.

commit d3f3debdd4f6f2a31442230ac6e23fe0d56e7b24
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 22 10:48:49 2017 -0400

    don't make locking failure fatal
    
    this will always fail when run on nfsroot for eg.

commit 216d90aee966a28ab603adeeee2e6cacb1dfa6f5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 21 16:24:27 2017 -0400

    update -l help text

commit 1db93cd2e73726688d9714783234bba492a8c4fb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 21 14:51:40 2017 -0400

    fix swapped args

commit d69b7d40c503e165c0ddfd68334dd46eec1587ba
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 21 13:39:33 2017 -0400

    micro-optimize the 'became tainted' case.
    
    don't bother reading /proc if some other process already did it.

commit a9b67acf3bb3d977b4d654b9676950385ad2d9ae
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 21 13:26:14 2017 -0400

    fail hard if we get passed '-l off'
    
    I'll remove this in a few releases, but for now document it so people
    know what's happening.

commit 7d4b3149dc96c124eda0690e9512bf98462e6d27
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 21 13:23:31 2017 -0400

    scope reduction

commit 3576e429a5f76388044f4a12f5fcf9a0d8e25e13
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 16:53:50 2017 -0400

    retry sending handshake up to 3 times before giving up.
    
    Also wait up to 5 seconds each time before giving up.

commit 940227b2d2f2717d8ad03c210f8b9748538387cd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:52:41 2017 -0400

    remove old debugging message that now triggers all the time

commit 336cf1f17374402d1db871442717e183d0a25e0d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:48:37 2017 -0400

    replace decode switch with table lookup

commit 7f631dd182644350e9fe4f5af597750121700fb6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:39:59 2017 -0400

    decode child signal messages

commit fa997f1c7673337f772a680881e8ad6e3c4caa02
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:39:51 2017 -0400

    log child signal messages

commit 14633decf57850d0ac720ff6dd9621ccf2df68fc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:28:14 2017 -0400

    decode child exiting

commit 3fec7de803d6ab404f10fa7592311de997b47098
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:28:07 2017 -0400

    log child exiting

commit ea6fec53a6f08ed374e2f7037fe1013f6a9dac89
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:17:21 2017 -0400

    decode child started messages

commit bc8a6211ca4172d0c14a69372687b6744159c35e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 15:15:38 2017 -0400

    log child creation

commit 12acd91cb415c38f927de5afea8a984bb222d24a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:27:36 2017 -0400

    add server decoding of main exiting

commit 0795bbeb7a9f97ca7a4f0d75bc95ac5c0553246c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:27:04 2017 -0400

    add logging of main exiting

commit f5c97e3c03e875632e704c6431bd3394fdaf1755
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:07:04 2017 -0400

    shut down socket if handshake fails

commit 1616c8b1bc77d4c65a1b2221f5cbc3c0d9663f43
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:22:10 2017 -0400

    move exit reasons to header
    
    This will allow sharing between client/server

commit 4e8789c3c208371836f24371201c327acd59c36a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:08:23 2017 -0400

    reset proto to v0 for now.
    
    during development, this is going to change a lot, and it'll be nicer
    later to have the first cut of the protocol be 'v1' when it comes
    to release time.

commit a76f31e1bb0cd0fa81441390e46b019a74dff47f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:08:10 2017 -0400

    don't hardcode protocol version in server side.

commit 14d4f3802a7eb44d3305afb4963e157fa73acb1e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 20 14:02:52 2017 -0400

    Initial logging server implementation.

commit 2220106d96a2960e316d6c4fd7b3b290cbe1c53e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Mar 16 17:28:30 2017 -0400

    fix missed variable replacement

commit eecb0ff42cceba453ed18e29f531272674cb4af6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Mar 16 17:24:34 2017 -0400

    move the message struct definition to udp.h

commit a1f0d63341af98649292d1afc096147978f42db0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Mar 16 17:16:52 2017 -0400

    have the logmsg type be the first byte

commit 87831f1112d2c8ff253910c6f0cb72240a856f74
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 15 16:06:07 2017 -0400

    send a udp message to indicate main started

commit 9b70d49ceef53f47cb2541df52313213149be2cb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 15 15:11:48 2017 -0400

    simple handshake over udp to logging server

commit 64f20b3143c0a5fa70d8defef4479566143ad7fb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 15 14:30:12 2017 -0400

    don't mess with ioperm
    
    especially when running as root.

commit 72147c4bb395d9abea738920515630dbb5f5f8e5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 15 14:29:55 2017 -0400

    prctl todo for later

commit 9bb547faad18f1e2e6b4ef1d938503b094d060ea
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Thu Mar 9 00:00:14 2017 +0000

    Check for bpf_prog_type BPF_PROG_TYPE_PERF_EVENT.
    
    BPF_PROG_TYPE_PERF_EVENT is not available until Linux 4.9.
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit fb843a588cd068262daaa7015383f6fb01abe393
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 8 11:29:38 2017 -0500

    basic statx coverage

commit f05ecfbb19684a93f27d699e578d1d7606c8e7bc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 16:41:12 2017 -0500

    bpf: pass in the right size arg depending on which union we use

commit 621e192a610c28e8108d8f236d476265c762a081
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 16:34:30 2017 -0500

    keep bpf keys in small range for now

commit c301cfb378dedc9bd5478b463c7711142b1a8d2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 16:05:46 2017 -0500

    improve BPF_MAP_CREATE by setting reasonable types/size

commit e524942c20ea8b7870a5a6deed3f8812cfde614c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:57:23 2017 -0500

    unused fields are already zeroed, as this is zmalloc'd

commit 64ac74b08b6a255ac8ab608387b1ab2a442434bc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:50:50 2017 -0500

    split out the bpf attr generations per-case.
    
    Unused fields have to be cleared.

commit f4452a64bab2d183e70ab583eb2c73527040fa18
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:38:03 2017 -0500

    new BPF prog types

commit 9c23c2579419416c4f86e8c71f6584a5da82b097
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:37:08 2017 -0500

    bpf: set r2/r3 in all cases

commit 4fd5f3c4282c5baa63cf8e70703e61c037daf905
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:31:57 2017 -0500

    always include config.h
    
    Missing this include has caught me out a number of times, as we'll
    silently fail ifdefs.  Make it implicitly included.

commit 1f72d1ae868e10b3dabcfe85fa9a04d7c8ef6d4f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:26:37 2017 -0500

    compile fixes

commit 24ecdeb00ffc240d45b12e64362e55fcfd6201d0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:21:09 2017 -0500

    bpf arg 1 is cmds, not flags

commit ef29f19af040bd2cc407a846f9209ceb7e0e3c3d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:20:45 2017 -0500

    add BPF_OBJ_PIN/BPF_OBJ_GET

commit 917061687be9ec9f23d35bf560faa677746037ab
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 6 15:18:01 2017 -0500

    improve bpf sanitize to support more than just PROG_LOAD

commit 943bc6c4ed2b162e2a7c2c974600a8f9024427cb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Mar 3 16:31:48 2017 -0500

    add some new BPF map types

commit dc4d90f43cf5908710b097b7a260850475809c59
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Tue Feb 28 19:49:16 2017 +0000

    fds/drm.c: Increase buffer size.
    
    Fix GCC format-truncation error.
    
      CC    fds/drm.o
    fds/drm.c: In function ‘open_drm_fds’:
    fds/drm.c:106:40: error: ‘%s’ directive output may be truncated writing up to 255 bytes into a region of size 119 [-Werror=format-truncation=]
       snprintf(buf, sizeof(buf), "/dev/dri/%s", entry->d_name);
                                            ^~
    In file included from /usr/include/stdio.h:939:0,
                     from include/list.h:3,
                     from include/fd.h:3,
                     from fds/drm.c:4:
    /usr/include/bits/stdio2.h:64:10: note: ‘__builtin___snprintf_chk’ output between 10 and 265 bytes into a destination of size 128
       return __builtin___snprintf_chk (__s, __n, __USE_FORTIFY_LEVEL - 1,
              ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            __bos (__s), __fmt, __va_arg_pack ());
            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>
    
    [ changed to 256+10 -- davej ]

commit f159c8e29f642bc17df88d2a11acf4367a18a10a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Feb 27 11:43:31 2017 -0500

    set iovec lens to '20' half the time.
    
    This is a magic arbitrary number, do something better later.
    The case it's trying to improve is when we have a huge mapping,
    and picking a rnd() amount of that mapping is still huge.

commit 4e03dd2c3431d5ffc0c5e997a05098eef61b2729
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Feb 27 11:42:08 2017 -0500

    make iovec's with a single element half the time

commit bd34a3b7e7c819a67db687accf5cd31a5fff0e53
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Feb 27 11:41:43 2017 -0500

    Sometimes unshare various namespaces in child processes

commit 12920afa4634d7361d347de1a436ff85ba2554b3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 24 11:40:14 2017 -0500

    remove unnecessary macro hell

commit 8bac872e231c2c91f41e4dafe13aadd9e8b6076f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 24 11:40:00 2017 -0500

    add RTNLGRP_MPLS_NETCONF

commit 39105a456795dfa07cb892c5de070488750ad2b2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 24 11:29:57 2017 -0500

    skeletal support for PF_SMC

commit 4d0a2c44f52af689ac5392eb2a9c43975ff0e05a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 24 11:23:35 2017 -0500

    skeletal support for AF_QIPCRTR

commit 4f6a1bc463c54cd98ad534de07ceb7b62f9d8763
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 24 10:56:45 2017 -0500

    Add TCP_FASTOPEN_CONNECT

commit 76baad50e645cfda936ab72cbab031c80160bdb9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 16:26:28 2017 -0500

    add ->dump member to objhead
    
    this way objects.c doesn't need to know about every new kind of object.

commit 58017a536464624c0cd313545ef764d60910d146
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 14:10:22 2017 -0500

    make sendudp less fatal on failure

commit 961a1dc12c5fd845a30f9e2d8470b218830881b6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 14:08:42 2017 -0500

    implement logging shutdown

commit 18be9d233ffae1d4d6175fb3791df6813d6df8a3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 13:36:28 2017 -0500

    log.c->output.c log.h->arg-decoder.h

commit 4b9e9c54c1043e1ca026712d796739181bb51f51
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 13:31:55 2017 -0500

    move output() and friends to trinity.h
    
    step 1 of killing off log.h
    
    This is used pretty much everywhere, so it makes sense to put it in
    the 'everything' header.

commit 1570804059f2d5793b342da03d89cc24bc373377
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 11:59:10 2017 -0500

    introduce some basic 'connect to udp server' code.
    
    early days, but something to build on

commit c541485aa3db4db2afb9c34b65bbf9dec3027b13
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 11:35:36 2017 -0500

    remove some more leftover log-to-file code

commit f961e7b183d48f9e154f9ecb289e4dd871d5737f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 22 11:33:29 2017 -0500

    missing include, compile fix

commit 71c79cac873243eb043bdd215e831605ff5d94ed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 17 14:37:07 2017 -0500

    Add PF_KCM to domains list, so -E KCM works.

commit 03cf290f205d5277603464393333441062e6edd7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 10 14:13:44 2017 -0500

    if creation of a specific socket fails, bail out instead of retrying
    
    otherwise we could get stuck in an infinite loop of EPERM

commit 1334c511e499e684cbe637384cecb40ab20bd676
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 10 14:10:19 2017 -0500

    get_domain_name returns strings without the PF_

commit 45676e23b00bfd656ed88bdbec93776939991d30
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 10 14:00:36 2017 -0500

    don't set dropprivs if we start up without any.

commit 913adf0b59423af3c7cc841b4f3f64fce5c42898
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 8 15:53:20 2017 -0500

    do a flush after rewinding the pid stat file.
    
    we can read stale data aparently without this.

commit dca7af62e1d43a2e5f6158ab38acad698884aa2a
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Feb 5 17:53:52 2017 +0200

    btrfs/ioctl.h is not really needed
    
    <linux/btrfs.h> has the ioctl definitions we want, so I see no reason for
    checking for <btrfs/ioctl.h>.

commit 8a91c7ee90f9c30d222a01c499d282f2e2b2dcca
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Feb 5 17:53:51 2017 +0200

    Makefile: -Werror also for gcc 6.x

commit 568b2440c5739eba53edecc02f6e95cc336073a0
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Feb 5 17:53:50 2017 +0200

    Makefile: improve build time with immediate variables
    
    It looks like "CFLAGS += $(shell ..." is a bad idea, as make will repeat the
    shell expansion again and again during the build.
    
    Use immediate variables where we can to avoid the issue.
    
    make -j4 before this patch:
    real    0m10.774s
    user    0m24.541s
    sys     0m10.676s
    
    make -j4 with this patch:
    real    0m8.173s
    user    0m20.817s
    sys     0m7.632s

commit 104cce8840dbb38b03f680985c26e57d67226d66
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Feb 5 17:53:49 2017 +0200

    Makefile: use findstring to check if we are building in development mode

commit 8372191e2147d8ab64961760a7853f1580043cb0
Author: Tommi Rantala <tt.rantala@gmail.com>
Date:   Sun Feb 5 17:53:48 2017 +0200

    Makefile: use grep -c to avoid wc -l

commit 99f53f5663cce5447dfe490c8232e33b29bc57f8
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Tue Jan 31 08:26:02 2017 -0800

    Fix a rare double reap bug

commit b4c977378541d4d3bf07de647d3b0329b559cfa7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 30 16:37:37 2017 -0500

    remove all the 'log to disk' code.

commit 6346874171c553aa2faf04ac4e2380f17dfd3c5a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 30 16:41:43 2017 -0500

    remove all the ANSI colour code stuff

commit fc91c08eb08e0982ce649ef651adc9a2793b61c3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 30 13:58:32 2017 -0500

    add TFD_TIMER_ABSTIME & TFD_TIMER_CANCEL_ON_SET to timerfd_settime flags

commit 5156ee671854d8aab44bccb10cef3b543ecb9837
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 24 13:02:01 2017 -0500

    open_socket can be static

commit 5f94be30041a8b3043eac21420ae9e67858cdff1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 24 13:01:21 2017 -0500

    write_socket_to_cache can be static

commit d8ad631859b068172e20f01a6a8dc66eeecb7d41
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Mon Jan 23 14:31:08 2017 -0800

    Fix --enable-fds bash list expansion bug

commit 63a15767d9402fb877fc29e67097de2eb1913b77
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 24 12:52:13 2017 -0500

    socket generation should signify success when no cache exists.

commit 90b79ec370ba109a4f1b661066760c07236642d6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 24 12:51:10 2017 -0500

    generate_socket can be static

commit d40cb895236d376b99bc68073dc8b4b7e07446e9
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Mon Jan 23 11:38:07 2017 -0800

    Fix glibc for linux < 4.5 using compat.h

commit 2f401e5cf8029e84222ac4c149ccfb8eb7f191f9
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Wed Jan 18 15:48:35 2017 -0800

    Correctly handle failure to open the kernel taint file

commit 0d07e7845a63f9ce7f3af96c787aa5cea2589642
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Wed Jan 18 15:43:44 2017 -0800

    Correctly handle commas in fd provider mask

commit b7d7d059c8ba17391b737ae0f6cdeef8e1488fdb
Author: Gareth Evans <gareth.evans@contextis.co.uk>
Date:   Wed Jan 18 15:42:37 2017 -0800

    Correctly handle an error during initialization of fd providers

commit 14f78c74d14ce5a675d4598d7e25f6790dbfd3ee
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Jan 7 22:45:22 2017 -0500

    clear out any old state left in the postbuffer before we do a syscall.

commit f731d101f0cfec261dc3c1d296b714ce6011e390
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 28 19:02:01 2016 -0500

    protocol is always unsigned.

commit 4f8ca1b3b213dcb1facf3aaa74cc2f2bc98a927c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 28 14:46:11 2016 -0500

    optimize the case where we're dirtying a whole mapping.

commit b95986b43f0960ce604b0c7e402179675e5a05a1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 28 14:27:29 2016 -0500

    check that the mprotect succeeded before writing to page.

commit 7b0c4fea9d676996d942cfe4fd12bd2dd9d217c2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 22 16:38:48 2016 -0500

    fix segfault in get_writable_address
    
    we can call this before we've setup any shm objects.

commit 2250b042bcaa8814dfd4d3b7f1da40e30e055e9f
Author: mennis <mennis@corvus.net>
Date:   Tue Dec 20 17:33:07 2016 -0500

    linux/nvme.h has been renamed in linux 4.4 to linux/nvme_ioctl.h

commit 052b153184113cc68d31d56ee1c3749b75ee7daf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 21 11:27:26 2016 -0500

    update i386 syscalls

commit 034a41cc2674341ce7fda908e4cb4be3c8e48757
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 21 11:16:24 2016 -0500

    add IP_RECVFRAGSIZE setsockopt

commit 39340c66406d710ac5e81ce441dff5508afc79c9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 20 15:21:55 2016 -0500

    add missing ipv6 setsockopts.

commit 0b9467947e9b94899f70da2a095bf2e1a1c62b14
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 20 13:16:05 2016 -0500

    don't reduce max number of children if < 4 specified

commit 2411e2a00232d4f7c12828d9c0c3882b63d602fa
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 20 13:05:56 2016 -0500

    remove some off-by-one's in the -N handling

commit 946d268d99d2632659e0e0a4140422e822cbcc31
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 20 10:04:20 2016 -0500

    remove the ECHILD handling completely.
    
    It shouldn't be necessary any more.

commit a3c82705b2b45107fa036c1352bd630546215f42
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 19 14:38:35 2016 -0500

    teach sanitise_socket_triplet about the privileged socket types

commit 3f371262026576fcf2d3e0f8e566c7487c493c22
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 12 14:05:31 2016 -0500

    ECHILD with child==-1 is boring

commit 7a664b9bacce0d5c9dd57962c009dff58ba08aff
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 12 13:16:55 2016 -0500

    greatly simplify the seeding code.
    
    - only use /dev/urandom
    There's really no benefit to getrandom().
    - remove gtod fallback. urandom or gtfo.
    - Only read from a high entropy source (urandom) once, and use
    rnd() in subsequent new seeds. We don't know what other consumers
    of urandom are on a system, so replaying the reseeding was difficult
    or impossible depending on how busy the system was.

commit c0bd6ba0d14e326b44f4d5ed87536fe060c33b09
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 12 12:53:10 2016 -0500

    add --ftrace-dump-file arg to specify where the dump file goes

commit c5de347684a2c2ec002c09cb809e157a0638c087
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 12 12:44:33 2016 -0500

    sort by argname

commit 5b68e1ee9bbce64c8f8434e7a30f800b40c9d2a5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 12 12:42:33 2016 -0500

    move taint checking init to its own function
    
    also explicitly cache the taint fd on startup

commit b0e66a2d084ffc210bc1fc247efb4d177e9f7e3d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 5 12:46:14 2016 -0500

    use userspace headers for ax25 instead of kernel.
    
    This should solve https://bugzilla.redhat.com/show_bug.cgi?id=1400720

commit a99acd76f500133d68a69e184a969c0151317efc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 5 12:14:06 2016 -0500

    dump the trace to a file when we detect tainting.

commit 8f4844fd949294dd2e9ae9641d928fc3ee3ea828
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 2 11:35:24 2016 -0500

    similarly, if stopped ftrace fails, bail out after warning

commit ae1e40fb2ed7300fa367e42748ed68e369bf6f96
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 2 11:34:55 2016 -0500

    don't fall through if opening ftrace tracing_on fails

commit f1d2a4635510aef4a2e8c5c9bff0e7e546c0a406
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 2 11:27:39 2016 -0500

    We only want to do the ftrace stop/postmortem once

commit 90dc84912b73f3dbc286b95ab66c6d5c0124d36a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 2 11:26:39 2016 -0500

    replace duplicate code with taint_check helper

commit 1e489f6a7e1910a5e1ccde3d77b98c80806c6639
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 2 11:25:19 2016 -0500

    split stop_ftrace_if_tainted in two

commit 4eb7784c5be8e3f752d1bf87170058b055ba0554
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 1 17:21:28 2016 -0500

    get_cpu type fixes
    
    -1 needs us to return a signed int.
    return INT_MAX as a possibility too
    fallthrough to allow 0 to be a possible case.

commit cda23d53fedeb1f9d720320dff04a499a510ab7d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 1 17:17:06 2016 -0500

    list_empty is a bool

commit 7b501751b6720691c0791f41d64a5afe41b2a63f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 30 16:09:00 2016 -0500

    reset tainted filepos to 0 before each read
    
    Now that we keep the fd open across the lifetime of the run, we need
    to reset it after we've read it

commit 9e8fb7b8668cd54022918edb4558bc03bb5be57f
Author: Yury Norov <ynorov@caviumnetworks.com>
Date:   Sun Nov 27 12:50:29 2016 +0530

    Fix -Wunused error
    
    I try to build trinity for aarch64. In my configuration USE_PPPOL2TPIN6
    is not defined, and it makes some functions have unused variables. GCC
    treats it as error. This patch fixes it.
    
    Signed-off-by: Yury Norov <ynorov@caviumnetworks.com>

commit 1e545aa1d8cb80e6f165abe516632e0efc22832d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Nov 24 03:05:29 2016 -0500

    Add beginnings of ftrace work
    
    This assumes you've already setup some ftrace tracing before
    you started a trinity run.
    When it detects that the kernel has become tainted, it shuts down
    the tracer.
    
    Right now it relies on you to copy the trace buffer somewhere safe etc.

commit f7a42e9aba4c89f29112da25b617587902b30337
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Nov 24 02:59:13 2016 -0500

    rework taint checking
    
    * Move the mask checking into taint.c
    * introduce is_tainted()
    * rename check_tainted to get_taint()

commit 0b7ba41157aaf92c418ab0f5f1114c4875da8ba7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 22 11:42:47 2016 -0500

    rename lock -> thislock to solve -Wshadow warnings on older gcc

commit 6ecf0909eda15a0db420946823935cfb186c46be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 22 11:32:51 2016 -0500

    Fix missing initializer warnings for older gcc's.

commit 87427256640f806710dd97fc807a9a896147c617
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Sat Nov 12 00:55:35 2016 +0000

    Check for bpf_attr map_flags.
    
    map_flags is not available until Linux 4.6.
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit cc3394c2dd164afa53732c3aac6cc31ec4a6e93b
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Fri Nov 11 16:54:11 2016 +0800

    Debian release 1.7-1

commit 2ff8486504ccd53ba83870d24ee4dc5e9ee3298a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 8 10:40:24 2016 -0500

    Some older distros apparently need types.h included here.

commit f447db18b389050ecc5e66dbf549d5953633e23e
Author: Jan Stancek <jstancek@redhat.com>
Date:   Mon Nov 7 12:50:27 2016 +0100

    fix build when USE_BPF is not defined
    
    net/bpf.o: In function `bpf_gen_filter': bpf.c:852: undefined reference to `get_rand_bpf_fd'
    
    Signed-off-by: Jan Stancek <jstancek@redhat.com>

commit ccb0c8935a5b7e6afb6f68bd73f61867f0965dea
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 17:23:55 2016 +0800

    Partially rever commit 6966190
    
    Replace the clean target in debian/rules by a dh_clean override

commit 55db3b19a203462e1cff1d2cf7050e4817678e8d
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 17:18:06 2016 +0800

    Enable verbose build, (Closes: #790719)

commit 69b60ee6f8f6539e6eac3a5e80992b68afdbc5ee
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 17:08:35 2016 +0800

    Update upstream changelog

commit 59f864abc2550de7cc17e97ff372570e6069d62b
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 16:59:22 2016 +0800

    Remove lintian overrides

commit b01227cea93ed61014428be857491a57dc52d5b0
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 16:56:52 2016 +0800

    Enable all hardening flags

commit a6aa123718a5deb652157d8a9d37139ecb0b78cd
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 16:55:04 2016 +0800

    Starting 1.7-1's packaging

commit bff9f052a650f6430ecaba9ca08d5e17941baf77
Merge: f31d63595629 4b4463ea3313
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Sat Oct 29 16:51:12 2016 +0800

    Merge tag 'v1.7' into debian/unstable
    
    v1.7 release

commit 83edf1ef00456a161224a8bf12aa9bf89f03de6c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 28 13:56:34 2016 -0400

    Move version back to devel

commit 4b4463ea331336285321b4352ad305fd306f06da
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 28 13:41:17 2016 -0400

    1.7 release.

commit 24a516dff281d3262fe57a57e5e3510d655e2e2c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 28 00:32:46 2016 -0400

    Add FALLOC_FL_UNSHARE_RANGE flag to fallocate

commit c3f0b53764599645b033902a8164a9463f57ef04
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:39:55 2016 -0400

    consolidate the seed initialization into init_seed
    
    Reducing the number of places we check user_set_seed.
    
    Bonus side-effect of not printing about getrandom() when we set a seed.

commit 698453cc56072fa852a03099a8d0867143279fa2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:31:37 2016 -0400

    kill_pid debugging
    
    like the pid_alive debugging, this may be useful to prevent some
    future stupidity.

commit bc239d4a072a92c50a4a407784d99520ae6c3c19
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:30:55 2016 -0400

    update find.sh to a more interesting example.
    
    Also use the helper scripts.

commit 584d09a8d1be8c54d88fac3a11eabb95d761cf95
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:29:05 2016 -0400

    Sanity checks in pid_alive
    
    debug code that I've been carrying forever.
    These should never fire any more, but they might be useful to have
    in case I screw something up in the future.

commit af4611a1d454032729a93113da95e46532504b2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:27:45 2016 -0400

    for now disable periodic dirtying of mappings.
    
    Another case where after some syscalls (mremap for eg) we segv.
    Need to investigate further post 1.7

commit ad6f3585e16158256712515c82f84bc5698278b9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:27:22 2016 -0400

    pick read/write dirtying based on PROT settings of mapping

commit c5d4fbb48c3e996769894fdf9c6566195b6cdde1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:26:17 2016 -0400

    disable the mremap page-dirtying for now
    
    This segfaults, and I'm not sure why yet. Disable for 1.7

commit 08ddcfa937e0232a6c93594da9aa564f2d900189
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:25:04 2016 -0400

    let children reseed (from rand()) when we pass in -s

commit 3ca8b3752cb2f329df384755a3be7596110e0489
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 27 14:19:12 2016 -0400

    if we passed in a seed, don't generate new seeds from urandom/gtod

commit 3aba9133af20b707d44a17ace91a857c22c2ea9d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 25 19:50:12 2016 -0400

    bpf: Fill out .k with a bpf map fd occasionally.

commit 3494a7959d4a590650a3fd2839d89f64cf5ebe3a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 20 14:34:06 2016 -0400

    update the map->prot when marking a page as writable

commit d7ca00d437e03b45bd38b06ecf284ed9e672580a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 20 13:48:08 2016 -0400

    fix off-by-one bugs in single page fault routines.
    
    page offsets are 0-4095, so we don't need the extra subtraction.

commit 0b6e4f0515bc7af2904808c1bd9ceca309ba090c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 18 19:17:03 2016 -0400

    allow '0' as a file mode

commit c78a28d4daa46267c5766875b0b8ab83b5915ae5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 18 19:16:06 2016 -0400

    remove the 'do syscall in a subchild' code for now.
    
    This isn't doing anything useful other than adding overhead right now.
    To be revisited post 1.7

commit 9cb8dbf6fc3fb5e6660d2cc15ec61d21e99f07fd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Oct 17 15:06:47 2016 -0400

    mark pages as PROT_READ before we fault them with a read

commit 3a0e33d1db3214503316840ecfb90075d60ab3be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 15:53:25 2016 -0400

    silence cppcheck

commit a79863662025676a0d49b361db24371d295abe04
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 15:35:50 2016 -0400

    change the random munging a little
    
    - increase the likelyhood that we don't do any limiting
    - tweak some chances that we leave the rand num unmunged

commit 35018d4bbe5179f1aef4e00823f0474538770d0a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 15:32:55 2016 -0400

    generate random numbers in the -1..-10 range

commit aa1798cf35dbfa9c4a11c05028ac4e89d2bac6eb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 15:08:24 2016 -0400

    add the 'special' ring-id's for keyctl

commit 5cd7824c547adfd33fa4ce8d82778e4daaed937e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 14:14:19 2016 -0400

    fix segfault in setsockopt() when called with --disable-fds=sockets

commit 73da6ab7f0efbfc32b25e13da3772559f69aa567
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 14:13:36 2016 -0400

    Fix up segfaults when encountering null entries in syscall tables.
    
    Triggered occasionally with -r

commit 55fd93c44ccc24b9d21ea37c73d72c12e98e6f01
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 14:12:43 2016 -0400

    don't use rewind() on /proc/pid/stat
    
    This seems to not do the right thing always.
    The fseek is more explicit.

commit 40c86c5a30b36dd95307f5a6033c101252f28495
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 14 14:09:35 2016 -0400

    multi-page mprotect fixes for fault-write
    
    Multiple problems here:
    - In some cases we would pass down a multi-page mapping after mprotect'ing
    the first page as writable, and then try writing to a different page within
    that mapping, and segfault.
    - In some cases we would mprotect write a whole multi-page mapping, even when
    we were only going to write to a single page.

commit f31d6359562959590ad4a8df9637a34c47ecbcdb
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Wed Oct 12 11:53:15 2016 +0800

    update debian/changelog

commit 02d4a566d30bbca01f6468ee24fc2ed3a56b8505
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Wed Oct 12 11:52:26 2016 +0800

    Install the manpage provided by upstream

commit c10f59bd63ab30709ba059dd3b98864e0be6c461
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Wed Oct 12 11:50:33 2016 +0800

    Override 2 lintian warnings, document the reason

commit e7de12ec7d51fb7ff8e27ed419d8c4d505ce205d
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Oct 11 10:25:58 2016 +0800

    Store the generated tarball using pristine-tar

commit 1e4be75fc54eb410ca4d869290fec1a45f5adf8d
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Oct 11 10:20:25 2016 +0800

    Changelog for debian release 1.7~git20161005-1

commit 6966190ba8efa17cc4f2366baad0d52a78ccfb03
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Oct 11 10:17:41 2016 +0800

    Replace override_dh_clean by clean target

commit 0a133427f33aa80ca577f29ddd4114a633696df6
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Oct 11 10:14:14 2016 +0800

    Update standards version, no changes were needed

commit 49767cb18e47ca4dbd127786b0870389a406f227
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Oct 10 16:06:21 2016 -0400

    add pkey alloc/free syscall stubs

commit 178058972b816132789fc1a945a22ff3020581cb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Oct 10 15:56:11 2016 -0400

    add pkey_mprotect stub

commit 175b6288ca685815e8f3bc61e2ba4b548902c102
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Mon Oct 10 21:07:15 2016 +0800

    Drop unnecessary patches

commit 055d51b38afe5c2e63b40987bac5a6164c0ec2e2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 7 15:57:54 2016 -0400

    open the testfiles multiple times with multiple modes

commit 8d530c3bac53de5a06fddd5c99056364f1cae33f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 7 14:44:55 2016 -0400

    fill out the .k with rand32, so we get fd's etc in there.
    
    This needs to be smarter, but this is better than rand() for now

commit 60e27523a341749e8f429c2168a6129b37afea56
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Oct 7 14:01:13 2016 -0400

    add some eBPF instructions/addressing modes

commit ce7fdca7e4f84538cfc42ff59df65a2f4d4571b5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 6 15:40:19 2016 -0400

    scope reduction.

commit 0d44070108f82d59d27db95c8357eb2885fec3be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 6 15:39:28 2016 -0400

    convert bpf fd generation to be table driven

commit 88db9ff4f855a2f5fbe260b396e7d2774cbaed8c
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Thu Oct 6 21:07:06 2016 +0800

    Update changelog from upstream git log

commit 211b1b21292ae90a6f6c2455813641c9246e545e
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Thu Oct 6 21:05:28 2016 +0800

    Remove override for dh_auto_configure

commit 5aa3e6f96c15415cc863c3f3aa4cb42eec69f93e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 6 08:46:55 2016 -0400

    fix uninitialized var when run with --disable-fds=sockets

commit c902a4380f1c559b113fb07a35154c1ce7905b4f
Merge: 1c49a2822097 6512bb9044bb
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Thu Oct 6 20:24:07 2016 +0800

    Merge tag 'v1.6+git20161005.6512bb9' into debian/unstable

commit 6512bb9044bbd82922fc4e74e1f122d68fbca0e8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 5 14:09:56 2016 -0400

    correct the params for BPF_MAP_TYPE_STACK_TRACE creation

commit 93d419beb2f2fb1e71ddb34ba4e47e6d74b94510
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 5 14:08:40 2016 -0400

    add the newer bpf map types

commit c3da5c4224b0646aac2ea5cca2ebec1e169f46d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 5 13:47:06 2016 -0400

    create a bpf fd of each type.

commit 05948f04430564d5e66aa93244543585c86049e4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 5 11:35:59 2016 -0400

    move the reading of MemFree out to its own function for other uses.

commit 1a44abb7710eb93987f165699f959827b0704245
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 5 11:26:32 2016 -0400

    fix up some segfaults when --disable-fds=sockets is passed.

commit 76aadaba3e48f73adecff456e595582fdc472916
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Sep 23 16:25:49 2016 -0400

    annotate fadvise flags

commit 7887d9e30c8fc9d3c58ae62c5d17ae8c7dc29c21
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Sep 13 11:18:12 2016 -0400

    make enable_random_syscalls static

commit e966131caf8c287f11f367426c6ca43ba9d358bd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 15:48:04 2016 -0400

    reduce the amount of time we wait for the grandchild a little

commit 9e44545de53ef8ca77368c0edf32e245e896a7a8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 15:47:15 2016 -0400

    skip the sleep if the grandchild has already exited.

commit a37e38b4ab6a7b3260fa165a1edb2dcc022a6e48
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:41:44 2016 -0400

    add missing locking around state modification

commit 04ffc99dc5b050744b5cac628a41590e8039e2c8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:41:08 2016 -0400

    count syscall attempts before, not after the syscall.

commit 3bd0e91a586822e05fe8763ec262a2c56f0434e3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:40:21 2016 -0400

    set GOING_AWAY state correctly.
    
    The recent change to widen the BEFORE state window meant we scribbled
    over the GOING_AWAY state.

commit 3c4daa609aa4c22f8f7b9ad4707c9847c8b11c20
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:39:21 2016 -0400

    unify the stats update in handle_syscall_ret()

commit f7974b6849d3819247bddf699c475d37d50ce610
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:37:37 2016 -0400

    small pause before repeated kills to grandchild

commit 90e237c8be2806ee69dc17def523e26b0789efc0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Sep 12 12:36:27 2016 -0400

    let the grandchild live for a second before we kill it.
    
    When under load, we got into a situation where the fork/exec never
    actually completed before we started sending kills.

commit 5bc525ca3d2b8f117e3d8303e948bfa48e8b4270
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Sep 9 21:20:01 2016 -0400

    change check for inactive children
    
    Jan Stancek reported that he saw processes hanging without getting killed,
    and this is the most probably reason.  We were considering children
    as inactive even if they were doing the syscall, so they were never getting
    sent a SIGKILL.
    
    Change the state comparison, and also widen the window that we spend
    in 'BEFORE' up until right before the syscall.

commit ecea2b06d5f348068cb74ffef072813e13a38856
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Sep 1 17:39:36 2016 -0400

    record/output the successes/failures per syscall

commit d18ba5b45727f67780c0f449b1a7308614f9c83b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Sep 1 17:20:21 2016 -0400

    add option to dump errno distribution on exit

commit 87427506ffa17ead38bd548a781c6842148d4555
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Sep 1 00:37:47 2016 -0400

    fix generation of localhost addresses.
    
    The main thing wrong here was that it was in host order, not network
    order, so we were trying to send to 1.0.0.127. Oops.
    
    Make things more readable by just referring to it in ascii.

commit 37eaa4d616294a7028ebf4aba1fc3bffcfc927bc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 30 21:19:43 2016 -0400

    Only do the max_children limiting once.
    
    This was in a loop, which sent it to 0. Derp.

commit c073f7380db6e1a9e3d8b0477d91bb8ee6b94b18
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 16:49:10 2016 -0400

    remove ->socket
    
    Use the triplets arrays instead.
    Mucho code deletion.

commit 6f4f50259f2ef233ac1b56e3261b27770fa487d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 16:31:27 2016 -0400

    add PF_X25 valid triplet

commit f8187f53c59056b962856858f12913c269f1277a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 16:02:04 2016 -0400

    add valid protos for PF_KCM

commit be0547db1a41e029d958a5f31668ca21e0fbab32
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 15:55:03 2016 -0400

    dummy entry for (dead) econet

commit bcc2f0234270bf658dce689ec2fcdafc0145a132
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 15:53:11 2016 -0400

    add PF_DECnet socket triplets

commit e2fdeec6d640a030bd08a0c47d34bf1a9c95ab96
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 15:50:05 2016 -0400

    add PF_CAIF valid triplets
    
    based on guesswork

commit a52f72f41e2e596c497b5e5b09a2dfc72b476d36
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 14:39:13 2016 -0400

    use correct loop boundary for privileged sockets

commit 829c4bfe158657a5c30556a8b995b13bf5627021
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 14:37:40 2016 -0400

    add support for privileged sockets to the socket generator.
    
    Not super happy with this yet, but this is better than nothing for now.

commit e24b8840802d59548037894bd93a44f21cf9e504
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 14:23:55 2016 -0400

    Replace ->generate with lists of valid socket triplets
    
    These can be shared between the 'generate fds' code as well as indirectly
    from ->socket calls (tbd)
    
    Currently lacks support for 'needs root' sockets.

commit 19fdbda05370999da03ec3891698cc522a0ff99e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 10:26:55 2016 -0400

    overwrite the correct pointer with the sockaddr

commit 17e27d3ce608c62001efe3d8479abf271510adce
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 10:16:46 2016 -0400

    pass the UNSPEC sockaddr back up instead of just leaking it

commit c20bc68e57400602d37b2a9c2b18031710012b94
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 26 00:22:08 2016 -0400

    scope reduction

commit c378e63a11141ccb3cc906fbad996aef8b2f1102
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 17:07:21 2016 -0400

    ->generate for PF_NETROM

commit ece557c3181d076ece8bada0b9f8ab45c31dbbef
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 17:03:17 2016 -0400

    ->generate for PF_TIPC

commit 228f17481ad574748e391380bb339beb04e10acd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:24:43 2016 -0400

    ->generate for PF_PHONET

commit e12514ba3ff869bda7972c5d1dacbf8928c11f8a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:20:42 2016 -0400

    ->generate for PF_LLC

commit b0673ce61ae555083750beb96a4db6bfba68ef1c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:17:14 2016 -0400

    ->generate for PF_RDS

commit b62cfa7ba89e543eb3e7a32e8c50073b0166abbb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:16:25 2016 -0400

    ->generate for PF_PACKET

commit d5d1ada16b6d87e01dc0244dcf585b6e01b620c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:09:00 2016 -0400

    ->generate for PF_ALG

commit 768f817c2d991ec01f14e97bc3acd3464e478e4d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 16:06:58 2016 -0400

    ->generate for pppox

commit 1543000320d06bd7928718cfad5f81a0f5eb1ae0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 15:56:58 2016 -0400

    ->generate for rxrpc

commit a5506ef075bec5562b2b820257b691a857eeab2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 15:44:41 2016 -0400

    rename the IP specific protocols

commit ec1cd9d47bebad49b6e449618d9db60a514bef4a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:45:21 2016 -0400

    Sometimes just do generic socket options instead of the per-proto ones.

commit b1558c017ddc215a46ab3396b806bf9f63873fba
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:42:19 2016 -0400

    move the generic setsockopt options into setsockopt.c
    
    It's not a protocol, so the filename was a misnomer.

commit 18eb29935f5faa9ef9b28c4d336b6a5e59b1b312
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:29:56 2016 -0400

    sometimes make generate_sockaddr create a PF_UNSPEC sockaddr

commit 0d7e5bca772cf6bb3eb40e584a9729cd5e67b618
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:29:07 2016 -0400

    point alg->salg_name to a hash name if we choose hashes.

commit 6a36879c7b8bae11e83afec5e665e968acc615b4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:26:17 2016 -0400

    sendmsg sanitise improvements
    
    - Create more realistic iovec's (limited to at most 3 entries)
    - Sometimes no iovec
    - Set msg_control/msg_controllen to zero sometimes.
    
    Still not great, but at least seems to succeed slightly more often.

commit 526521e28bbcb6613423aaf6780c93e2b03090b5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:24:58 2016 -0400

    cap the number of ARG_LIST options to at most 3

commit b0109d15b452a2a22a43034c8400b6b2cf76cefd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 13:24:03 2016 -0400

    when we play with 1GB mappings, don't create so many children

commit dadd15e33834af3598aabc15d180075f05b9d9ba
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 25 11:51:14 2016 -0400

    remove extraneous format string

commit d868baf5417b65398533126e5fd263bb7df2ea22
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 22 16:17:59 2016 -0400

    misc coverity warnings

commit feed6eeb0e7e7cb0e300e32d85b79cec73658c2a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:52:56 2016 -0400

    ->generate for nfc

commit 57071b9d752de3f40f21777df832e41c29a6a493
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:48:33 2016 -0400

    ->generate for CAN

commit 2cde944fe1fa808c268b245e6355eaac83b2fe7a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:42:11 2016 -0400

    ->generate for unix sockets

commit 0f6caf1fd82eba51dc45d84479fd7ebc4166712a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:39:39 2016 -0400

    ->generate for bluetooth

commit 81bb32f6630f2f028e2f1a1260b12adcf6d90892
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:28:44 2016 -0400

    ->generate for IPX

commit 650f4c18aae810b4dfee4d67990354510ec02159
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:25:54 2016 -0400

    when comparing PF names, take the length into account.

commit 743ee32a3b99ea7e1c11f4377e6c13300aa4a4cb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:23:49 2016 -0400

    ->generate for atm

commit 1a0b370aaf7e946d3741c5425a3e31bea1defa4a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:07:57 2016 -0400

    ->generate for ax25

commit 7f4fa16a7e9561a5b627ff711050a3299495aadb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 16:01:25 2016 -0400

    eat whitespace

commit c60bb9e976561970afc7397308567ce7e9ce825c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 15:29:37 2016 -0400

    print number of unknown protocol/types

commit 14ef7ec8ed8175b5adb759980ea432cceaa288d7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 15:02:44 2016 -0400

    fix -E to work when no -P is passed

commit 98e987a34898e135d410a5ba924a40ef25a989c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 14:54:52 2016 -0400

    ->generate for netlink

commit 83f14a2906f9f83c2ef6c1f1f1389286684bab9b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 14:44:13 2016 -0400

    ->generate for IRDA

commit b9e3a9d5f74562c53c658b226673f086f8fe9736
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 11:00:34 2016 -0400

    make sendmsg pass in more sensible iovecs
    
    also the msg_flags arg is apparently ignored, so leave it 0 most the time

commit 475eaf918a00ee30cd37c6668c7a8af4f9d3263d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 10:42:39 2016 -0400

    scope reduction

commit 8a3c9e18d25ff3cbfebad6a7d8ad68435aa12bc4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 18 10:41:22 2016 -0400

    fix uninitialized use of .type in socketcall

commit d4f6f98967ab8d9cb38d10b139d82902d2181ff6
Author: Vince Weaver <vincent.weaver@maine.edu>
Date:   Wed Aug 17 13:14:20 2016 -0400

    perf_event_open fix unexpected char warning
    
    The perf_event_open code parses some files under /sys
    There are some hex values there, traditionally these were all lowercase
    but on RaspberryPi2 machines for whatever reason they use uppercase.
    
    This led to warnings like this:
    
        Unexpected char A
        Unexpected char D
        Unexpected char D
        Unexpected char B
    
    Signed-off-by: Vince Weaver <vincent.weaver@maine.edu>

commit 73b51799f7b0248056c106082477eb4bf2ca78a2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 21:42:34 2016 -0400

    pass the protocol family down to generate_sockaddr from sendmsg()

commit 6aeaa6ec1f3e1f5bc5e8ffcdb55af6dc736722b3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 21:18:49 2016 -0400

    remove duplicate get_argval function

commit 5dc766502c816c0ff3bcf083df16e046d0c8327d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 21:03:56 2016 -0400

    fill out flowinfo & scope id for ipv6 sockaddr

commit 82574abd60740c1a70b139068a50cfdffaff445c
Author: Vince Weaver <vincent.weaver@maine.edu>
Date:   Wed Aug 17 20:23:49 2016 -0400

    perf_event_open: update to features in 4.8-rc2
    
    This patch adds in the new ABI features found in 4.7 and 4.8-rc
    
    Signed-off-by: Vince Weaver <vincent.weaver@maine.edu>

commit 6ef294a4c039761f02a50a0e536935954c1336a4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 20:10:11 2016 -0400

    generalise the 'generate socket' routines.

commit cd5a452f05300bd0c23b8b9e3f8229f4eee7f3a9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 20:01:14 2016 -0400

    ->generate for appletalk

commit b40e58ff795c0105d7df31d357b714fcd925423f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 19:45:36 2016 -0400

    add a ->generate for ipv6

commit 3d9287d454e83f3c26777f4bbac900c66bd86787
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 17:58:42 2016 -0400

    handle ipv6 sockets in analyzer

commit d5f29cd01dce0e88328aee13f33f970e023d6a51
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 17:47:06 2016 -0400

    flesh out the ->generate function for IP packets

commit 5600b7a25abaa5d197590f272f18084b6e0381c3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 17:01:58 2016 -0400

    simplify rand_proto_type() using RAND_ARRAY
    
    The special casing for packet sockets isn't worth it.

commit bf49450565f071d7bf69675af8a6095da0644540
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 16:58:37 2016 -0400

    Fix up -P to generate at least 50 sockets.
    
    Killing off NR_SOCKET_FDS had this unfortunate side-effect that -P only
    created a half-dozen or so sockets.
    
    For now we'll reintroduce this nasty hard-coded limit.

commit 232ad5ab19af593dff4dee4376076e3b45293b10
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 16:57:21 2016 -0400

    If we get a zero byte socket cache, invalidate it.

commit 403c1261f605815974719096211689cf372cfe1b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 16:00:03 2016 -0400

    if the child pidstat file didn't open, don't try to close it.
    
    This can happen if we run out of file handles

commit d4ce5f34406cd51cb6faf73f503bd88328d8b944
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 15:29:06 2016 -0400

    remove debug code that crept in

commit 1f8a18693be0c9c2c88cfce7567b12da03992284
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 15:21:05 2016 -0400

    revamp the socket generation
    
    Instead of calling down to ->socket N times until we have enough sockets,
    call ->generate which will create N sockets.
    
    The advantage of doing it this way is that we get far less duplicate sockets.

commit f06319cce463fb87b025913f5880f51dbe061c3f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 12:03:08 2016 -0400

    move initial reseed out of fork_children into spawn_child
    
    Making spawn_child the only place we do reseeding.

commit 77e56117c79f3eeae880c5439601e65e2597d36f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 12:00:13 2016 -0400

    move periodic_work() after the seeding interval

commit 11a17e301f5f30ab577aef7bbd2111b67d6d6952
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 11:59:28 2016 -0400

    Prefer using getrandom() over urandom if available.

commit 9d1f58d78882a9f06404f742beb89c63506c704d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 11:47:55 2016 -0400

    socket(INET[6], IPPROTO_IP) can be multiple types.

commit c798e7099053412f060427e3507be34c584450bb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 11:41:46 2016 -0400

    add possible SOCK types for IP sockets

commit 577815638f1b52f64eee55498e017875a8ffdf7c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 11:38:18 2016 -0400

    only do raw sockets if we're running as root

commit 9d6190f4406924acfeb5977a0aa0b1b70e69e36e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 11:26:52 2016 -0400

    make PF matcher work on length of string passed in.
    
    We were matching 'INET6' as 'INET' because it appears earlier
    in the list.

commit 9e981daa797e5187e0172a37180586ec82d3b67d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Aug 13 00:26:54 2016 -0400

    remove masking of random seeds.
    
    Reducing entropy in the seed isn't a good idea, we end up re-using
    a lot of the lower numbered seeds.

commit f07a51551698d878797ac2887ed1b21fc7ff575b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 10:40:42 2016 -0400

    tweak localhost bias to be 90%

commit d5d1075236557414df597210fa7b426d80e3acc0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 17 10:38:51 2016 -0400

    remove all the server_addr stuff
    
    It wasn't particularly useful in this form. Eventually I'll do something
    better here, but for now we'll rely on localhost

commit 62ec5b0504e7804c49cd32f5b1c2ea94e447a35b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 14:15:10 2016 -0400

    move all the results related code out to separate file

commit 88a87b1034dd705f6aded972e1e4473988277e69
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 14:01:19 2016 -0400

    store results for ARG_LEN

commit e3dba430e08679e22cec38afcaf114336a9b66f5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 13:50:28 2016 -0400

    rewrite ->store routines to take a pointer to the result struct to update
    
    This avoids having to duplicate the argnum switch in every ->store

commit 4a36d22d3290f75b3a61c924ccf6dacb9e79e3e8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 13:23:07 2016 -0400

    remove implied local variable name

commit f4e320ebda77939d44ae6f5dfd6cff6728372ce1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 13:12:23 2016 -0400

    store results of which file descriptors a given syscall succeeded with.
    
    This will later be used to avoid using fd's that block, or fail in some
    other way.

commit e324ce2d66fc8d811738742fbb3a79e51c234d76
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 16 12:34:11 2016 -0400

    remove out of date comment about -n
    
    This arg doesn't exist any more.  This condition may be unnecessary now,
    but it's safe enough to leave it in case I change the path building code
    later.

commit 5ebc41c1bc4e16eba2c71c6169e10df1b7a11972
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 12 17:31:23 2016 -0400

    Fix a missing reseed point.
    
    We were only reseeding from fork_children(), so when we called
    spawn_child directly, we got a child with a seed we'd already used.

commit 7ec1889ede862687dd53469eb98ceea8b03c0217
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 12 15:10:14 2016 -0400

    dump the stack of any 'stuck' children.

commit ecf6dfd83d4c886d78d4605163cb8c3f1728db62
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 12 15:05:01 2016 -0400

    if we haven't done a syscall yet, treat child as "making progress".
    
    Chances are that we haven't been scheduled because some other
    children are hogging the cpu.

commit 7475c7ad0ff107f7112d4b7d660ca26dcb61ad71
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 12 09:36:03 2016 -0400

    shut up coverity.

commit 3ac0b187703d7a1d12d38b33efefebc74f03da40
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 11 18:13:23 2016 -0400

    check for NULL protocol ptrs

commit de4de2d55f055df7b854f00cc9cf33beee148a89
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 11 17:41:11 2016 -0400

    give equal chance to mmap exclusive flags with/without extra flags

commit 3ae85e02f6776e0f02df544c48d6820ed8c4a945
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 11 17:38:20 2016 -0400

    rewrite PACKET_RX_RING support
    
    For now we just support v3 of the packet format.
    This at least gets us able to trigger the tcpdump bug that was
    reported in 4.8-rc

commit d1390caa6146910c95786fc78aa38ea0dc141b09
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Aug 11 17:37:28 2016 -0400

    Add a hook for protocols to call post socket()
    
    Sometimes we might want to always call certain setsockopt's on
    a created socket.

commit ac65d70b42944ff572aea2c5fcb508620405a62b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 10 18:20:13 2016 -0400

    fix segfault when specifying multiple -c's
    
    We now need to care about NULL's in the syscall table.

commit 9a1e242e77915510081d3d9b765af00411ec3fbd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 10 18:03:41 2016 -0400

    mmap sanitize can use simplified 'size' setting

commit 7f06c6edf50bb772f8d0e9729946d3f2e0a46059
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 10 18:03:06 2016 -0400

    make IPPROTO_IP sockets be type DGRAM

commit a01dc8b28fc836c5628cf967f52bfa3ad1068037
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 10 18:01:19 2016 -0400

    remove the 4MB mapping
    
    This is pretty pointless, because no-one cares about !PAE 32bit x86

commit c8a03b87dcbe5c12119a01d2ee742c779e6ffa91
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Aug 10 17:52:33 2016 -0400

    secret option to skip the delay when run as root

commit fbe7d7c38197132980cdf3c8e3528bd0cef25f2a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 15:25:36 2016 -0400

    Add initial support for kcov functionality.
    
    This doesn't do anything yet, and is more or less just a carbon-copy
    of the code in the kernels Documentation directory.  Landing this now
    for further experimentation later.

commit bc97bc35f26f1ba2f263a2628866155915709569
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 13:51:29 2016 -0400

    remove the pause in the parent before we wait for the child.
    
    It isn't necessary due to the other syscalls

commit 44db6756c3658c5eb6fa8b28eb785ea61dffb813
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 11:47:57 2016 -0400

    dump errno if we fail to fork a child

commit ee17c3c6028bd9d33a17e83237289840e29b92e6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 11:47:22 2016 -0400

    forcing an unlock is a bad idea, just wait a little longer.

commit fb3e7bc04ef995c4cf091219c938946290c71126
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 11:46:41 2016 -0400

    exit child on SIGHUP

commit d19438e250e56530d8d0576c1906393dbd878fde
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 11:45:53 2016 -0400

    factor out the "do syscall in child" code

commit 05bc6bbf779525574870267b99d798c16c758e2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 9 11:28:02 2016 -0400

    Fix dumb typo in bpf configure check

commit 08c9d6d3faac0ab0f7b20dcc02113bcf096ac065
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 8 13:51:12 2016 -0400

    fd provider for bpf maps
    
    so far, just supports array types

commit 177317f8e827151d68addb9cc0337ef0d173018f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Aug 5 14:41:17 2016 -0400

    Check for existence of linux/bpf.h
    
    This is a little more involved, due to us now needing to handle
    holes in the syscall table when something isn't defined.
    
    Based on an initial patch from Vinson Lee <vlee@freedesktop.org>

commit 2fbc368ffb65717016d69d0cc135ccb12e614ac3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 2 09:55:33 2016 -0400

    force unlock 'stuck' locks.
    
    don't wait for it to unlock, because the unlocker may be dead.

commit b1bb1028f8faf7f7f612f8137bc0bbbddf54ece8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 2 00:10:55 2016 -0400

    add support for TCP_REPAIR_WINDOW

commit 616f9953a7daa2f7c209af7934ffafde4acd8bc8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 1 23:50:12 2016 -0400

    Check for 0 pid when encountering locked lock
    
    Because the pid zeroing happens before we set the lock back to UNLOCKED,
    there's a tiny window where we end up with a locked lock with no owner.
    Just recheck, and we'll get it right next time around.

commit b241797b5151887d0683e81492c4bd60579dd5cc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jul 29 11:54:57 2016 -0400

    pass the signal from the sighandler using siglongjmp instead of global var

commit 1b498f616f945babc7c449b22e442c327043ff92
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 17:31:00 2016 -0400

    Add extra local var to make handle_childsig more readable

commit 40ab1d3197c8afec43d7171f198e363c23688e79
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 17:29:00 2016 -0400

    The 1GB mappings cause oom's too much, disable them most the time

commit a9eadb7c983cd62bb7d75a2024b01a8925ed1a80
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 17:28:20 2016 -0400

    make the backtrace code work with the main process too

commit 2339c4910682711f972dbd5c3cd154ce91b6df79
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 17:26:03 2016 -0400

    silence annoying cppcheck warning

commit fc67eb0840e5ffae71a6253c4502b17e26f2fdf9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 17:07:28 2016 -0400

    grand-child forking code needs to handle errors

commit 66fde990bc151b0cc7522c49e025714898cd1bff
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 15:30:13 2016 -0400

    replace kill() invocations with kill_pid

commit 70127bfd7e44c8fa8167ba6e844b9eefc488849c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 13:51:13 2016 -0400

    replace open-coded pid_alive

commit 6e71177ae2a6978d69a5e087963fe03fa809f6c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 13:13:09 2016 -0400

    pid_alive is a boolean thing, so make it return bool

commit e56924c4ba7288fd1b1ff5400d672334391961c0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 13:02:40 2016 -0400

    check child is alive before we bomb it with SIGKILLs
    
    also tweak delays

commit 1263564e0ef261cfcb7cdeed4c867562cdd465ed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 28 12:23:09 2016 -0400

    fix misplaced bracket in dump_childnos

commit ee76fc3aaf78518a0e06b3e88bedd12c0e87a262
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jul 26 11:38:36 2016 -0400

    sanitise add_key type argument

commit 157637dae5cbe4413020861ff04ccd8b4f0fa366
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jul 26 11:14:16 2016 -0400

    remove all the 'unknown errno' checking.
    
    It's a huge task to get even a partial coverage here, and it's not
    particularly useful, and slows things down unnecessarily.

commit e405aa7ee24923c2fa492dd723c090bf3ebcdede
Author: Fabien Siron <fabien.siron@epita.fr>
Date:   Tue Jul 5 10:02:46 2016 +0000

    net/proto-unix.c: set protocol to 0 in unix_rand_socket()
    
    The protocol of an AF_UNIX socket should be 0.
    
    Signed-off-by: Fabien Siron <fabien.siron@epita.fr>

commit 84dc4dd4f582e8951c85368643ab439af9eb8b18
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jun 3 16:01:51 2016 -0400

    Before falling back to gtod, try getrandom() if available.

commit d0dd97bb2f05662a07d1565b53f5fb6fccb3dae4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jun 3 15:48:05 2016 -0400

    if we use the fallback seed, don't use rand() yet.

commit b314824e300a4fb09cee9b4fad8a7f8b2801bd38
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 17:36:41 2016 -0400

    fix wrong variable name in childops wait

commit f34ebf964687b334ba483b9004364b78a846df67
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 16:25:04 2016 -0400

    bpf: only do bpf_gen_filter for BPF_PROG_TYPE_SOCKET_FILTER

commit c79e0864840c51fff1e4eb87bd97384a59dc57bd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 15:59:39 2016 -0400

    make the BPF_PROG_LOAD case look more sane
    
    This passes in a sensible looking bpf_attr.
    bpf_gen_filter is the wrong thing to use here, some refactoring needed.

commit b7d645c4c985d9b272a6e785380a34da5d84dc57
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 14:33:09 2016 -0400

    introduce object types for bpf maps & progs

commit c328cdcda9d47844fec025c13b3dbadccb22cd8b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 14:20:58 2016 -0400

    flesh out the bpf sanitiser a little.
    
    Lots to do here, including storing the fds in the object caches,
    and then later, using the map fds.

commit b659d6e2f2258b840f5aee1f5d1a30359ac7b683
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Thu May 26 00:05:24 2016 +0000

    fds/drm.c: Add forward declaration of struct.
    
    Fix build error.
    
      CC    fds/drm.o
    fds/drm.c: In function ‘open_drm_fds’:
    fds/drm.c:120:3: error: ‘drm_fd_provider’ undeclared (first use in this function)
       drm_fd_provider.enabled = FALSE;
       ^
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 06259c05da8e09594e196dbd57077130ce155b12
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 12:33:51 2016 -0400

    check for potential failure to acquire testfile fd.
    
    also, offsets are off_t's

commit 9a0a5ac6d12711ab8988700d85b05d4f82fb08e7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 26 12:31:58 2016 -0400

    fix memory leak on child fork failure.

commit b17a6f9163674cbe213440ddca93659c456e8ec1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed May 25 11:42:22 2016 -0400

    compile fix.
    
    forgot to git add yesterday, oops.

commit cbd7270994210421beaca9decb61102147a6fc33
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 24 15:49:52 2016 -0400

    for each random syscall, do one in an extra child too.
    
    idea here is two racing syscalls with the same inputs

commit 6532e89292164ec09962ab84dd2ebd4f506f0e20
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 24 15:49:11 2016 -0400

    Add a child-op to truncate one of the testfiles to a random size

commit 9a71ff0a25e91fada5e3cd9ead28d1b2282c575e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 24 13:46:45 2016 -0400

    Reactivate the use of 1GB mmaps if enough memory available.
    
    With the recent fixes in this area, this should be safe again
    
    also, fix another instance of 'wrong offset for 1gb mapping'

commit 93f1689da9083ed902b469153941525d79d4137a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 24 13:11:05 2016 -0400

    check the actual num/values, not the pointers

commit 74303be33819a1b3ef53887b5af0fd83183f8157
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 24 13:08:59 2016 -0400

    fix type in copy_file_range syscall definition.

commit 83af013b74b2239413bd012a39669a126912d024
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 13:49:02 2016 -0400

    bump the child progress indicator in set_dontkillme
    
    This is mostly for when we are unsetting it, as we could have spent
    some time dumping stack traces etc.

commit 02c98869fd47196655eb1447be25432057e2012d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 13:47:54 2016 -0400

    change set_dontkillme to take a child struct instead of a pid

commit d0affde28acac94aa4195aba3ce5db26dbcfd3cd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 13:00:41 2016 -0400

    fix up more clang detritus

commit 37aba5d803d6da20bfdd9a4004dd8e3ce2bdc798
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 12:49:31 2016 -0400

    shut up clang

commit 251739ce8c7c13968027d9bbeb4d05bc5e8b9c0d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 12:43:02 2016 -0400

    merge enable_fds_param/disable_fds_param into toggle_fds_param

commit d52a876a795edcd9a9c2231cfea45baced78cce4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 12:23:58 2016 -0400

    document how register_fd_provider gets run

commit bf2cea4e0b0acbf85bb006aee46b31eec7cb98e5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 12:21:09 2016 -0400

    include file cleanup
    
    after switching the fd providers to use constructors, clean up the
    leftover mess.

commit ad64c0acfc3884b8aac0cbe85d8278aaf4fc1257
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 12:15:43 2016 -0400

    Convert fd provider initialization to use constructors

commit 69dbf0489d0442e332c7b1566d7d3a9d8eea3277
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 20 11:26:40 2016 -0400

    if random_ipv4_address picked localhost last time, let it happen again.
    
    The ip_lifetime check happened too late, so we only had a 50/50 chance
    of getting localhost more than once.

commit 6f7e3f35a02ca482bcb246cdc6356a2ce9df246c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 19 14:07:59 2016 -0400

    add flags from 4.7 for preadv2/pwritev2

commit 93be60b2e449b913923ea57bec449bcde04f0e20
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 19 12:08:15 2016 -0400

    make setup_fd_providers silent, so it doesn't spew during -h

commit 271b3d469805621b088858262f533f995cc934d3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon May 16 12:58:58 2016 -0400

    split num_fd_providers_enabled into two vars.
    
    this was being used to mean "num of providers to enable"
    as well as "num of providers we _did_ enable" depending on
    whether --enable-fds= was passed.
    
    Splitting it into two vars makes the accounting easier

commit cad191604278df8e3f148638e6196f69c6694031
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 13 16:11:11 2016 -0400

    when disabling 1GB pages, just do nothing
    
    don't bother adding a second page_size mapping.

commit 928414a2734ac8bf8b5e1362ee57de6835355514
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 13 15:47:00 2016 -0400

    fix offset for 1GB pages.
    
    When I removed the 10MB mapping, I forgot to update this, despite
    the big fat comment.

commit 1856c2c04688e2cb8ac7438ee8aa0e0019aff632
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri May 13 15:44:28 2016 -0400

    print the error if the initial mmaps fail

commit 44bd034522a63e68cd721b82baa103510192bc0f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu May 12 14:58:24 2016 -0400

    only do the 'stuck syscall' info on children running random syscalls

commit 825b51cfe8fcbc7461c9a327411475ae481654c8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue May 10 13:42:39 2016 -0400

    don't call fcntl on -1 fd's

commit ac2997db26011a45287d9cf69b2f4455c2b4a1a5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 13:48:19 2016 -0400

    Introduce 'root child ops'.
    
    Make 'drop privs' be the first possible operation a root process can do.
    After calling this, a child will then fall back to calling only
    !root operations.

commit 8364483cc4df0ad88872ff6aaaa7c93d14a846e2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 11:35:11 2016 -0400

    rewrite set_new_op to take ptrs to alternative childops.

commit 8fb7bdfe2c95cb9d06ecc4f8a8605757aa6ce79a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 11:31:33 2016 -0400

    factor out the 'set new op' code to a separate function

commit 01f451207652e5335d170177adf0bb18335a0797
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 11:12:38 2016 -0400

    set a flag in the child struct when we've dropped privs

commit adc72d6121288be4f9a1d7d8c3a1571acaf7f99f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 11:09:41 2016 -0400

    convert uid.c to use output() instead of outputerr()

commit acc095b6d7adbfc7b41ffbce1d3f3925d62da5d6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 26 11:07:35 2016 -0400

    reformat childop structs

commit 42d4847a0f82ce84795ab391e6920e60a1ac22d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Apr 25 09:12:47 2016 -0400

    fix leaks in thrash-pid-files

commit 3510cc8cb0f97c52f12623d461bf53d64a4bf3e1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Apr 24 17:53:30 2016 -0400

    add a 'read /proc/<pid>/status' childop
    
    simple beginnings. Eventually, I'll add support for hammering on all
    the /proc/<pid>/ files.

commit 642c47958aa91ccc80703882016a4eb163b952a2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Apr 24 17:51:49 2016 -0400

    bump the 'pick new op' counter even higher.

commit cf387d29bb9e622b776512080b65791be0c54abf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Apr 24 17:50:13 2016 -0400

    push the dropprivs code down into the child processes.
    
    * main process always retains root privs.
    * child processes will later get the option to retain root privs
      and run root-only ops.

commit b35eaf67b913eecd4ecd875d91e0624342cd0118
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Apr 24 10:09:36 2016 -0400

    define maximum size of ip_ssoptrs array

commit a8e000922be680a97e05546fd55259cc0fc6449c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 23 23:39:05 2016 -0400

    be careful not to read past the end of the ip_ssoptrs array
    
    If we create a socket with a protocol higher than that of
    IPPROTO_MAX, then we can screw up here, because we sometimes
    can call the ip setsockopt() on a non-ip socket.
    (see syscalls/setsockopt.c:do_random_sso)

commit 3d9ab352bf088ed88317ca92ecf0d7e19b48234d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 23 23:12:24 2016 -0400

    remove the 10MB initial mapping.
    
    It doesn't really serve any purpose the other mappings don't already cover

commit 2264cf7ac42a8aa6993f4d69687baeb06669aca8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 23 23:10:18 2016 -0400

    store the type of childop we're doing in the child struct

commit 34adf2c50845a761517827e9ad11cfbac70677da
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 23 22:51:31 2016 -0400

    remove the shm_rw debug code.
    
    It was racy, and has served its purpose.

commit d0089f1a0aec919ee87f9e799a6c3711a81386f6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 23 22:30:38 2016 -0400

    fix the 'pick new childop' code.
    
    multiple problems here.
    - Returning from signals would clobber the locals.
    - I forgot to decrement the counter
    - And forgot to reset it when we select an op.
    
    I don't know what was going on when I wrote this code, but it was
    pretty far from my greatest moment.

commit a8550b020b2f9f6cb2002b4b1b92157c480c281e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 22 01:12:31 2016 -0400

    change stats to count operations, not just syscalls

commit 7a31dd9ba8e4e0a0a55f9e3f49613602c55f772d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 20 02:03:02 2016 -0400

    Add new CLONE_NEWCGROUP flag

commit efe6f46925900c9d352d0460d3429948a45d2835
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 19 19:48:16 2016 -0400

    reset the child timestamp when we clean it out

commit 0d0c68ab29bbfbe234c09d6011cf7ecdb75e087e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Apr 19 18:50:10 2016 -0400

    reset the op ptr when we reach the loop counter.

commit ba1eee11129abf47143f4ccf675a8f170b3f8d43
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Apr 17 16:54:37 2016 -0400

    use fstat instead of lstat

commit 0f3dd2f7d850392a67555e7f3229da7d0e2d6e6b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 16 17:02:08 2016 -0400

    open/stat instead of stat/open

commit c1c503900e9995e9f6c75dec61194667fa2f253a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Apr 16 16:58:02 2016 -0400

    fix open() return code check

commit 6d751b3049a370bcd731e257f2718910861ef8ad
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 16:28:02 2016 -0400

    move op_nr from syscall record to childdata
    
    This is a progress indicator, and is child-type agnostic, so it
    doesn't belong in the syscall struct

commit cc6570c65903d5b0d8e4e27a50127c624a7c1f71
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:59:27 2016 -0400

    children/ -> childops/

commit c9cca6d4947ac81ad644ea32e6ec6a1c59a0809e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:57:05 2016 -0400

    update the prototypes for the read-all-files childop

commit daa4bf17a61044b77e73bfe963505d505b6ff16b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:45:24 2016 -0400

    repeat the previous childop 1000 times
    
    instead of potentially changing every iteration.

commit 5e4228da4b482be8e3043480b68b2763d952704a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:35:40 2016 -0400

    fix badly named child_random_syscalls()
    
    It only does a single syscall, and is a childop, not a child

commit 0635357a713eef4577c78da8a9ee3fdf8d6a96bb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:26:10 2016 -0400

    pass the child ptr down to the child op.

commit 3d49efc613b6d2902ac7a47e8840851aaf9a5125
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 15:02:14 2016 -0400

    change reap_child to take child struct
    
    iterating over the pid list when we know the
    child struct is a waste

commit 91c1e632776c8a2ce6f7677ee54eec2d636d48cf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 14:30:14 2016 -0400

    move the "child progressing" timestamp from the syscall rec to the child.
    
    This will be more useful when multiple child types are implemented.

commit bcfc86c513c72888cbb88a9eb6417675c71d421c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 14:29:49 2016 -0400

    decrement enabled fd provider count if one fails

commit 72396aa7888459987772fd0b1788c2b421b03739
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 14:29:16 2016 -0400

    add missing break's

commit 4cf405d07a4733ac9a377478619483d692c7758b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 15 14:03:15 2016 -0400

    perf: reset the failure counts if we succeed at all.

commit 8799ba00836caff9d2fa6babec714ae2bf2562cf
Author: iljavs <ivansprundel@ioactive.com>
Date:   Wed Apr 6 12:59:23 2016 -0700

    Update perf.c
    
    win10 LXcore always seems to return EINVAL for this, throwing trinity in an endless loop.

commit f2ecc0e9a94871ebd8f27daf390516d03a22fa1d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 8 14:39:39 2016 -0400

    rename ->send to ->gen_packet, and redefine args.
    
    This function will be used by sendmsg etc too, and we need to get
    back a ptr to a generated buffer, along with its size.

commit b94edace8fcb9f7d6039a3b5f9c0b68b588a098c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 8 12:52:19 2016 -0400

    Only pick a single netlink group
    
    From the man page:
    "Since Linux 2.6.13, messages can't be broadcast to multiple groups."

commit ff5a5b10a1fd14ed4a65125b5f825b6c6632e305
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 8 12:06:49 2016 -0400

    when per proto ->socket succeeds, indicate success so we don't fall back

commit 40d38f86cbfee1b1531b0be1369aee41cb569e67
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 8 12:05:40 2016 -0400

    add missing NETLINK_ROUTE decoding

commit 8b1122f982a61dde4183b15228974ad74f092251
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Apr 8 11:56:07 2016 -0400

    decode netlink protocols

commit 2f5fa17ef3e858e6c0f5d530b24613371032d3b4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Apr 7 10:42:37 2016 -0400

    if a proto's ->send is missing, fallback to random
    
    we returned too early, and ended up free'ing bad pointers.

commit f1f16f1c10373f32f31471b4e7dd6290ed1ea138
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 6 15:32:53 2016 -0400

    add MSG_BATCH flag

commit 048f6cd36f6ee576e05f1e435a3095472f40f538
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 6 15:29:22 2016 -0400

    add SO_CNX_ADVICE setsockopt

commit 3f338c2d18d411352f3c20d5794c3541bfd8ffb1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Apr 6 15:24:29 2016 -0400

    add pwritev2/preadv2

commit 729c2cb220831022fd9a6b1ef76eda743917c247
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Mar 31 15:30:44 2016 -0400

    add a ->send method to struct netproto

commit 21b08e7a999804fc0e7ad3f11beddcfd449c086c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 30 09:35:36 2016 -0400

    add l2tp to analyze-sockets

commit 2630751fb74b00c074788ebe8e21b85fa73d5e6e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 30 09:31:11 2016 -0400

    remove some noise from potential failures from unshare()

commit 6c791b39ec794c53e9294ec38c941fc82610da65
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 29 15:07:36 2016 -0400

    EBADF is a possible return from execve

commit 8543692ebbfc13986541789fbb2926da2637532b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 29 15:07:03 2016 -0400

    by default, start nr_cpus * 4 child processes.

commit 9ab78be27faba9053e20877d3c4fb30646a22f17
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 29 15:06:19 2016 -0400

    make get_new_random_fd bail early if no fd provider has finished yet.
    
    another rare deadlock.

commit 4e633ab7d46bb360e9061651204a0216002e055a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 29 11:31:48 2016 -0400

    use SOCK_RAW for IP sockets half the time.

commit c3c20277f2294ee46f996379d6dff6c0b9be51a4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 22 12:46:17 2016 -0700

    add bare-bones PF_KCM support

commit 1c49a2822097f67ccc60c2df5fc4a50d3f2ac873
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Thu Mar 17 12:08:31 2016 +0000

    upload to unstable

commit 4387f9f447486519d93f95586a549ce0f7a0514b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 15 16:01:18 2016 -0700

    remove unnecessary include

commit 49072463130406c5eacbdfb98bea7aa2d173e710
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Mar 15 16:00:40 2016 -0700

    add ext[234] ioctls

commit b24bc9b12be906962e354e5c7612dea680efeefe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 20:13:08 2016 -0400

    check for existence of btrfs ioctl headers

commit 6a5b4a8649b8fb17bc538795e699b29402d61cdf
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Mon Mar 14 16:54:15 2016 -0700

    net/proto-ipv4.c: Include limits.h as a workaround for older kernels.
    
    For example, CentOS 6 kernel-headers-2.6.32-573.18.1.el6.x86_64
    linux/netfilter_ipv4.h does not include limits.h and results in this
    build error.
    
      CC    net/proto-ipv4.o
    In file included from /usr/include/linux/netfilter_ipv4/ip_tables.h:20,
                     from net/proto-ipv4.c:12:
    /usr/include/linux/netfilter_ipv4.h:53: error: ‘INT_MIN’ undeclared here (not in a function)
    /usr/include/linux/netfilter_ipv4.h:64: error: ‘INT_MAX’ undeclared here (not in a function)
    
    This was fixed in upstream 3.2 598aaff2ee05c91728e5845956dd9754ed04315c.
    
    commit 598aaff2ee05c91728e5845956dd9754ed04315c
    Author: Ben Hutchings <ben@decadent.org.uk>
    Date:   Wed Aug 24 18:45:36 2011 +0000
    
        headers, netfilter: Add missing #include <limits.h> for userland
    
        Various headers use INT_MIN and INT_MAX, which are defined for
        userland in <limits.h>.
    
        Signed-off-by: Ben Hutchings <ben@decadent.org.uk>
        Acked-by: Patrick McHardy <kaber@trash.net>
        Signed-off-by: David S. Miller <davem@davemloft.net>
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 22622044f323bbc91609f0e52d91d3688cc0e0e6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 17:00:14 2016 -0700

    add VFS generic ioctls

commit 8b0b1220ce4cc5f5be8a7ff3177eb75bc6b13a2e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 16:34:01 2016 -0700

    allow for multiple ioctl definitions to succeed at fd_test
    
    This will be useful for eg for doing both VFS ioctls and BTRFS ioctls
    on the same fd.

commit f037dbd0515c33c504ffd6ef7e364cd4a6df1f07
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:49:34 2016 -0700

    mangle the random page we pass as an ioctl arg

commit c7343b0aadb91af2b0477744ad03a4fa087eb941
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:38:56 2016 -0700

    add btrfs ioctls

commit 14e75a6417383cd347efcd83bda01c7c5ec58c1d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:10:24 2016 -0700

    ioctl: make random arguments a bit more.. random.

commit 3a6ff062a8ff39d6b1f378468bea5b364513c8bb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 14:53:26 2016 -0700

    fill in some socket ioctl gaps

commit 02b3bf7df0d9247d51b3725b12e282ded1b6848e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 14:38:50 2016 -0700

    ioctl: move the rdev test later
    
    sockets weren't getting matched to the socket ioctls because they
    don't have a backing rdev

commit bbff560bff9b66f603dc3c79da20086ab4e64da5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 14:29:18 2016 -0700

    ioctl: allow 'pick random group' as a fallback.

commit a7e8ecf7147fffa9bca8bb24e9917fb1117f31a2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 14:26:53 2016 -0700

    simplify ioctl generic sanitise

commit bd9b58a142035d25e789ef1d33a6bc56eb8880fe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 16:09:48 2016 -0400

    sometimes unshare the userns on child startup

commit 2b1f865a892602fa3ac6ac445136d3db4752e962
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 16:07:57 2016 -0400

    let get_writable_address return some sysv shm objects

commit f8f487314f289543b4588b4c71a3cf333557c43a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 16:01:48 2016 -0400

    make mmap use a random fd for non-anon mmaps

commit 6f886cf69b5eed5dfeb6122f38f3a9649fb3e9e8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:59:52 2016 -0400

    when reaping dead children clean up zombies immediately.
    
    Without this, we don't get the shm->running_childs check
    working if all processes are in Z state

commit 0c2136c42a69b0d87b6509abbcef77a4ac791a64
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:59:19 2016 -0400

    teach perf_event_open how to pull from the perf fd cache

commit 9f40cf9f2e1826e07e3a8d98ceff21383a7e4ac6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 15:57:02 2016 -0400

    fix accounting of enabled fd providers.
    
    There was a possibility of an infinite loop here, because we were
    comparing against the number of known providers, instead of number
    of enabled providers.  Rewrite how we count enabled, and use that instead.

commit 24b0c8dcde6d0db77d61dd2e57ea226add68c4d8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 14 12:55:09 2016 -0700

    don't modify argv directly.
    
    operate on a copy instead when we munge it.

commit 58615a9d54b8357a285c90cb12f45dc39f90c5a6
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Mon Mar 14 10:17:16 2016 +0000

    new Debian release

commit 4a9a342c52ba30605673e04148ce7bdbd4484841
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Mon Mar 14 10:16:17 2016 +0000

    updated patch to build on mips

commit 1f5b0ccaf0ad5905c52adae0ccbf93f0d7711916
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Fri Mar 11 16:30:03 2016 -0800

    compat.h: Add SO_IP_SET for older distros.
    
      CC    net/proto-ipv4.o
    net/proto-ipv4.c:223:12: error: ‘SO_IP_SET’ undeclared here (not in a function)
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 81a029cafa71630f765adb9f34dc78c257cfc9d4
Author: Adrien Schildknecht <adrien+dev@schischi.me>
Date:   Thu Mar 10 15:31:49 2016 -0800

    net: include <linux/if.h> instead of <net/if.h>
    
    Commit 4ada80dd202675 includes net/if.h and linux/netfilter_ipv4/ip_tables.h
    net/* and linux/* should not be mixed.
    Debian Jessie x86_64:
      CC    net/proto-ipv4.o
      In file included from net/proto-ipv4.c:11:0:
      /usr/include/linux/if.h:71:2: error: redeclaration of enumerator 'IFF_UP'
        IFF_UP    = 1<<0,  /* sysfs */
      /usr/include/net/if.h:44:5: note: previous definition of 'IFF_UP' was here
        IFF_UP = 0x1,  /* Interface is up.  */
      [...]
    
    Signed-off-by: Adrien Schildknecht <adrien+dev@schischi.me>

commit 560b25d32f92cc34f305762da71afbdc0f3187dc
Author: Adrien Schildknecht <adrien+dev@schischi.me>
Date:   Thu Mar 10 14:56:55 2016 -0800

    compat.h: add SHM_NORESERVE flag
    
    Debian jessie MIPS build fix.
    sysv-shm.c:22:3: error: 'SHM_NORESERVE' undeclared (first use in this function)
       SHM_NORESERVE,
    
    https://sourceware.org/bugzilla/show_bug.cgi?id=17930
    
    Signed-off-by: Adrien Schildknecht <adrien+dev@schischi.me>

commit 8e0584879dd2f9bc41bad5cf19f722fdfa0b674e
Author: Adrien Schildknecht <adrien+dev@schischi.me>
Date:   Thu Mar 10 14:56:23 2016 -0800

    move x86 specific syscalls to x86 dir
    
    Signed-off-by: Adrien Schildknecht <adrien+dev@schischi.me>

commit 353ee4d4f9dbc615e1ad8ea65a1a481c8df301f9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 16:08:42 2016 -0800

    move child debugf into child code

commit ff58c4a70f262ce0fa4a5929551fdec02247ce73
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 16:08:06 2016 -0800

    move child cleanup to child.c too

commit 2ff781851d7ee1b1bfdf7a426c45c9e59d594f3a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 16:04:35 2016 -0800

    make init_child use the child struct passed in instead of searching for it

commit ad0f981cb4ff0e2319f279bc6f689f8381c2cafe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 16:03:37 2016 -0800

    keep init_child local to child.c

commit 115993aaa73566d9fb945494be599694e5bec356
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:40:11 2016 -0800

    add ipvs setsockopts

commit e2fc611d5f81878f713300ab7f1c7a847f87b449
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:37:35 2016 -0800

    add SO_IP_SET setsockopt
    
    ugh, this demuxes the command from the data passed in instead of it
    being multiple socket options. Something for later maybe

commit f39f129410207d838c66e1e3e35d049a8b2d4d4c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:34:40 2016 -0800

    add ip6tables setsockopts

commit 9985bd61e9aeb54316526f9f70e7e4139a7a73ed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:31:11 2016 -0800

    add the arptables setsockopts

commit 82cbfb238aaf34bfd3abf1cbf839e4dbd9484809
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:30:00 2016 -0800

    add the ebtables setsockopts

commit 4ada80dd2026756643b29c8d346b039ea9cd7f41
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 14:27:45 2016 -0800

    add the iptables setsockopts

commit 5d44f2c7a3b77ebb2fe38119dcd6d450c41ff3dd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 10:59:41 2016 -0800

    dump unannotated 32bit syscall table entries too
    
    add code to the 64bit path to only print entries not also in the 32bit table.

commit f311015bdddac1a60065256af8161a960c1ce771
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 10:54:18 2016 -0800

    fucking Makefiles, how do they work

commit a3aa4bd9bdd08c4bfe969a2fb4050473933fe150
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 10:40:29 2016 -0800

    add cppcheck target

commit dd03ae2b876d35234c53a7ef610bbbf03c77daae
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Mar 9 10:40:14 2016 -0800

    fix type-spew from cppcheck

commit edbf9bb55ea4cc491bc09e6eb8fe19d2955381d5
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:49:00 2016 +0000

    update upstream changelog and copyright

commit 9c97100c1d41d3608a2738cedca6acc614619684
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:39:39 2016 +0000

    upload to experimental

commit f70aa7b47f2e2bdef58bb99e7bde45a80a08edef
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:27:19 2016 +0000

    use secure URIs for VCS-* fields

commit 6da4ca94b3b089996d03286ea889f656f1df5b2c
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:12:04 2016 +0000

    document changes on d/control and d/compat

commit 45fd0e65544bcfe09edaee2db13b25079bf4fe97
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:11:36 2016 +0000

    increase debhelper compat level

commit fcfe40994393dfb2159eec17cc5d82eeb598929a
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 10:11:04 2016 +0000

    updated standards version

commit dfce5b3f6cf82ba5d1edd860b054bac3c982b49b
Author: gustavo panizzo <gfa@zumbi.com.ar>
Date:   Tue Mar 8 09:30:26 2016 +0000

    initial packaging

commit 8a0612d823dd65055714941f6be040be4ae3d35a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Mar 7 16:27:48 2016 -0800

    add some crappy code to find unannotated syscall args

commit 800bd3466aa9e6caa7caa58843fd690ebce3b8b7
Author: Michel Normand <normand@linux.vnet.ibm.com>
Date:   Tue Mar 1 17:53:03 2016 +0100

    syscalls/mlockall.c only define MCL_* if not already done
    
    required to avoid build errors on PowerPC.

commit d2fb10d1763cba2df6b9d4409cc09a07c17476c0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Feb 26 12:50:24 2016 -0500

    sanitize the cmd & buf args for shmctl

commit aa30ce391add0306c867bb9cfafd997bb8b53fdb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Feb 25 10:43:08 2016 -0500

    give up trying to open perf events if they keep failing with EPERM

commit 16397b63080fe8491868da91fcfab8fe525d33ff
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Feb 25 10:31:01 2016 -0500

    randomize fd provider initialization order

commit f41d662108863ff10cb10d0793b5f2a96b1bdce8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Feb 25 10:04:53 2016 -0500

    don't let get_random_fd run on uninitialized fd providers
    
    This triggered a segv on init when pppox needed an fd, and
    tried to get a pipe (which gets initialized _after_ socket init)

commit b91a4ef77da5a5b804e3f478879bb214883e5ab2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 24 18:10:14 2016 -0500

    rename.

commit e7275c6504851ed714c0990990abdf99afec6468
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 23 12:46:36 2016 -0500

    remove lock stealing leftovers

commit 0064f7558ea7041b1e1f01792d4bb4affbd755f3
Author: Artem Savkov <asavkov@redhat.com>
Date:   Wed Feb 17 17:20:39 2016 +0100

    Fix logging logic in output().
    
    Commit "preparation for different forms of logging." contained a typo that
    broke logging to mainlogfile.
    
    Signed-off-by: Artem Savkov <asavkov@redhat.com>

commit f4c49fb29de6932b2dcb019ee2ba40e867e486f7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 17 10:59:40 2016 -0500

    remove void * arithmetic in dirty_last_page

commit b8bc3a5fc4e8913630aee76601661e3a000a4e9f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 17 10:57:37 2016 -0500

    scope redux

commit dcfce4823a414318b63758cad7c9bbbb04df9cfe
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Feb 17 10:57:11 2016 -0500

    fix a rand64 case
    
    undefined behaviour shifting > width of type

commit 3ebd636144735adde1f3263c768978e2330cc64e
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Mon Feb 8 21:24:41 2016 +0100

    Makefile: Use -std=gnu99 if -std=gnu11 is not supported.
    
    -std=gnu11 is not available with gcc < 4.7.
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 31cef803a3a79d3bb26a1a19b805da12d7e457f1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Feb 4 11:13:20 2016 -0500

    resync crypto algs

commit 0207de22f08d6314be07722176e626355e14d727
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 2 15:30:45 2016 -0500

    fix up more out of bounds writes in the page-dirtying routines

commit 0cd4b515c4aa95320031a262c8f10df76e9291b3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 2 15:13:13 2016 -0500

    double check that we always have enough children running

commit 0b974c7d8335e7b9e94379941224ab8490d16491
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 2 13:31:08 2016 -0500

    Add some SYSV shm objects.
    
    These aren't used anywhere yet

commit 0583dbc0a112c924ea19dd289f6971d5364183fb
Author: Jiri Slaby <jslaby@suse.cz>
Date:   Tue Feb 2 13:25:21 2016 +0100

    net/protocols.c: fix build on old machines
    
    * include compat.h for PF_* constants
    * use PF_ALG only if USE_IF_ALG is defined
    
    Signed-off-by: Jiri Slaby <jslaby@suse.cz>

commit a53144d86f4b862d907b45f9cdf3fad421c2fdf4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 2 11:27:18 2016 -0500

    use TRINITY_PF_MAX instead of PF_MAX in array definitions.
    
    Older distributions may have a lower PF_MAX than we need.
    Pointed out by Jiri Slaby <jslaby@suse.cz>

commit 10031645562ca23e6fd7492100eb1b831449dda9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Feb 2 11:03:20 2016 -0500

    fix off-by-one in socket validation

commit 137a2d3387303c938408f63eeff00b9de1a579f4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Jan 31 20:18:22 2016 -0500

    reduce scoping

commit 73031324ef69081b8be0d55dc51de57f57aa7134
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Jan 31 20:15:46 2016 -0500

    create mmap's of the testfile fd's too

commit eb6b6e561dfb7dc8be8caa3812e2e90e0562aacc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 29 16:20:14 2016 -0500

    check the limit on the domain in the socket cache

commit 790f32889e53e3261f5600af4991ed9d029c5a6b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 21:19:44 2016 -0500

    go back to a state where get_map can't ever fail.
    
    This is too much of a pain in the ass to run around everywhere
    and handle fallbacks

commit 6a47b7f316491769dd6bd49728e79fd8e8b9a4ff
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:55:18 2016 -0500

    fix potential infinite loop in get_writable_address

commit a781db526a5f57eed12048a0b54978f7dc6714ae
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:53:03 2016 -0500

    mincore fails giant malloc's all the time, cap the max size at 1GB

commit 3113b1d263d976d4434862ae8930c2b0f8475a69
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:52:36 2016 -0500

    dirty_random_mapping needs to handle NULL get_map() results

commit acae380ccbffabd338a76b7571fcce82c50aebed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:07:50 2016 -0500

    make mmap'd files use their own object cache

commit 528344b52ef3d245ed57bd42f51180f61dd22227
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:06:26 2016 -0500

    make get_writable_address retry on failure.
    
    Again, an ugly hack. We could theoretically get stuck here
    if we've run out of writable mappings.

commit b6fcd4ab3c060b469fa8e4bf266622603fc23149
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:05:22 2016 -0500

    Move the file fd provider up so it runs first.
    
    This is kind of a hack, but makes sure we have some mmap's
    on the lists before the perf fd provider tries to grab some.

commit 7276c6ff77cda70f369e0b66c36097fc489ac2aa
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 20:05:00 2016 -0500

    rename OBJ_MMAP -> OBJ_MMAP_ANON

commit d59e1fe1449189a347b979b5a3447d0b218fa13e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 19:51:01 2016 -0500

    allow get_map to return NULL
    
    if get_random_object fails, we shouldn't return 0x10

commit c17fbae6d68848007d69568ed2219ec08b86b589
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 18:57:17 2016 -0500

    change mmap_fd to take a global/child flag

commit a3ab7df996f95efa3cf32390c2c18c05ccc959f7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 18:46:42 2016 -0500

    move mmap_fd to maps.c

commit cf3c9324393b0f9d5bcf4688660e6619c202dbe3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 18:43:36 2016 -0500

    rename the TRINITY_MAP_ definitions

commit 85f7deac96cb48c109679872c157fe55447401de
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 18:35:28 2016 -0500

    remove debugging code

commit dd1d471e1f3775eccbd2c73b6e17039f377c95c7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 28 18:10:18 2016 -0500

    when creating file fd's, also created some mmap'd ptrs.

commit 6402c11220248e88a2cd255acb20f8ededb98275
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 27 20:37:40 2016 -0500

    add new EPOLLEXCLUSIVE flag to epoll_ctl

commit 3c4642ddb043416410215ea894c8e553be9b60ad
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:46:10 2016 -0500

    remove cut-n-paste mess from man page.

commit bcfce2fa39dc89ece4ba7732299738d020c8dec3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:44:35 2016 -0500

    constify sock_option members

commit 83f3345ccfd24177b57d13876ad9efdbc2099d23
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:42:20 2016 -0500

    move the INET related SOL_ options to proto-ipv4

commit 113cb1cb71e595ee8e26ca08fb424ae0f654ffd1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:41:25 2016 -0500

    move SOL_NFC local to where it's used

commit 9462dc1d579aa502450cfc24ee5a78522ec49223
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:40:57 2016 -0500

    move SOL_ALG local to where it's used

commit 787c960f4fc0231814f290f4a1b116d658d7a608
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:40:21 2016 -0500

    move SOL_CAIF local to where it's used

commit b0f40cc30a13c77fb3e35b3329b2cb7f4bc57549
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:39:56 2016 -0500

    move SOL_IUCV local to where it's used

commit d79c05a1258ad52c7fc52e34f1226833818da425
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:39:26 2016 -0500

    move SOL_RDS local to where it's used

commit 645aa378ce0247df8390115043ebf23e70d33f93
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:38:49 2016 -0500

    move SOL_PNPIPE local to where it's used

commit 728abecee0c8da8d5e09fcd0718efa0801c95e80
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:37:45 2016 -0500

    move SOL_BLUETOOTH local to where it's used

commit 58c08b0e07116a4183552267fe1e3cdd6369dced
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:37:04 2016 -0500

    move SOL_PPPOL2TP local to where it's used

commit ce520196aed53b0e01de9e0de3bc4659c79f0bfa
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:36:27 2016 -0500

    move SOL_RXRPC local to where it's used

commit c97a304c679ad1f9cf345fa1cddbee66d46a2897
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:35:42 2016 -0500

    move SOL_NETLINK define to where it's used

commit b1985051f32586c53635b5b29e2afdf410c3de3e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:35:00 2016 -0500

    keep the LLC/NETBEUI defines local to where they're used

commit f83191770ce06750c1e752ef447aec10acc1e741
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:28:55 2016 -0500

    move compatiblity defines out of net.h into compat.h

commit c495e71f2c485755900d471d6cea7329bc77d07c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 18:26:18 2016 -0500

    constify struct netproto

commit 35611a165510e97f78cb19a14b9aa62c034db077
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 17:08:55 2016 -0500

    remove no longer necessary includes

commit 3e03295c7ba304325864b11b0ec02890788058c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:57:31 2016 -0500

    header cleanup

commit e207f8a7eaa8487cbebf38267a671237f2613b70
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:55:24 2016 -0500

    convert PF_NFC to use gen_sockaddr and remove now unneeded code.

commit 10f69f76860ccfad99569073fdc9eeb0cb00fde5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:52:45 2016 -0500

    convert PF_ALG to use gen_sockaddr

commit 96f55c44f5657f9a5d126e3673896d3843edaa97
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:51:30 2016 -0500

    convert PF_CAIF to use gen_sockaddr

commit 79e7fef94ea1f553ecc8b71c13605cdd5710e08f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:50:42 2016 -0500

    convert PF_PHONET to use gen_sockaddr

commit 77ada88a7a1c0014b6051ab8c53740e4da32b238
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:50:01 2016 -0500

    convert PF_TIPC to use gen_sockaddr

commit 0c18a057be993f0c1cb5df79ed788403f9098609
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:49:20 2016 -0500

    convert PF_CAN to use gen_sockaddr

commit 854ad493a33d192c8a3002f6cec556ff77083c51
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:45:46 2016 -0500

    convert PF_PPPOX to use gen_sockaddr

commit c4aff6f453796498d2309d75e740c14ac8989fca
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:45:00 2016 -0500

    convert PF_IRDA to use gen_sockaddr

commit f3a7941f44ee93cd1eadb8755302b877360484e2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:44:19 2016 -0500

    convert PF_RDS to use gen_sockaddr

commit e44b9257467e4de3fc31b5be155480437257ac9c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:43:32 2016 -0500

    convert PF_ECONET to use struct netproto

commit 9703c3b534c00f05f52a0c62e53e26ad65f171dc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:41:20 2016 -0500

    convert PF_PACKET to use gen_sockaddr

commit 541d68fa6bf004553386cc6e623ea93555178915
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:40:21 2016 -0500

    convert PF_NETLINK to use gen_sockaddr

commit a378fad7a65f465d67c5e140919d397e53ac2688
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:38:59 2016 -0500

    convert PF_NETBEUI and PF_LLC to use gen_sockaddr
    
    given they both share the llc routine, just fold proto_netbeui.c
    into proto-llc.c

commit d457c5d7a3e72ffb4b13fcc63836e514a0546b2d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:30:28 2016 -0500

    convert PF_DECNET to use gen_sockaddr

commit a4b987ef2ca12d47c5ed13b7930fd08928c268ed
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:29:30 2016 -0500

    convert PF_ROSE to use gen_sockaddr

commit 1895a2c61cace77d654af1cc455b48db260307e6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:28:49 2016 -0500

    convert PF_INET6 to use gen_sockaddr

commit 13bec99131dc25aa33abd6c95fad7a5dc4195f42
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:27:49 2016 -0500

    convert PF_X25 to use gen_sockaddr

commit 2e50eb842b525599880fc937c23481694f6b3978
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:26:56 2016 -0500

    convert PF_ATM[SVC|PVC] to use gen_sockaddr

commit 996ab382600a39a9b3aaca35092f8f2b76f8ac9c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:20:47 2016 -0500

    convert PF_ATALK to use gen_sockaddr

commit d788d4058e5969b481c8eed81cff8da79abf5046
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:19:50 2016 -0500

    convert PF_IPX to use gen_sockaddr

commit cc27d57644e0bb77ce131596ab19ec7a0794043c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:19:05 2016 -0500

    convert PF_AX25 to use gen_sockaddr

commit e899e8e5bc3d9dc5c125795fcf28448731aa54c4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:18:04 2016 -0500

    convert PF_INET to use gen_sockaddr

commit 23e984ac8b090a73534458bd4849fac0dbe02c1e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:16:47 2016 -0500

    convert PF_UNIX to use gen_sockaddr

commit cc72d0c1ed26ef1e4673c3722b65ae6f5455e2d2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 25 16:15:08 2016 -0500

    introduce a gen_sockaddr funcptr to netproto struct

commit 1de59ebe3d216d2d140f6c8dab1bfcf17b3267f3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 22 15:43:35 2016 -0500

    make perf fd generation ctrl-c'able

commit 4a93bf0d0c4f564d48770d63434515670893d15d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 22 15:37:03 2016 -0500

    consolidate two "print a number" routines.

commit 77ba85be8091b7992b40ed78eddeddff428ccfb0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 22 15:36:54 2016 -0500

    change -W to -Wextra

commit 9df7d5a53e7acd69b363ebd8d61861877ee6055a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 22 15:21:07 2016 -0500

    Move IP related stuff out of setsockopt.c into proto-ipv4.c
    
    This requires us to pass the triplet down, so that we can figure
    out which IP protocol we're talking, so this cset impacts all protocols.

commit 77a5c19bd21a6007978905e888e8a10be66aca46
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 22 14:34:17 2016 -0500

    pass -std=gnu11
    
    Some compilers gripe about the C11 features we were using like
    loop declarations.

commit 71bc8a11c9651c628531c16193f0523368e8c8d5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 17:27:30 2016 -0500

    check that we have a valid socket pointer before jumping to it.

commit 28c139cf1d87de0641ef699e11a93ab8e42c19d5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 17:09:57 2016 -0500

    kill off sso_funcptr
    
    This isn't needed now that we use ->setsockopt through the netproto

commit 96b0b286b38fbb7ba3286aca59575f03dbe39f4b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:26:58 2016 -0500

    convert PF_NFC to use struct netproto for setsockopt

commit e3b0902437588949a40fafe075087fa3eb05aee6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:25:25 2016 -0500

    convert PF_ALG to use struct netproto for setsockopt

commit d5358fc7d5ee340dd99301056d0fadde3d04abb0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:23:04 2016 -0500

    convert PF_CAIF to use struct netproto for setsockopt

commit 5e835913549e5f9efab3d4b90bbc779e3173f6df
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:21:33 2016 -0500

    convert PF_PHONET to use struct netproto for setsockopt

commit 05ce6aa75b83224dc5f884b475033e1efa6e30ca
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:19:45 2016 -0500

    convert PF_RXRPC to use struct netproto for setsockopt

commit b3ad01d5834b5f2e99eacf2c1628397581e5d69d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:17:50 2016 -0500

    convert PF_IUCV to use struct netproto for setsockopt

commit 4be32eab1b2f742c4b2bd55a7111b1ff43056694
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:15:55 2016 -0500

    convert PF_BLUETOOTH to use struct netproto for setsockopt

commit 31ca3650cbf320d221902b4c2379183704dad516
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:14:18 2016 -0500

    convert PF_TIPC to use struct netproto for setsockopt

commit f9587dac4279100f238c1817563f2ddc50c150a3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:13:11 2016 -0500

    convert PF_LLC to use struct netproto for setsockopt

commit 139a81781f33d73a15257072b8782db9b57fa836
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:06:53 2016 -0500

    convert PPPOX to use struct netproto

commit 27d0ec7651c04fb83663686cd04785cc1821f605
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:03:57 2016 -0500

    convert PF_IRDA to use struct netproto for setsockopt

commit a8da18886466d567ec2bce9aadec32356456c002
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:02:38 2016 -0500

    convert PF_RDS to use struct netproto for setsockopt

commit edbed290df479a89d9289ee649ce16a60cc01187
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 16:01:23 2016 -0500

    convert PF_PACKET to use struct netproto for setsockopt

commit 33432afcbceb6a4c5c6a1a151b3fd38aaccf6043
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:59:44 2016 -0500

    convert netlink setsockopt to use struct netproto

commit 50971bc57cd58b105f87e8dbd891ed4bae02ca10
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:58:38 2016 -0500

    convert PF_NETBEUI to use netproto struct

commit b5c1a946d8a6ee7988833662b83ad53c034d42a8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:55:28 2016 -0500

    convert DECNET to use struct netproto for setsockopt

commit 1b9df73b4baf3becf39e99b63bd3e5936038541f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:54:18 2016 -0500

    wire up the ATM proto ptrs to the proto struct

commit 21b503d7f9e86cc75071c0e0b5037b3df1ba703f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:52:02 2016 -0500

    convert ROSE to use netproto for setsockopt

commit a5c1e4122671d04cdba989bb6571d3c4fc04b6c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:49:25 2016 -0500

    convert INET6 setsockopt to use struct netproto

commit b2cf13a4da947255f4e5796d1d10d08551354f4d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:48:00 2016 -0500

    convert x25 to use struct netproto for setsockopt

commit 0557a9c7822193724db0bbac76c09d69dffa44ad
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:46:55 2016 -0500

    convert ATM to use struct netproto

commit aba6736bb6c96db2d0b9f9304071bb316a93fd13
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:44:33 2016 -0500

    convert netrom to use struct netproto

commit 461a127412250ad0317c8b610c33239b3269771c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:40:31 2016 -0500

    convert ATALK to use netproto setsockopt

commit fc5474b43c350db6de75cfc5e81319c7a6057a17
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:39:09 2016 -0500

    convert IPX setsockopt to use netproto

commit 3b4472030baeb428fcbb54c242ae765f033160a9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:37:44 2016 -0500

    as we did with ->socket, start converting setsockopt

commit d6874bc68d3255afaeaa7aacc474917f2e55e12f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:22:55 2016 -0500

    remove socket_ptr struct from syscalls/socket.c
    
    Now that we use the netproto structs exclusively, this is not needed.

commit 95c605bd38322335c985fb8fb9a360af2e22722f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:20:15 2016 -0500

    convert PF_NFC to use struct netproto

commit 3234b892e1d9b28a820dae6c0b419c5bfb367e38
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:18:53 2016 -0500

    convert PF_CAIF to use struct netproto

commit e512b99bc8762d0d6d03bdb3796973fb32999199
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:17:34 2016 -0500

    convert PF_PHONET to use struct netproto

commit 2e013525d08ddc96f9dd28af01668af651ab1d6d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:16:04 2016 -0500

    convert PF_BLUETOOTH to use struct netproto

commit 77d82e48d65db69092ba066c55dfc08de073bb74
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:14:47 2016 -0500

    convert PF_TIPC to use struct netproto

commit fda2a99ec1de7e98d48000c27436eaa209ca911d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:13:48 2016 -0500

    convert PF_CAN to use struct netproto

commit d10785f34cc53566724fc506d3b13ce14ea73f66
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:12:34 2016 -0500

    convert PF_LLC to use struct netproto

commit 236721333c77686cf956f1dc8c6bfed4f4c9e02a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:11:22 2016 -0500

    convert PF_IRDA to use struct netproto

commit 0524bbf9a634473ebdb7168e5bf2518c7f543a91
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:10:07 2016 -0500

    add ifdef around ipv6 parts of protocols.c

commit cb82a44c9348a5016c627818907a259d30f19b97
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:09:44 2016 -0500

    convert PF_RDS to use struct netproto

commit 15036f32b8e0152830195f722a7d7acc747a737e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:07:35 2016 -0500

    convert PF_PACKET to use struct netproto

commit 1dd439f9a90e717027d33b28907dd012f0e18e40
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:06:29 2016 -0500

    convert PF_DECnet to struct netproto

commit e56eb9ef3ffc1e1aefe50b1ec737b49eb92c9707
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:05:05 2016 -0500

    convert PF_INET6 to struct netproto

commit b2982041a98dcf277a95437f8706379ce360197b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:03:18 2016 -0500

    convert PF_X25 to struct netproto

commit 546a40fd032fff0b6ca2b8e87fe75a8b6cbcf091
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 15:01:47 2016 -0500

    convert PF_APPLETALK to use struct netproto

commit 3cf0e88a289e9757d953362f66414c70e726d026
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:58:43 2016 -0500

    fill in missing protocol ptrs from previous commits

commit f7709c6cc20475002ecd735c007d3549fb1ed1fc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:56:29 2016 -0500

    convert PF_IPX to use netproto struct

commit c891246a9746026a36113b30f7bd05758ddd9dca
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:55:24 2016 -0500

    convert AF_AX25 to use netproto struct

commit d21b555f92ebfc2478123230c130a4192b8168c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:53:19 2016 -0500

    convert AF_INET to use netproto struct

commit 8974b95c5109ed15c1d413c09ca16c02d8d28d4e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:50:11 2016 -0500

    convert AF_UNIX to use netproto struct

commit c61702e46a522d51b0df27ebf144ceeedc71ad82
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 14:46:38 2016 -0500

    start abstracting away per-protocol stuff
    
    socket.c shouldn't need to know directly about the individual protocols.
    Start by moving socket creation. Initially, just netlink.
    Eventually, things like setsockopt, and more will also move to the
    netproto struct.

commit 321e1793c75b540df8a8aba386d4162b01087a69
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 13:34:14 2016 -0500

    dump the fanotify flags too

commit 0d613839196636908df1089fb7bd910db32d75ee
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 13:11:19 2016 -0500

    fix broken cut-n-paste and add in missing bits for fanotify to work

commit 16334580741f97f8dc46aff8975b5cae2e1bcca3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 13:02:56 2016 -0500

    fd provider for fanotify

commit 1dd8464920b3852a6d90d98038b1865d336bd211
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 12:12:17 2016 -0500

    sanitise the 2nd arg of fanotify_init

commit 654c3e5f2c29cd0bbc69f30faa08c9b2b31a2618
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 11:42:09 2016 -0500

    add a userfaultfd provider

commit f14cd0bf71770f0e438431b37eb7a229972ca155
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 21 11:28:51 2016 -0500

    remove bogus comment. this is actually still true.

commit eb3563b0a214648601475b0d9103b3987a95234f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 20 22:11:55 2016 -0500

    add recent socket setsockopts

commit 2dc90ccfe3f7d2d6897f8dc4c36d6472b4b0882b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 20 22:07:33 2016 -0500

    add MADV_FREE flag

commit 9199173ac99b3b9c293ad6ee193f207a3eeddb47
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 20 19:22:30 2016 -0500

    the 'stop' argument to handle_childsig is a boolean

commit 6f51b21f17351969a1545dba3022f42788e3bb69
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 20 19:19:49 2016 -0500

    remove childpid parameter from handle_childsig

commit e25e11f227b2b9b13dccb082056bda2fae172e86
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 20 19:13:39 2016 -0500

    pass the childno down to handle_childsig
    
    rather than recompute it.

commit e9c4c0fc48c7d1835fccf75d10213417799d19b6
Author: Eric B Munson <emunson@akamai.com>
Date:   Wed Jan 20 14:51:12 2016 -0500

    Add MCL_ONFAULT to mlockall calls
    
    The new mlock2 system call was added, but it looks like the MCL_ONFAULT
    flag was missed.  This is now a valid flag to pass to mlockall(), but it
    must be used in conjunction with either MCL_CURRENT or MCL_FUTURE (or
    both).  Also rework the way that the flags value for mlockall() is
    caclulated.  It is valid to pass any combination of the MCL_* flags
    except for MCL_ONFAULT alone.
    
    Signed-off-by: Eric B Munson <emunson@akamai.com>
    Cc: Dave Jones <davej@codemonkey.org.uk>

commit d7907a0fc3e92f5e73cbdd6133d790920a35d8e4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 14:02:39 2016 -0500

    bias all three sizes in struct size generation equally
    
    Before, we favored putting them in the evaluation order.

commit 751cb910ed90cbe2b1d55fb7a7f6990575463109
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 13:54:10 2016 -0500

    allow rand16/rand32/rand64 to return RAND_BYTE

commit 28e2045d335cce4ee8eeb9f6865b06852f783e1b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 13:47:57 2016 -0500

    let rand64 call rand16
    
    and also call rand32 less often

commit 0ac9ed7a46a71111bef39c703232f395f5418ad2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 13:45:48 2016 -0500

    make rand32 sometimes return rand16 ranges

commit f52472c13e81d2d5c574b9b0440e28a444e1516c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 13:44:10 2016 -0500

    masking rand16 with 0xffff is the same as doing nothing
    
    change it to mask with 0xfff instead

commit 239063f979f08a3e2a172c2be781a07408be3998
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 12:55:46 2016 -0500

    fix rand16 to not shift out of range.
    
    It also didn't match the original intent of this case

commit 1940c04f896801a18fb5fcdbd1fec9f25012c61a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 12:42:51 2016 -0500

    fix stupid off-by-one

commit 50e6817b833944997d07997fc4163384f342a7a5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 12:35:47 2016 -0500

    case 7 can be up to 20 chars

commit fa58171f9d62cc56cc78b161721d61a95b1ca1b8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 12:35:07 2016 -0500

    use same null-terminator as elsewhere

commit eaa777f7030dfcdbe34d781100470d437b4117c6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 12:30:28 2016 -0500

    The higher page-scribblers only work with an even number of bytes

commit d79d06d2733c097acf77533d0bf7d24296a324de
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 19 11:54:44 2016 -0500

    more random 'random struct' generation.

commit 08b603f4fc8c3bfd8e530f45321780762f3ec8b5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 18 21:16:59 2016 -0500

    make struct fabricator work with less than a page

commit bc279bb3e97c36bad6d852731f16567d66bcd443
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 18 10:34:06 2016 -0500

    check buffer length before trying to do some of the longer generators

commit 0347350352967f862e602912d6c98b9d792db496
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Jan 17 22:06:14 2016 -0500

    merge generate_rand_bytes and generate_random_page
    
    More work to do here, probably broken in some cases, but it's a start

commit c919a75d6b6cd5699b4cf9853d21de8c02663cb0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sun Jan 17 21:44:05 2016 -0500

    consolidate "scribble stuff into a page" routines

commit 8cdbc6c686d1839924a02d4061b1e2da5afb476a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 15 15:48:57 2016 -0500

    fork new children as needed.
    
    This way we keep closer to max child count at all times.

commit 22c1567e3f7ddfe5d1abd9e9f028129240c65ae4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 15 13:14:33 2016 -0500

    spawn_child return a bool, not -1

commit 9b66709816d44224707c361fa7d87a9af62e8b27
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 15 13:11:03 2016 -0500

    update the pids array, not the local copy.

commit 8d195e3b7a8f8da02f027b2dadcde9b7541b9c91
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 15 12:47:53 2016 -0500

    use sigtimedwait with a 1s timeout instead of sleep(1)

commit 360686ac3d6f8973109c3ce11bd3a59daf95c4c7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 14 13:35:41 2016 -0500

    pid caching for the child code too

commit b9eda9d7e705e164e75fcefd779ff58c8c86a632
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 14 13:32:57 2016 -0500

    cache pid locally in various places instead of re-reading from pid array

commit b5174a416b6e64e62383b4ee5805108e25a78049
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 14 13:27:26 2016 -0500

    remove clearing of pid entry from clear_childdata
    
    This doesn't actually need moving, it's done by reap_child now

commit 61483a5ccfadecf9c727705388bc7611c069d81b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 14 11:57:27 2016 -0500

    move the pid back out of the child structure
    
    By reintroducing a global pidslot array we can do better locking
    when searching for EMPTY_PIDSLOT.  This isn't so much of an issue
    right now, but will be soon with some upcoming changes.

commit 22b1e304c0d8e4a374002be29b67e0df4ce8daf2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 13 12:18:41 2016 -0500

    add copy_file_range

commit a02f722dd1d3dba1506c34f8f857eecf4dbe0016
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 21:04:10 2016 -0500

    reset stall count before each recount.
    
    When this became a global I forgot to add something to clear it each time
    we do a recount.

commit 0fb3aa5a5ac78fa894092e8dc24926c323c50bf2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 16:30:14 2016 -0500

    use a better exit code when we fail sanity

commit d880a059ddf046eabcdff0fee791b6168ff9f1af
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 16:24:16 2016 -0500

    remove the lock-stealing mechanism
    
    This was a bad idea, and it's now unnecessary (hopefully)

commit fa8118572cdbc83fc2a154d6da4837a78b65396c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 16:20:31 2016 -0500

    remove the child sanity check for the tvsec progression
    
    Let's just do this in the main process.
    (It also fires too many false positives in the child)

commit 437400ba75c3e24888b9831d90f3f2a04af08966
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 16:17:55 2016 -0500

    count SIGXCPUs and exit after we see 100 of them.

commit 005f917e0a033e8c419d1dff0f46430a7d5825d9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 12 16:10:39 2016 -0500

    move responsibility of the clean out of the childdata from the child to main

commit c6119c1e6057bb67fc0032df068a46a502f6cf72
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 22:47:34 2016 -0500

    rewind the getline file pointer each time we read it.

commit e15055aaaec0594c4051c0eb99d6cd03503cd978
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 16:04:49 2016 -0500

    initial seeding cleanup
    
    - remove workaround for no-longer-around init process
    - main seeding now happens in init_shm

commit 6e94a0ae7369f566431aebd2dd352bba2a0c4f83
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 15:22:13 2016 -0500

    free the line after we parse it from /proc/pid/stat

commit 5932fddbc3ef0d8d55d89fa425d5fd15ebabbbfb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 15:21:40 2016 -0500

    cache the /proc/pid/stat fd for the lifetime of a child

commit b9dcd3ab94fa2616cff6312e98e6bc5a4fbcdc2a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:53:31 2016 -0500

    allow socket usage when using victim files

commit 0f30f4323703295b6586d3d9fdb9534a2a8c511e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:51:31 2016 -0500

    remove old FIXMEs

commit 2c3cdc0d60ab2593f4ce0876656b1a5e770f8ae0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:45:20 2016 -0500

    remove unnecessary print now that we only use one process

commit 5f22207c889140d9c0b15bae1ba50409ef849bc5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:43:56 2016 -0500

    remove duplicate set_seed(0) call
    
    left-overs from separate init/main process

commit a4680bfd693a62a2b73e35ebba97e1b2710699e7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:39:50 2016 -0500

    if we detect a stuck syscall blocking on an fd, don't reuse it.

commit ec6181ed36bc6f5e4f0d36162e625aa4496059be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 14:36:22 2016 -0500

    free pathnames post syscall

commit edd684339ead00bd262f9564fd7cdb5d5337143f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 12:38:50 2016 -0500

    check_child_progressing actually checks all children
    
    rename it.

commit d84490719df6dcafc3d6425bbac55e8c2b08e9a6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 12:38:31 2016 -0500

    move statistics printing out of check_child_progressing

commit 01cf58f0254a63b2ebdbc1a9698d587f127bdabf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 12:10:33 2016 -0500

    remove unnecessary clearing of mainpid

commit ba3605750d0b8da56aab1d35dcd3c4776cf9ccfc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 12:09:38 2016 -0500

    kill off initpid
    
    This is unnecessary now that init and main are the same process.

commit 8e0a313823cd01eb8acda8a32ca17e94f26c9bef
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 12:07:52 2016 -0500

    mainpid doesn't need to live in the shm any more
    
    Everything is now a descendant of the main process.

commit 8f0922f2da0c54b457d7cbab283b22513e62de1e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 11:52:43 2016 -0500

    Remove last_reaped
    
    There shouldn't be any way we can concurrently reap the same pid now.

commit ea345d8222946a8608ebd8320d4f7b0c769b0218
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 11:51:40 2016 -0500

    kill off the reaper lock
    
    This used to provide mutual exclusion between the watchdog process
    and the main process. Now that there is no separate watchdog process,
    this lock is redundant.

commit 8a6cb732eb8a869af9a3bb30964d2c515dd7769d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jan 11 11:24:21 2016 -0500

    split out a function to create a single child

commit 0c57388006ecbca98de5ddc6841a06a596bd3603
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 14:04:06 2016 -0500

    move fdstr clearing to later

commit 351650bb8411945fe0015f5b779c442bf8151e54
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 14:00:15 2016 -0500

    scope reduction

commit 9e504fe107ad068ec3fda3495ed2cc76101d3eee
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 10:41:27 2016 -0500

    don't bother SIGKILL'ing processes stuck in D state

commit 42ccfbcca651c9f4a9dcb3a3d0f89fe3e52539a3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 10:30:42 2016 -0500

    When reaping a child, release its syscall record lock.
    
    Not strictly necessary, as it would get cleaned up by check_all_locks()
    from the the main loop, but this cuts down 2-3 lines of log spew
    every time a child segv's while holding a lock.

commit a0db69f65c558d2684a0c2729b3b2535e37e7d84
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 10:27:38 2016 -0500

    make stuck_syscall_info non-blocking.
    
    A side-effect of removing the watchdog process is that now main_loop
    and all the functions it calls can't ever busy wait, or we get child
    processes stuck in zombies. This is catastrophic if they were holding
    a lock and segfaulted.

commit 7aa8cfc9524f61cfebd2846de6775eeac6210e75
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 10:26:05 2016 -0500

    introduce a trylock function

commit 884eafbcbe8e116327f84283ab0e9cbf9057050b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jan 8 00:20:41 2016 -0500

    syscall32 needs the shm writable.
    
    also, narrow the period that the shm is RO around 64-bit syscalls.

commit 1b1d784774369a43edcec2f8b94d776db529450f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 7 16:51:02 2016 -0500

    remove unnecessary break's
    
    With these in place, the *p=0 line is never reached.

commit 442fa4e1f9091c18c80d656a0dcf92eb5a46ccc3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 7 10:39:24 2016 -0500

    Drop the futex debugfs frobbing for now.
    
    It causes a ton of spew to stdout, and can't actually work
    unless you're running as root, without --dropprivs (which is a
    terrible idea).
    
    I'll add a root process later, and a means for children to communicate
    requests to it to do things like this on its behalf.

commit 44bac396a50b81319d41db0356b16b0900292d47
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 7 10:19:13 2016 -0500

    Remove the watchdog process.
    
    Have the work it used to do done by the main process instead.
    There's still room for improvement here, but this is a big step
    forward in terms of simplification, and allows a whole bunch of
    code & locking to just go away.
    
    There's also no longer a good reason to fork main_loop() as a separate
    process, so now we're back to a single process (for now).
    
    A big change here also is the 'reaping' of processes. This is now
    only ever done by the main process. The child no longer cleans up
    after itself (ugh, kids eh?) before it exits.  There's no watchdog
    process, so we can probably remove the reaper_lock now as a follow-up.

commit 3247f5c5b185d6a202e80144ddd1facba4ce958e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 7 10:10:38 2016 -0500

    dump pipe object info on startup

commit f21238a05cbf7ccb2464cbef0f41363e9fa51f7c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 6 20:09:24 2016 -0500

    Change main process so that it no longer blocks waiting for signals

commit 96c4eb08d6d60a2651fe9276a27592b3bb25cc9a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jan 7 10:22:36 2016 -0500

    accumulate the check_lock results instead of over-writing each time.
    
    Typo introduced in previous commit.

commit 962f70d6fde58f202fc85339d18acb4563f88cee
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 6 21:44:11 2016 -0500

    remove leftover debugging code.

commit 14655b6524145b70c0a0649b762eda43dd18b7c2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 6 17:22:43 2016 -0500

    add a dumb syslog() wrapper

commit 69b42fa0cd99d776a995449da8cfbb8c1a2d7569
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 6 17:18:55 2016 -0500

    remove unnecessary include

commit 8879ece3b24c38bea78813d48a91f733dbfc4039
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jan 6 17:10:08 2016 -0500

    move the resetting of a pid to EMPTY_PIDSLOT later.

commit 3c8e5e5ca3ca893bdd54bb947b4f3560ef53b98c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 22:32:46 2016 -0500

    start numbering testfiles from 1, not 0

commit 1620b181c8f73d019628b388295e8c274b1dd2d0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 18:17:05 2016 -0500

    two-step locking.
    
    There was a tiny race where a lock would show as LOCKED, but hadn't
    had its owner set yet. This would manifest by the watchdog finding
    locks owned by pid 0.

commit abcf1017d4ebf898ee44df3b8508afccba51a149
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 14:08:22 2016 -0500

    change the lock-checking to return a bool

commit fee8277677dcfb6d48cc56dae1748c54f50a2e90
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 01:13:19 2016 -0500

    signedness fix

commit 166a433d6816dff42a06ce5b3ad92706bc7a4d72
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 01:12:33 2016 -0500

    signedness fix

commit 3eeba24232bdabcc7a4871686ae134217c16788d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Jan 5 01:12:03 2016 -0500

    rewrite the random ascii number generator to be simpler

commit cca66d7ede02156f85a8536fbf5a1657b834a582
Author: Jiri Slaby <jslaby@suse.cz>
Date:   Mon Jan 4 12:21:31 2016 +0100

    Makefile: fix build with older glibc
    
    man 2 clock_gettime says:
    Link with -lrt (only for glibc versions before 2.17).
    
    If we do not do that, we get:
    post-mortem.c:61: undefined reference to `clock_gettime'
    syscall.o: In function `__do_syscall':
    syscall.c:121: undefined reference to `clock_gettime'
    watchdog.o: In function `is_child_making_progress':
    watchdog.c:317: undefined reference to `clock_gettime'
    
    So introduce (standard) LDLIBS into Makefile and add -lrt there.
    
    Signed-off-by: Jiri Slaby <jslaby@suse.cz>

commit 4d6144c53987566819959ad5fdb5be7b569e0a54
Author: Jiri Slaby <jslaby@suse.cz>
Date:   Mon Jan 4 12:21:30 2016 +0100

    compat.h: add more macros
    
    Some more RTNLGRP macros are not defined on SLE11 yet.
    
    [v2]: NVME_IOCTL_RESET is not defined on openSUSE 42.1. Include
    compat.h in ioctls/nvme.c.
    
    So define them in compat.h.
    
    Signed-off-by: Jiri Slaby <jslaby@suse.cz>

commit 6050c1cc3e09d6d99f0f61183fb8da9e1bc20086
Author: Kirill A. Shutemov <kirill.shutemov@linux.intel.com>
Date:   Wed Dec 30 02:36:12 2015 +0300

    convert syscall time tracking to CLOCK_MONOTONIC
    
    Commit e8646038d918 ("add some extra sanity checks inside the child
    process") made trinity near unusable for me: the rec->tv sanity check
    fails rather quickly after first syscall capable of changing wall time.
    
    The patch reworks trinity to use clock_gettime(CLOCK_MONOTONIC) instead
    of gettimeofday(). It makes trinity usable again.
    
    Signed-off-by: Kirill A. Shutemov <kirill.shutemov@linux.intel.com>

commit 40c64904cc3e24f41adb7ca0ad948bcfb9c0ee9e
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Mon Dec 28 08:17:06 2015 -0800

    futex: fix uaddr passing when dealing with lock
    
    We are working on the address of the futex word in our
    local lock structure. As such, we are currently passing
    it a completely bogus params for uaddr and uaddr2, which
    can be seen with the amount of unsuccessful futex calls.
    
    Also get rid of printing the addresses in the mmap'ed
    playground when creating our futexes, just show how many
    are created, no one really cares about these specifics,
    which can be seen/studied in the logs anyway.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit d987efb5bc9ba23e4f8117d00431be00803030a2
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Mon Dec 28 08:17:05 2015 -0800

    futex: fix private object segfault
    
    When doing a get_random_object() lookup, we can
    dereference a nil pointer in the local list. As
    such, always use the global variant to avoid
    crashing the child.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 1ab8aa36dae3ff8af304292b312938fddf718602
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 23 17:16:25 2015 -0500

    check for empty pidslots in stall_genocide
    
    This was a pain in the ass to track down. We were sigkill'ing
    a pid of -1, which took down everything.
    Amazingly, this has been there for six months, and only recently
    became a problem.  This is because children previously weren't
    running long enough, or getting stuck enough for this situation
    to arise that often.  With the recent segfault fixes, this
    function gets hit a lot more.

commit b4f40a2d9b83b258abceed9078e7f16f8d6dd8e7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 23 13:56:32 2015 -0500

    don't try to destroy empty lists

commit 37171f1c9139739dc683c78c7caa6535210d3f6e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 23 13:36:20 2015 -0500

    fix divide by zero in get_random_object

commit a9cdb6593eea88f54bc3f099144ffefbe6603100
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 18:16:07 2015 -0800

    RTNLGRP_NSID opensuse build fix.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 7372566441a515ebee66c5fa66089e679abfeb47
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 17:56:11 2015 -0800

    futex: fix post call make-it-fail
    
    ... the purpose is to clear the option.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 42de68f83cc32a80e6af4f00764da40620d57942
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 21:24:49 2015 -0500

    improve on the nvme.h test
    
    Some older versions of this header lack the ioctl definitions.

commit 708719ec8de89221bb71b201aaa26812f37497d8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 20:44:39 2015 -0500

    old habits die hard

commit f7346ecac3c8db036bdcd77eec89c372c2930b65
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 20:11:17 2015 -0500

    RTNLGRP_MPLS_ROUTE opensuse build fix.
    
    pointed out by Davidlohr Bueso

commit 0774c700ed4da79e876b78788c2d21ee7f1b72c5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 19:43:49 2015 -0500

    argh, forgot to add include/futex.h

commit 662b80805ecf2cea1586068722cdc74b5bfd33d8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 19:43:15 2015 -0500

    more scope reduction

commit dc26f8e31e59ff5dd6c7da7d5f16e17d6cbb2d34
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 13:14:25 2015 -0800

    futex: convert to object cache
    
    This allows better handling of the uaddr parameters we pass
    to futex(2). As such, teach the object structure about the
    internal lock primitive. We have two alternatives now, which
    replaces the current use lock or whatever trinity gives us
    as addresses. Now we continue using the lock half the time,
    but make use of the mmap playground already available otherwise.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit dcdcb333038e274400ad464178dda8c3ddbbdeb8
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 13:14:24 2015 -0800

    futex: trigger error injections
    
    Make use of futex support for artificially triggering errors
    within the various futex paths faults and deadlock scenarios,
    via the CONFIG_FAULT_INJECTION kernel framework along with the
    CONFIG_FAIL_FUTEX option. Trinity can make use of this feature
    by randomly toggling the process' make-it-fail file as well as
    selecting appropriate fault injection debugfs options.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 2b2e87e92a86d0720f572faae744ba345bc0496f
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 13:14:23 2015 -0800

    futex: FUTEX_WAIT can also use FUTEX_CLOCK_REALTIME
    
    FUTEX_WAIT is treated as a simple version for
    FUTEX_WAIT_BITSET internally (with a bitmask of
    FUTEX_BITSET_MATCH_ANY). As such there is no reason
    for regular wait calls not to make use of it. Update
    trinity to reflect the new kernel logic.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 25bae91882def7ea536e6b9ac33bcc834766f6a5
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Tue Dec 22 13:14:22 2015 -0800

    objects: rename no_objects
    
    ... and trivially simplify it while at it. no_objects()
    is slightly confusing regarding the name and I believe
    changing it to objects_empty() serves better.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 8e3e294003524516f86dc7dbb8d39225283e9515
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 14:54:00 2015 -0500

    scope reduction

commit ada55975ec2542cbb40395e64adda6cf257a0410
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 14:50:34 2015 -0500

    move all object creation/destruction to main out of init.

commit 8a31ab2b74613c825d50d6da9e6c66e9ab98705b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 14:47:52 2015 -0500

    move the socket shutdown code into destructors

commit 82eb06fbfdb2fc9bb16e92fe533cfa99735296c0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 14:41:00 2015 -0500

    make the mmap dumper generic, and move to objects.c
    
    This is useful for debugging. I'll clean up the TODO's later.

commit 6a5822c54a754b7a477fd5fecbc309d300edb38c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:30:05 2015 -0500

    wire up the pruner to potentially trigger when we add an object.

commit 039838dcc2652f1dd752cf774e1e9ed69f39b9d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:22:23 2015 -0500

    use get_objhead instead of open-coding

commit 1fb5e8bc1cbbbaaa10e246ee41e71689854e2816
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:19:28 2015 -0500

    child list creation can inherit destroy/max from global list

commit d9af62f2e26d62a9dcd2b83bc415c705f05ab754
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:15:54 2015 -0500

    move initialization of child lists into init_child

commit 2fe3df81b716b90bddbed468fef6185aed5280e7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:14:00 2015 -0500

    only prune lists that have reached their max length

commit d490294726da1796fddb06be416cc64bbc380452
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:10:44 2015 -0500

    genericise the destruction of global objects

commit 45ab7def1ba15cd4b6bd28c8440e00b47282edc6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 13:04:20 2015 -0500

    simplify prune_objects, have it iterate over all lists.

commit 8ac58621178dc21fb8f5864eeda1a58b53ebe7d9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 12:58:52 2015 -0500

    max_entries = 0 means "don't prune"

commit 65e18b2be8369646dc01f98e373b79213cb2fe16
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 12:48:17 2015 -0500

    add a simple garbage collector for old fd's etc.

commit e11d73682e11c36746b79e8be49f4bd56b623bf6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 12:05:06 2015 -0500

    make destroy_initial_mappings more generic

commit a8aa7dcfd456b3521e8d2c675056102302e846c9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 12:00:34 2015 -0500

    share the mmap destructor across local and global mappings

commit eb1ccbbaa6ae167f025e11268d6837f5e9dd75f5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:57:25 2015 -0500

    mmap destructor needs to munmap the mmap

commit 2661275b48b52643d63cf92bf5f583acfead115f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:56:46 2015 -0500

    use the mmap object destructor instead of open-coding it

commit 0b9dc1fff7d509e07c6c89251d8fb83b1863636c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:51:00 2015 -0500

    remove print spew from alloc_zero_mapping

commit e748e92bbc09c3cec39f0542540f1a8cb016c789
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:47:31 2015 -0500

    use alloc_object for all allocation of objects.

commit 158f0829f7197dea001183c735e771c10a65e76c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:43:30 2015 -0500

    add destructor for timerfd's

commit a022ae05fc4e05e2dce92bd37f6f672ca749f8bf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:42:24 2015 -0500

    add destructor for testfiles

commit 53713e12aa9f2e997ce3be788003b91d82a43dbc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:40:25 2015 -0500

    add destructor for sockets

commit 0f65e00638717bcfb6b1f7ff77076f4d8e17c19c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:36:47 2015 -0500

    add destructor for pipe fd's

commit 5b7754032a22d1c1521e49683150ae7a24e51a5a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:35:16 2015 -0500

    add destructor for perf fd's

commit 8cc9d3e68786374bbd87b462b8ed6e4ed9a8d29a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:34:05 2015 -0500

    add destructor for memfd's

commit 20da7fa85fb5476ea88dee90601b8a9422a2669f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:32:15 2015 -0500

    add destructor for inotify fd's

commit 04caa1c02d9d6bfa9fbb1765b558773b84854030
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:30:37 2015 -0500

    add destructor for filefd's

commit f71a1254e9e21a62448d2bbe6622a861c2867cd3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:27:31 2015 -0500

    add a destructor for drmfd's

commit e6ef3e03e14f18499ceb6d1641b9e639b405f256
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:25:49 2015 -0500

    add a destructor for eventfd's

commit 0e0cdce6106bd9105679f2ddfd6fb677eb96c98e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:22:39 2015 -0500

    add a destructor for epoll objects

commit d074e91c4cae4863084f8ed0f922aa6075490eb2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:22:25 2015 -0500

    export get_objhead

commit 12d85444984a9aa85d7f0e6a3f02c79f2e091f3f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 11:05:22 2015 -0500

    the busy-wait on watchdog startup is actually waiting for the shm

commit bff28f841dcc492e717e557f42c3cba1255ab351
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 22 00:09:17 2015 -0500

    split up watchdog() a little to move out the init code

commit eb75dedc7f9952da5ccc66947a63ebba60c7cbe7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 19:53:19 2015 -0500

    store inotify fd's created by children in child local list

commit 0734374379d0113ae5492a577623405e38c941e5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 19:49:42 2015 -0500

    mark return type for inotify init variants

commit ce8c2337e5be92f326dd1a3c4e7bb870dec6a61b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 19:48:59 2015 -0500

    merge both inotify_init variants into same file

commit 16e0722ed99e8ee93d48a2ad0b68a5fb39f66927
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 19:47:45 2015 -0500

    store eventfd's created by children in child local list

commit 14bfbbe9e4133e13e32dd142fb90bc9915270a8b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 16:24:46 2015 -0500

    store epollfd's created by children in child local list

commit 24de470e4629b2547ea23319bbd5a592a6c4cda7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 16:20:57 2015 -0500

    store fd from epoll creation in the right object cache

commit 84f895774ff39c268af70cc80df5a7d55584691b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 16:06:54 2015 -0500

    check for presence of linux/nvme before using it

commit e59291aed58602c402226549f17ced530bffb13f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 15:52:47 2015 -0500

    assume untainted if we fail to open the tainted sysctl

commit 4fa673ed193b11819f275ad15c9e51b0a09b92f6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 15:20:38 2015 -0500

    set the child number earlier.

commit ad0643f59c5e01f676d1d056dfb189f72fa86cd9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 15:05:14 2015 -0500

    remove the 'previous' syscall logging
    
    It's never been particularly helpful, and it's use will be obviated
    by the upcoming logging rewrite.

commit fa60add5242757d0449bbf9f55a7bb5366db94cc
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 13:13:59 2015 -0500

    creation of the child logfiles must happen in main pid.
    
    otherwise the watchdog can't fileno() them.

commit 397961a569231c73259131572cba531a179033b0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 20:48:14 2015 -0500

    improve msgrcv sanitise
    
    mark as NEED_ALARM, give it a non-null address, and set a smaller len.

commit 1cb54a7856dbfcb977350c38cf0e95c9942897e0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 20:46:50 2015 -0500

    ignore rt_sigsuspend. It's boring and just causes the child to hang

commit e5a5e576d8a8d083fc28e524efb36239e8f149d2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 21 12:59:28 2015 -0500

    remove noisy output from sigreturn

commit 4a302e24b9b334c9e9a8d94b39e78a15c4b8528d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 19:03:26 2015 -0500

    fix up straggler rand() -> rnd() conversions

commit 3f5eb372334a8c968554f8ee227aeee52f935e8a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 18:59:33 2015 -0500

    get rid of the RAND_32 / RAND_64 macros

commit c0c5d9edf3595bcba9950c123548cf189cb51330
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 18:35:44 2015 -0500

    I missed include/ in the rand -> rnd conversion

commit 663e440324176f7da04df9746220e037f4ba2f0a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 18:35:09 2015 -0500

    add missing includes of random.h
    
    These all use RAND_ARRAY, so are pulling this in indirectly.

commit 9952a51ded92d6e14972e1d2604f02a35dc7b894
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 18:29:44 2015 -0500

    simplify futex random array usage

commit 6ad0eb79ea25863d8c503b077fa2716657dbfa57
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 17:53:52 2015 -0500

    main process debug message cleanup

commit 94fd4ea839e32832137ed5e218d062051208d3e0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 17:41:15 2015 -0500

    Disable use of 1GB pages again
    
    Need to rethink this, as this causes a number of problems.

commit bf347f38a2599b88ee1887126f1a5ba964a9b7b1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 13:16:50 2015 -0500

    convert all rand() calls to rnd() wrapper
    
    This does nothing right now.  It'll make life easier later when
    switching to thread-safe variants of rand()
    
    bonus side-effect: it shuts coverity up forever about rand() calls.

commit f9811ed592d04c35c12a6b03cf05c31005f603c0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 12:09:56 2015 -0500

    now get_address can pick random mapping sizes

commit 46387deeb82a71a522b249a81cabc3e646b11b2e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 18 12:08:57 2015 -0500

    move mapping size calculation out of syscall into startup code

commit d184e9ac9d3599e740c92bdb4c262ce3959a9b92
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 17 17:46:23 2015 -0500

    further simplification.

commit e142f7ad926a41f015e1250601361a0dc28222e0
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 17 17:38:18 2015 -0500

    simplify get_address to the more useful cases

commit 174bfd24b3fd08701d62a8cd62039a6db872cb06
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 17 17:14:11 2015 -0500

    scope reduction

commit 1069bf0182dc36be03dabc96d5011872a2fcf80a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 16 14:13:06 2015 -0500

    cache the child struct ptr in the child main loop

commit 4f37acd2ec57860a3c7f6887336ebc2e47f0fd4d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 15 18:42:31 2015 -0500

    add a function to speed up bluetooth socket generation.

commit 848052ec421270753af95f091f9d1c82c64156da
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 15 18:41:15 2015 -0500

    factor out common code to obtain the right objhead ptr

commit 96f7375f1de9386dee01378b68a8087119e94dbf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 15 18:37:01 2015 -0500

    convert this_child to be a function instead of a global var.

commit 41d6098aaffbe511c133fa0704706bf38af40f8c
Author: Johannes Thumshirn <jthumshirn@suse.de>
Date:   Tue Dec 15 15:19:04 2015 +0100

    nvme ioctl support
    
    Add support for NVMe ioctls
    
    Signed-off-by: Johannes Thumshirn <jthumshirn@suse.de>

commit 1ccd4a9ae934aa1985c93069ac0e6faef53db35e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 16:16:19 2015 -0500

    when generating ipv[46] addresses, use localhost half the time.

commit 1f0c06495b9c19797a189a693c34adb57430cbb8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 14:46:54 2015 -0500

    move pathnames code out of fds as it doesn't provide fds.

commit f5ef75e73d3b5a9549da411dc8efa9d0d672daa3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 14:45:38 2015 -0500

    move generate_pathname into pathnames.c

commit c8113d10695983957a1738dbb2b9029404709a3f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 14:44:13 2015 -0500

    include file cleanup

commit 437be860a28e37837598f87e025cdc3468948946
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 14:38:24 2015 -0500

    separate the 'generate filelist' from 'open fds' code.

commit e3845568c4887393c0144f822b239311d4bc7392
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Dec 14 14:27:02 2015 -0500

    init the list head before adding it to the list.

commit 41a79274e79e0f5524e765a750fd3f1c255b845e
Author: Vicente Olivert Riera <Vincent.Riera@imgtec.com>
Date:   Mon Dec 14 14:51:54 2015 +0000

    mips: fix prctl's
    
    It looks like a typo in the syscalls/prctl.c file. It's lacking the PR_
    preffix, and due to that is causing build failures like this one:
    
      CC    syscalls/prctl.o
    syscalls/prctl.c:37:2: error: 'GET_FP_MODE' undeclared here (not in a
    function)
      GET_FP_MODE, SET_FP_MODE,
      ^
    syscalls/prctl.c:37:15: error: 'SET_FP_MODE' undeclared here (not
    in a function)
      GET_FP_MODE, SET_FP_MODE,
                   ^
    
    Signed-off-by: Vicente Olivert Riera <Vincent.Riera@imgtec.com>

commit c8ea635daff0137d680918e811bd522454af7c58
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 20:52:21 2015 -0500

    wrong indentation hid a bug that would cause early exit.

commit f780b9d336731ac01040b7f2143323691deb60c2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 15:44:14 2015 -0500

    factor out the code that determines which syscall to run

commit 976589bcd4cb9a90d2cb8b1055025de30db81a9b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 15:35:07 2015 -0500

    factor out the check sanity code

commit e4c8f48612ddbe6bfc81e0bdbf351cafee899c76
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 15:19:57 2015 -0500

    clean up the post-syscall sanity checks a little

commit c449703bf6ae6c8e794a4421b5203b073f1b0269
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 15:11:30 2015 -0500

    indentation fix

commit fdbff31e49ede02f1aeb8254117f4f47c45e1b99
Author: Vince Weaver <vincent.weaver@maine.edu>
Date:   Fri Dec 11 00:03:43 2015 -0500

    update perf_event_open support to 4.4-rc4
    
    Update the perf_event_open support to match the current
    4.4-rc4 kernel.
    
    Signed-off-by: Vince Weaver <vincent.weaver@maine.edu>

commit f5d9678e8467617b2926529bf391ac52a182464e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Dec 11 10:18:26 2015 -0500

    use rand32 instead of rand() for alg feat/mask

commit 3bffb03819734f8550ed9a064ab7a40980038e7d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 23:44:35 2015 -0500

    fill out the nl_groups field correctly for netlink sockaddrs

commit 48b747dd8ee9c5d3681a76829bedcf65dc6611ec
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 23:08:36 2015 -0500

    more alg_gen_sockaddr improving.
    
    duplication, but when the big struct gets split up, this will
    make more sense

commit 9671fe1600b99781e9eb760c97e787f050176030
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:58:07 2015 -0500

    reduce duplication in the check_if_fd function

commit 9432aa2e2d063f73207890366f1d5f36d213c7f7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:54:15 2015 -0500

    first pass at getting all the algos in for PF_ALG
    
    This is a mess, and needs cleaning up, but.. later.

commit b8ff7235ca316f47b8a3a55fc99effcda4f4f643
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:53:41 2015 -0500

    remove all the child related stuff from sigalarm handler

commit 8811d7f3710e307a8b056d7ff66f93ab70bdb0a6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:52:22 2015 -0500

    check_if_fd needs a return true if we have logging disabled too

commit 8fc6da24eb91b0ba1414f4b1c293a290a1648c79
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:46:36 2015 -0500

    fix prot tests

commit a71415428d06855416718e6adc6ba24bfe303dbb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 10 22:46:16 2015 -0500

    handle_sigreturn needs to write to the shm.

commit 9c01feaaec97ffb7fe6d1b05701b29296edc3beb
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Sat Dec 5 15:23:07 2015 -0800

    futex: pimp futex fuzzing
    
    Make futex fuzzing more ad-hoc and spice things up to improve
    testing coverage.  Roughly half the calls will use the generic
    arguments, with the occasional exception of using CLOCK_REALTIME,
    when applicable to the correct cmd (avoid -ENOSYS). The other half
    can perform anyone of the following operations, each with a ~25%
    chance, acting on at most two uaddresses from a small pool selected
    randomly.
     - Perform a pseudo trylock/unlock. Contended scenarios
        involve immediately blocking or doing a pi lock.
    
     - Wait/requeue, which pairs with one of the below wakes.
     - WAKE_OP, or,
     - a regular wake or directly requeueing.
    
    Additionally, update the TODO file as futexes are not (de)initialized,
    and we can just use the handful provided locality by futex.c. These are
    an array of locks which are used for the corresponding uaddresses requred
    by the system call.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 71ebf7842d7adc28ac1d37f39adb06dd2e9390f5
Author: Davidlohr Bueso <dave@stgolabs.net>
Date:   Sat Dec 5 15:23:06 2015 -0800

    futex: add _PRIVATE ops
    
    Extend futex_ops array to include coverage for private futexes
    (which do not share the addr space, and therefore faster wrt
    futexes). These are the same ops currently used, except with
    a xor'd FUTEX_PRIVATE_FLAG.
    
    Signed-off-by: Davidlohr Bueso <dbueso@suse.de>

commit 160868e87b002064ab86b016c410aaf890f08445
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Fri Dec 4 02:18:52 2015 -0800

    Remove unused variable in fds/drm.c.
    
    Fix build error with GCC 5.2.1.
    
      CC    fds/drm.o
    fds/drm.c: In function ‘open_drm_fds’:
    fds/drm.c:70:15: error: unused variable ‘i’ [-Werror=unused-variable]
      unsigned int i;
                   ^
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 92c59c46cf94c8d69eccbd5505884f37a5ff9488
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 3 14:27:22 2015 -0500

    Revert "compile with -Og when in development."
    
    This reverts commit 46cfc86b6b62a5f3a69f4693d2f61eda7bf7f6df.
    
    At least the gcc5 in debian produces horribly broken code with -Og
    Nice idea, but not ready for use.

commit 46cfc86b6b62a5f3a69f4693d2f61eda7bf7f6df
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Dec 3 12:11:17 2015 -0500

    compile with -Og when in development.

commit de1925683405d9add8e14d65aab2e0bd0155ba34
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Dec 2 16:24:52 2015 -0500

    post-syscall, ARG_SOCKETINFO becomes an fd, don't dereference it.

commit d8b6ad78c9f6dee4d806c4414129f0e7348b5343
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 1 13:04:53 2015 -0500

    watchdog needs to check SOCKETINFO fd's too.

commit 632cd349b645bf62bb4ee9c00701c03df6a1b06d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Dec 1 12:49:53 2015 -0500

    scope reduction

commit 7491348ced78154be7584252e185242c3192eeb5
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 30 16:10:41 2015 -0500

    move some unnecessary things out of the --dry-run path

commit d1a21d70e8efcaff0742c2e879b0bca0760ccf66
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 30 15:26:16 2015 -0500

    rename generic_fd_from_socketinfo -> fd_from_socketinfo

commit 29fb3354a339cda39537844b931a4dd56811e668
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 30 14:52:21 2015 -0500

    introduce shorthand 'no objects' helper

commit 61565ad10c907a109f8a53a7e49936a2407f65fa
Author: Vinson Lee <vlee@freedesktop.org>
Date:   Sun Nov 29 23:13:04 2015 -0800

    compat.h: Add NETLINK_SOCK_DIAG.
    
    Fix CentOS 6 build error.
    
      CC    net/proto-netlink.o
    net/proto-netlink.c: In function ‘netlink_rand_socket’:
    net/proto-netlink.c:49: error: ‘NETLINK_SOCK_DIAG’ undeclared (first use in this function)
    
    Signed-off-by: Vinson Lee <vlee@freedesktop.org>

commit 76d6ddf590cd3fe7da7ac1628228136fa945dfaa
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 30 13:47:13 2015 -0500

    destroy the network sockets in the same process that created them.

commit af781c9a06f89b77285753a62c77bae7d146c52e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 16:20:21 2015 -0500

    check for epoll init failure

commit 42053b9d43668d5007c4612f87986b85289fa549
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 16:19:55 2015 -0500

    initialize the listhead on new objects

commit 20a4f8674e665a21c9f24db9eaffd0f65b281146
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 15:38:29 2015 -0500

    convert socketfd code to object cache

commit e601a292ef83f1623e908a3d3e885b7634d9839d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 15:00:45 2015 -0500

    convert inotifyfd to use the object cache

commit f1b7d5f8dd59d19c62df45a8d64b03bfef218c65
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:45:50 2015 -0500

    convert drmfd to use the object cache

commit 1289f23587a8b6aa19c97d6e4e6e3bc96cf8f966
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:33:24 2015 -0500

    convert memfd code over to use object cache

commit e39d753c54bd7c31e281794bd9238b4ef73b23ce
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:27:40 2015 -0500

    convert testfilefd over to use the object cache

commit 59b65a072b8a5a27a010f12a202de75bf0a3d151
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:23:58 2015 -0500

    convert the timerfd code to use the object cache

commit d790247209c8562eb356a5a0ac4596dc2bc82297
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:17:30 2015 -0500

    int is big enough for eventfd flags

commit dbb435e2397d2e1f4da9b4412aced10592c68aba
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:16:20 2015 -0500

    convert eventfd code to use the object cache

commit f9dfaaed5e2c38c9d24e7dec1c8c49f3cc1cca66
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:08:46 2015 -0500

    convert epoll fd code over to use the object cache

commit 885c3819c10f73cf1197c38c392fb5612be5083b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:06:28 2015 -0500

    convert the perf fd code over to use the object cache

commit 448bbe9afdc4825537410764e4391739f58458e8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 14:01:11 2015 -0500

    add an alloc_object helper

commit 8d482379810a25bb5c6eddcf47c71e15a8b185d3
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 13:58:50 2015 -0500

    convert the file fd code over to use the object cache

commit 79f79013b97bf3c83212c4d547859b251c3c72ca
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 13:49:56 2015 -0500

    convert the pipe fd code over to use the object cache

commit 519d94021322535184812de3c5f4d97650eac74b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 13:35:06 2015 -0500

    move the object initialization up a level, out of the mm code.

commit 1049a753d77d619458ba0c842952c6017961c15e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 13:26:15 2015 -0500

    use a macro to count errno list members

commit 04d8fc2a7195783a8d4922689c3f2d4bbf53e0a1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 13:23:47 2015 -0500

    change syscall ->errnos.values to a pointer
    
    allowing deduping, as we did for ->arglist.values

commit 5ba1366ae69331dbe419d0326634fa8d19e53229
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 25 12:12:05 2015 -0500

    remove find_child_logfile_handle
    
    Simplify find_logfile_handle greatly.

commit f05d1e05cf94a6fa7075517d706492bf4e7a4b0a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 24 16:10:36 2015 -0500

    use a macro to count arglist members
    
    bonus bug fix: the count for fcntl flags was wrong.

commit 339ba423cf6eaf077e6488f438656ea51e681702
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 24 14:55:24 2015 -0500

    change syscall ->arglist.values to a pointer
    
    Thus allowing for some deduping where some syscalls share common flags
    (open, recv, send, etc..)

commit 5449eaa2daeb28e92a0a0eb7b41cf94b5d42c9f8
Author: Kirill A. Shutemov <kirill.shutemov@linux.intel.com>
Date:   Wed Nov 18 15:58:04 2015 +0200

    Free correct argument in post_ppoll()
    
    sanitise_ppoll() allocates first and third arguments and we need to free
    them in post_ppoll(), not first and fourth.
    
    Signed-off-by: Kirill A. Shutemov <kirill.shutemov@linux.intel.com>

commit ef72bed6ec9e54a23f5bba6d9186337a53b9ebf7
Author: Kirill A. Shutemov <kirill@shutemov.name>
Date:   Wed Nov 18 14:49:30 2015 +0200

    Fix "O_CREAT/O_TMPFILE without mode" error in open_file()
    
     > *** invalid open call: O_CREAT or O_TMPFILE without mode ***:
     > ./trinity terminated
    
    There's one more source of such crashes: open_file() in fds/files.c

commit 715074714443946109710f32ed1fbc5325ba2d82
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 10 12:14:51 2015 -0500

    NETLINK_SOCK_DIAG uses the type field for its own purposes.

commit 510d0acfef9b593e8cfdb612fc9789b577f2d583
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 10 00:08:08 2015 -0500

    update s390 syscalls

commit 234fa7023ca9227c976ea14f0fa13ed16f926712
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 10 00:05:23 2015 -0500

    add kcmp to ia64

commit 98db42321b97052cc0b0732b52cf630a63f192f9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 10 00:04:20 2015 -0500

    update arm syscalls

commit 4581dbb61a3fc25b6d263bd88a8546db8ddc8256
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:56:12 2015 -0500

    move get_random_fd proto to fd.h

commit 763f4afb19019228aa8e86949cb860ec0bb75831
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:55:55 2015 -0500

    bump gcc version check

commit 83c4bebbc5b2e0748f36cfa349e4ceaf9612a921
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:55:31 2015 -0500

    and another gcc false positive

commit a5492669da5e8af4c0c4be05424163979a2f1ee1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:54:25 2015 -0500

    silence another annoying gcc false positive

commit c45c1c8b0bbf1f05e5c4897f62776627e9f7ed38
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:51:02 2015 -0500

    splice can work on fd's other than pipes now

commit d0974556841a520bec96d3c51e4077e0dd6e110e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 21:50:54 2015 -0500

    for syscalls with >1 ARG_FD, don't always reuse the 1st ARG_FD

commit 9b91acc2c529dda96856a905b2ae0aa8c27ece82
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 16:13:23 2015 -0500

    add sys_mlock2

commit f355557f22f42292418167af65edf9d88e4d35b7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 16:09:53 2015 -0500

    add sys_membarrier

commit b26a1b17955f2c1b09b520e295b285a0deb31441
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Nov 9 16:01:51 2015 -0500

    ia64: Add userfaultfd

commit 4b1df1bd5b346b2e09305e06a02805bc5f2cb969
Author: Diogo Leal <me@diogoleal.com>
Date:   Thu Nov 5 14:58:17 2015 -0500

    Add first pass at man page based on README

commit 917b0ce8d1e30e2b8d6f7dd2c16c98e034705a7b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 4 19:26:20 2015 -0500

    Wire up phonet_rand_socket

commit ec5a3764c516e7e34ff8d7bf1c2c2b2d4866d4bb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Nov 4 19:20:43 2015 -0500

    move version back to devel

commit a0fa61798f5266cfbcb0750307d8596fb7ecb742
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 3 12:22:04 2015 -0500

    remove debug print

commit 4295cf7ba277850458f65e147c0e84e5a55ade0e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:47:39 2015 -0400

    use container_of to map from map back to object

commit 9ac02b8df59d8fd10116b0b53c754583b3011ce4
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:43:00 2015 -0400

    add destructor for maps

commit adb585a561ae9e3fcf9a5d6c4d953a1cb864fdce
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:42:50 2015 -0400

    fix up proto for destructors

commit 86f659b5613e99ad287011997e7d99dd946ecf33
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:27:54 2015 -0400

    do first alloc at first add_object instead of in init

commit fc2b0a7208a39dd743a6dd7aef7720073eb72674
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:26:59 2015 -0400

    make getmap get the map from the obj

commit 55e8ddaa58843458368285c55d141853ddd47b6e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 10:26:42 2015 -0400

    destroy the obj, not the map

commit 9aecb641e8c73ffd07275d8a09398dd51dfa6920
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 08:17:43 2015 -0400

    get map struct from the object

commit 07d9e458b560f1c6ed3a32da3c90cdb0df96c8e1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 08:16:57 2015 -0400

    remove linked list from mapping struct

commit 0a50b350b6748746abd0c4eb0d754c66849385d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 07:28:57 2015 -0400

    put the listhead directly in the object

commit e84b5eb791f251fdd73afb558bf4b6c07c358641
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 07:28:07 2015 -0400

    use the map struct in the object when dumping the list.

commit 84968d3ee4877f8bff67f8981ad6d07665e4c729
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 28 01:55:06 2015 -0400

    convert global mmaps list to use the global object cache

commit e43dab6700f9410508f58298e12f98d43552c60e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Oct 28 00:55:12 2015 -0400

    move mapping struct into a union in the object structs

commit 32d18289f2b34dd2384aa5a6688e7afe413b7de9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 23:19:10 2015 -0400

    move the object destructor to the objhead
    
    rather that duplicate it once for every object.

commit d066f6579e39e282437dc5423ea3d14ad4ed2175
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 23:17:59 2015 -0400

    convert the per-child mmaps list to the object cache

commit 1d215167da8913f20466bdcfd7f6bffdaf4cc117
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 23:04:07 2015 -0400

    remove unnecessary dereferencable field.

commit 1c772ad87ed1ea6c694cb377363d50e162e8de82
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 22:26:01 2015 -0400

    add new objects to the tail of lists.

commit 1bd0cca9e60f680fa99a35a60f439f9e1ae3d63b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 21:32:10 2015 -0400

    introduce a function to pick a random object

commit 7d9f5fe38c7e23316acca81d39e2b691b5509d9d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 21:22:07 2015 -0400

    object list initialization

commit 3482d1f68f424f4365f65894af140853ab648fbf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 21:15:40 2015 -0400

    move the object type out of the object struct

commit 0e26f6bcbcf8891e7876699d271d3c236e378ab8
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 21:00:31 2015 -0400

    switch to just a single add_object function

commit f4de988b35073d1abe41b29eab84a1c68943c323
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 20:53:53 2015 -0400

    maintain a count of objects in each object list

commit 97f4e4ec06ecdac7c8a07df66b3f88bcdaf5c36d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 27 20:26:00 2015 -0400

    sketch out the basics for a generic object cache
    
    right now this does nothing.

commit 24b93efdf1ff4fc01d4eb6b3296325afe2550d00
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Nov 3 12:05:50 2015 -0500

    1.6 release

commit 40b872b7df17d1adda6114320908a73675d84334
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Oct 29 07:15:09 2015 -0400

    add a --dry-run argument to disable the 'do the syscall' path.

commit 53dd214b1f46309fab93a117c992c079d18c0a45
Author: Praveen K. Pandey <praveen@linux.vnet.ibm.com>
Date:   Thu Oct 29 14:26:13 2015 +0530

    remove pause param as it doesn't add any value any more
    
    Signed-off-by: Praveen K. Pandey <praveen@linux.vnet.ibm.com>

commit 88e8495155af7f9f3665a17fb48e7df810b651fd
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Oct 26 22:32:18 2015 -0400

    move check_if_fd proto to fd.h
    
    Removes the need for trinity.h (which gets included everywhere)
    to need syscall.h

commit d972b6279ecdcecab5bc3eea53333dac9b94fa9b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Oct 20 16:48:11 2015 -0400

    fill out destringid flags for request_key

commit 1d2df023acba43ed5b05da71b89e65dd48be9eeb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Sep 5 21:08:05 2015 -0400

    beginnings of userfaultfd

commit 83d080dba735592ad1d19ef13aa6ab0df1a88734
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Sat Sep 5 20:58:29 2015 -0400

    Add PR_CAP_AMBIENT

commit db7ee382816d578367843b4d07ff967dee49837b
Author: Alexander Potapenko <glider@google.com>
Date:   Fri Sep 4 17:25:26 2015 +0200

    Add /dev/kmem to the list of dangerous devices that Trinity should not access.
    
    Writing to it may cause kernel memory corruption.

commit 45e3e2f3885c892c2b4b80c701ea987ac6222757
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Sep 4 00:35:44 2015 -0400

    Add NETLINK_CAP_ACK

commit 7855d8ba2141d6e906cb86a5ced55e48fb9cf358
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Sep 2 00:08:22 2015 -0400

    update 32-bit x86 syscall list
    
    socketcall got demuxed.

commit 8841696832414bd62c8437588cb93744679ad3be
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Sep 1 01:11:44 2015 -0400

    update s390 syscall lists to enable NUMA syscalls.

commit 8f12a40b81662487fee49d33bcac16db8e2b2e6e
Author: Vinson Lee <vlee@twitter.com>
Date:   Mon Aug 31 16:40:51 2015 -0700

    socket: Fix missing-field-initializers build error.
    
    This patch fixes this build error.
    
      CC    syscalls/socket.o
    syscalls/socket.c:48:2: error: missing initializer for field ‘func’ of ‘const struct socket_ptr’ [-Werror=missing-field-initializers]
      [AF_ECONET] = {  }, // DEAD
      ^
    syscalls/socket.c:22:9: note: ‘func’ declared here
      void (*func)(struct socket_triplet *st);
             ^
    
    Signed-off-by: Vinson Lee <vlee@twitter.com>

commit e530c3fc02244c4d10612f7c12f1fdf0db01f77e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 31 17:52:51 2015 -0400

    scope reduction

commit 75e03309ea79f447b04c3a8c05de18a605c87aa2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 31 17:51:41 2015 -0400

    scope reduction

commit a71d7cd049bfe70f8a3123f8deeb83d52241f086
Author: Hangbin Liu <liuhangbin@gmail.com>
Date:   Mon Aug 31 17:18:37 2015 +0800

    fix build prctl.h header on RHEL6.7
    
    latest RHEL6.7 kernel headers only defined PR_SET/GET_NO_NEW_PRIVS, which
    lead to 'PR_GET_TID_ADDRESS' undeclared build error.
    
    Signed-off-by: Hangbin Liu <liuhangbin@gmail.com>

commit 74b9f03a1eea19572150bec780e55a9dbf59e70c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 20:02:54 2015 -0400

    rand: add ':', ',' and '.' as possible separators

commit 9c674b08c58afb47ef009723e81266bdeea7a1ff
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 20:01:55 2015 -0400

    compile-time calculate the separator array size

commit f54f3b9be623293e2640c87b026d26e506af926a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:55:32 2015 -0400

    random: remove unnecessary local var

commit 0f88dffcd81247e13a52d8183464b68b87122604
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:53:43 2015 -0400

    watchdog: wait longer at startup
    
    if we're starting a *lot* of processes, it can take longer than the
    1000 retries in this loop when we only wait a microsecond each time.

commit ab9a8dec47ee51d07e9dc47fb314770b761f9fb2
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:52:52 2015 -0400

    perf_event_open: use RAND_BOOL()

commit e8af8f5883ef313272d986905b8c789f21de35ca
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:52:21 2015 -0400

    munmap: use ONE_IN() and RAND_BOOL to make clearer what's intended

commit 7f68f0378bb115fee24c4e74de15529f400b4adf
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:51:57 2015 -0400

    move_pages: use RAND_BOOL()

commit 95f25fd7105ec5644f5d16bb3e5f9272f9c68629
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:51:04 2015 -0400

    remove unneeded includes

commit 606e7f79ceb1f32bf0515e421ed27d1916206c99
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:50:35 2015 -0400

    decnet: use RAND_BOOL()

commit afeb2ca1856ac9f3e0e02e5ce0393cb584a73358
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:50:16 2015 -0400

    if an fd provider fails, just skip over it.

commit 5259f945d76820ef553b99be8515978cff1a3229
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:49:31 2015 -0400

    TODO: check loadavg before sanity checks

commit 3933afb88099d022b40d948f285d19f70beceb1d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:49:01 2015 -0400

    decide at random at startup whether or we bind processes to CPUs

commit 7a3796c3e3d20d97e50d6e18ef00e39a06ea0fb6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Aug 3 23:19:39 2015 -0400

    re-add accidentally dropped netlink setsockopt's

commit 0bceaf65d0bfabe813a1ec86c986c1b35a511085
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 19:03:53 2015 -0400

    select: fix shifting out of range of datatype in FD_SET

commit 0bc95033e002a643b3193592c4c29b65c0569ede
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 18:56:11 2015 -0400

    if we've filled the socket array, don't try to bind another fd.

commit 4ae63b03513fd224e070ba57a16578546f7b120f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 18:53:36 2015 -0400

    fix out of bounds read in socket creation
    
    The actual bug here was the incrementing of nr_sockets in add_socket.
    When we get to the setsockopt, we've advanced past the end of the array.
    
    Also eliminate the nr_to_create var which pointlessly duplicates nr_sockets
    and gets out of sync.

commit a4bebb33c169c6780a2da3cb0c41ab1b89d6f48b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:25:00 2015 -0400

    mask out a random number of bits from the new seed.
    
    The new seeds are overwhelmingly large 32 bit numbers.
    This at least gives some coverage to the lower end.

commit 4f55491789f411546d2e4b5e9790fdd57841bf8d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:23:12 2015 -0400

    open urandom just once on startup
    
    We can fail to open it from the child later otherwise, and end up
    falling back, and in some cases, seeding with '0' repeatedly. Oops.

commit 08bcce0b86046dc150d3100a77152dff7d19083c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:13:27 2015 -0400

    some glibc's check the mode arg for O_CREAT & O_TMPFILE
    
    Make sure we fill it in, or we get killed.

commit 0f7305ea1ae4d630d14e7f6efc5cc93bfa89328b
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:13:02 2015 -0400

    fix the "check for <8gb" test

commit f98a00ef0d810ef0d3ff11d3b2695e456b807d06
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:12:14 2015 -0400

    SIGABRT/SIGSEGV in main should be set to default

commit 75bcdf9523b540058b7163955718fa5bc9b40c62
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:11:41 2015 -0400

    make page_rand be a length we can return

commit b440b5d75a06552865ef1b05b3a1dcc8fde5202d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:10:57 2015 -0400

    add some more cases to the 'create a struct look-alike page' function

commit da08be88e75bfbd20efbc275782d2140d6b0171a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:10:24 2015 -0400

    socket: use struct initializers to save a loop

commit 711ccbf8e5040063fbff78b571324b86876aeeb6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:09:44 2015 -0400

    setsockopt: use struct initializers to save a loop

commit b9b5765972c9064ef0c6eb8e08bab99d1dca9762
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:09:09 2015 -0400

    if main crashes before watchdog has begun, we need to check for it

commit 112b58e51a4319b1c6e0f6f906b0e2440b9caba1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:08:55 2015 -0400

    check for memalign failure

commit 4816e49eaec16d4354756dac77cc9c7d41e0dbb7
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 23 00:07:35 2015 -0400

    fix get_interesting_32bit_value shifting
    
    This is supposed to shift 0xff through 7 positions, not 31.

commit 11ccbad89e571a14f863b9f2c2b336b6644ac8d1
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 22 23:59:55 2015 -0400

    flesh out AF_ALG some more

commit fc71ae9107b4e7a4e610c703b5bf4fc2b3f93523
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 22 23:58:10 2015 -0400

    fix undefined behaviour in RAND_32
    
    We were shifting past the width of the type.
    
    Make rand_32 simpler.
    If your rand() has some problem with the LSB, fix your rand.

commit 14bf4bc56fcad52ca9503ae626a3eeeb08774d48
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 22 23:57:16 2015 -0400

    only use fallback argument if argtype isn't defined

commit 7b6e6c5fe7337d10fc434d9f178c9ca3f7b07d6c
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 22 23:52:04 2015 -0400

    don't loop over socket types, pick them randomly.

commit ca0de735e31ff6700d73a1e48dce79689948d6eb
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 22 23:38:50 2015 -0400

    fix gcc5 warning about trashed var

commit 95ec5ea3d0e71d031fc7352b49914a5ea384f782
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Tue Aug 4 19:47:20 2015 -0400

    re-sort the getopt param string.

commit 1b9845ace0de65480f4e0229950af53658c84f0e
Author: Praveen Pandey <praveen@linux.vnet.ibm.com>
Date:   Mon Jul 20 14:29:16 2015 +0530

    fix trinity compilation (make) error in ppcle system
    
    Solution include termios.h in ioctls/vt.c
    
    Signed-off-by: Praveen Pandey <praveen@linux.vnet.ibm.com>

commit 2a37e77e0276d8a9b7c420e1332d39dbf0f31b44
Author: Vinson Lee <vlee@twitter.com>
Date:   Fri Jul 17 11:15:41 2015 -0700

    Fix build with kernel 3.4 headers.
    
    PR_SET_CHILD_SUBREAPER was added in kernel 3.4 but PR_SET_NO_NEW_PRIVS,
    PR_GET_NO_NEW_PRIVS, and PR_GET_TID_ADDRESS were added in kernel 3.5.
    
      CC    syscalls/prctl.o
    syscalls/prctl.c:33: error: ‘PR_SET_NO_NEW_PRIVS’ undeclared here (not in a function)
    syscalls/prctl.c:34: error: ‘PR_GET_NO_NEW_PRIVS’ undeclared here (not in a function)
    syscalls/prctl.c:34: error: ‘PR_GET_TID_ADDRESS’ undeclared here (not in a function)
    
    Signed-off-by: Vinson Lee <vlee@twitter.com>

commit d49c84ee568ee3900370d090cd90d88a0e61d1f2
Author: Vinson Lee <vlee@twitter.com>
Date:   Tue Jul 14 11:25:55 2015 -0700

    Add POLL_BUSY_LOOP symbol for older distros.
    
    POLL_BUSY_LOOP is not available until Linux 3.11.
    
    Signed-off-by: Vinson Lee <vlee@twitter.com>

commit 1973119fc24bed6f28569b5295a4db5efd02cb84
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 8 19:22:34 2015 -0400

    resync aarch64 syscalls

commit 80c6bc84cde79831d92424c72ae975b7edc2dbf2
Author: Vinson Lee <vlee@twitter.com>
Date:   Tue Jul 7 14:46:06 2015 -0700

    Add POLLFREE symbol for older distros.
    
    Signed-off-by: Vinson Lee <vlee@twitter.com>

commit 23982097aebc3940987f7c267ee128bfb6af6772
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jul 6 18:39:01 2015 -0400

    clear optname on each do_setsockopt invocation

commit 8816a902baf859cb0844b4802c0cfadb129a063d
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jul 6 18:38:42 2015 -0400

    clear optval after freeing it

commit b3838221560d58fb3a69f106e539cd5a8e72994a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Mon Jul 6 18:38:13 2015 -0400

    Fix up a bunch of incorrect RAND_ARRAY uses

commit bcd0e418950e1ff8ab245966bae281ff5148222e
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jul 3 12:47:40 2015 -0400

    fix up corner cases and unify table counting.

commit 0e4851dce759c737da02ad59b8dd17dbe0009a4a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jul 3 00:08:04 2015 -0400

    don't output "64bit: 0 disabled" when using -a64

commit 718af5d83525a8d598962cbf91f25312fc3c152f
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Fri Jul 3 00:02:21 2015 -0400

    rename enablednr -> enabledstr.
    
    Also reduce scoping

commit b8cafcb52d59490ec74e31f5406b8127605d8e77
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Thu Jul 2 20:58:48 2015 -0400

    pretty print the 'all disabled' case for 32bit.

commit dfd9160e95fc364960974697f479dceb25f1bab9
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 1 18:50:59 2015 -0400

    remove remaining duplicate code from poll/ppoll unification

commit 79d555c8a27beb8af4876a7269a1edffaa39b6a6
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 1 18:50:10 2015 -0400

    replace open-coded freeptr

commit d92549fd9b40d9cc6cc805f7febd31536bfb0b1a
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 1 18:49:34 2015 -0400

    make ppoll impossible to fail allocations

commit e332665dd21584c51c46abd4d3bdb761c2397e23
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 1 18:48:24 2015 -0400

    merge poll & ppoll

commit 568ce76bec014a4cbf76d7c66c83626caacf0a28
Author: Dave Jones <davej@codemonkey.org.uk>
Date:   Wed Jul 1 18:29:04 2015 -0400

    slightly improved sanitisation of ppoll

commit 9e5dd744d12b50253b435ea1fa425a68c6f72351
Author: Jiri Slaby <jslaby@suse.com>
Date:   Tue Jun 30 12:01:01 2015 +0200

